#include<bits/stdc++.h>
#define endl '\n'
#define MAX 300024
using namespace std;

int n, q;
struct vr
{
    vector<int> kids;
    int parent;
    int inf=0; /// count of infected below
    bool state=0; /// 1 - infected
};

vr tree[MAX];

void infect(int x)
{
    tree[x].state=1;
    tree[x].inf++;

    while(x!=1)
    {
        x=tree[x].parent;
        tree[x].inf++;
    }
}

void heal(int x)
{
    tree[x].state=0;
    tree[x].inf--;

    while(x!=1)
    {
        x=tree[x].parent;
        tree[x].inf--;
    }
}

void printTree()
{
    for(int i=1; i<=n; ++i)
    {
        cout<<i<<": "<<tree[i].state<<" "<<tree[i].inf<<endl;
        //cout<<endl;
    }
    cout<<"----------------"<<endl;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin>>n;
    int p;
    for(int i=1; i<n; ++i)
    {
        int u=i+1;
        cin>>p;
        tree[u].parent=p;
        tree[p].kids.push_back(u);
    }

    /* for(int i=1; i<=n; ++i)
    {
        cout<<i<<" "<<tree[i].parent<<endl;
        for(int j=0; j<tree[i].kids.size(); ++j)
        {
            cout<<tree[i].kids[j]<<" ";
        }
        cout<<endl<<endl;
    } */

    ///////////////////////////////

    cin>>q;

   // printTree();

    for(int i=0; i<q; ++i)
    {
        short qtype;
        int x;

        cin>>qtype>>x;

        if(qtype==1)
        {
            infect(x);
        }
        else if(qtype==2)
        {
            if(tree[x].state==1)
            {
                heal(x);
                for(int u=0; u<tree[x].kids.size(); ++u)
                {
                    int kid=tree[x].kids[u];
                    if(tree[kid].state==0) infect(kid);
                }
            }

            int prev=x;
            while(x!=1)
            {
                x=tree[x].parent;
                if(tree[x].state==0) continue;
                heal(x);

                for(int u=0; u<tree[x].kids.size(); ++u)
                {
                    int kid=tree[x].kids[u];
                    if(kid==prev) continue;
                    if(tree[kid].state==0) infect(kid);
                }
                prev=x;
            }
        }
        else if(qtype==3)
        {
            if(tree[x].state==1) heal(x);
            for(int u=0; u<tree[x].kids.size(); ++u)
            {
                int kid=tree[x].kids[u];
                if(tree[kid].state==1) heal(kid);
            }
        }
        else // 4
        {
            cout<<tree[x].inf<<endl;
        }

        //printTree();
    }

    return 0;
}

/*

5
1 1 3 3
8
1 3
2 5
4 1
1 1
2 1
4 3
3 1
4 3

11
1 1 3 3 5 5 5 7 8 8
8
1 5
1 9
1 3
4 1
2 7
4 1
3 3
4 3

*/
