#include <cstring>
#include <cstdint>
#include <unordered_map>
//#include <iostream>

#include "Sgame.h"

using namespace std;

#define ARR_SIZE(x) (sizeof(x)/sizeof(x[0]))

#define NMAX 100002

static size_t wsize;
static char *w;

#define K1      19
#define MOD1    1000000007
static uint32_t kpow1[NMAX];

void init_kpow()
{
    kpow1[0]=1;
    for(uint32_t i=1; i<ARR_SIZE(kpow1); i++)
    {
        uint64_t tmp=kpow1[i-1];
        tmp*=K1;
        tmp%=MOD1;
        kpow1[i]=tmp;
    }
}

static uint32_t w_hash_pref1[NMAX+1];

void w_hash_pref()
{
    w_hash_pref1[0]=0;
    for(uint32_t i=0; i<wsize; i++)
    {
        uint64_t tmp=w[i];
        tmp*=kpow1[i];
        tmp%=MOD1;
        tmp+=w_hash_pref1[i];
        if(tmp>=MOD1)
            tmp-=MOD1;

        w_hash_pref1[i+1]=tmp;
    }
}

void start (char w[])
{
    ::w=w;
    wsize=strlen(w);
    init_kpow();
    w_hash_pref();
    //cout<<"Wsize: "<<wsize<<endl;
}

static unordered_map <uint32_t, uint32_t> hm;

uint32_t solve (int m)
{
    hm.clear();

    for(uint32_t i=0; i+m<=wsize; i++)
    {
        //cout<<"Solve i:"<<i<<" ";

        int64_t diff1=w_hash_pref1[i+m];
        diff1-=(int64_t)w_hash_pref1[i];
        if(diff1<0)
            diff1+=MOD1;

        //cout<<"diff1:"<<diff1<<" ";

        uint64_t hash1=diff1;
        hash1*=(uint64_t)kpow1[wsize-i];
        hash1%=(uint64_t)MOD1;

        hm[hash1]++;

        //cout<<"hash1:"<<hash1<<endl;
    }

    uint32_t res=0;

    for(auto &x:hm)
    {
        if(res<x.second)
            res=x.second;
    }

    return res;
}

int round (int m, int k)
{
    if(k!=(int)wsize)
        return 0;

    return (int)solve(m);
}
