#include <cstring>
#include <cstdint>
#include <unordered_map>
#include <map>
//#include <iostream>

#include "Sgame.h"

using namespace std;

#define ARR_SIZE(x) (sizeof(x)/sizeof(x[0]))

#define NMAX 100002

static size_t wsize;
static char *w;

#define K1      13
#define MOD1    1000000007
static uint32_t kpow1[NMAX];

#define K2      27
#define MOD2    1000000007
static uint32_t kpow2[NMAX];

void init_kpow()
{
    //-----------------------------------------

    kpow1[0]=1;
    for(uint32_t i=1; i<ARR_SIZE(kpow1); i++)
    {
        uint64_t tmp=kpow1[i-1];
        tmp*=K1;
        tmp%=MOD1;
        kpow1[i]=tmp;
    }

    //-----------------------------------------

    kpow2[0]=1;
    for(uint32_t i=1; i<ARR_SIZE(kpow2); i++)
    {
        uint64_t tmp=kpow2[i-1];
        tmp*=K2;
        tmp%=MOD2;
        kpow2[i]=tmp;
    }

    //-----------------------------------------
}

static uint32_t w_hash_pref1[NMAX+1];

static uint32_t w_hash_pref2[NMAX+1];

void w_hash_pref()
{
    //-----------------------------
    w_hash_pref1[0]=0;
    for(uint32_t i=0; i<wsize; i++)
    {
        uint64_t tmp=w[i];
        tmp*=kpow1[i];
        tmp%=MOD1;
        tmp+=w_hash_pref1[i];
        if(tmp>=MOD1)
            tmp-=MOD1;

        w_hash_pref1[i+1]=tmp;
    }
    //-----------------------------
    w_hash_pref2[0]=0;
    for(uint32_t i=0; i<wsize; i++)
    {
        uint64_t tmp=w[i];
        tmp*=kpow2[i];
        tmp%=MOD2;
        tmp+=w_hash_pref2[i];
        if(tmp>=MOD2)
            tmp-=MOD2;

        w_hash_pref2[i+1]=tmp;
    }
    //-----------------------------
}

void start (char w[])
{
    ::w=w;
    wsize=strlen(w);
    init_kpow();
    w_hash_pref();
    //cout<<"Wsize: "<<wsize<<endl;
}

static map <pair<uint32_t, uint32_t>, uint32_t> hm;

uint32_t solve (int m)
{
    hm.clear();

    for(uint32_t i=0; i+m<=wsize; i++)
    {
        //-------------------------------------

        //cout<<"Solve i:"<<i<<" ";

        int64_t diff1=w_hash_pref1[i+m];
        diff1-=(int64_t)w_hash_pref1[i];
        if(diff1<0)
            diff1+=MOD1;

        //cout<<"diff1:"<<diff1<<" ";

        uint64_t hash1=diff1;
        hash1*=(uint64_t)kpow1[wsize-i];
        hash1%=(uint64_t)MOD1;

        //cout<<"hash1:"<<hash1<<endl;

        //-------------------------------------

        //cout<<"Solve i:"<<i<<" ";

        int64_t diff2=w_hash_pref2[i+m];
        diff2-=(int64_t)w_hash_pref2[i];
        if(diff2<0)
            diff2+=MOD2;

        //cout<<"diff2:"<<diff2<<" ";

        uint64_t hash2=diff2;
        hash2*=(uint64_t)kpow2[wsize-i];
        hash2%=(uint64_t)MOD2;

        //cout<<"hash2:"<<hash2<<endl;

        //-------------------------------------

        hm[make_pair(hash1, hash2)]++;
    }

    uint32_t res=0;

    for(auto &x:hm)
    {
        if(res<x.second)
            res=x.second;
    }

    return res;
}

int round (int m, int k)
{
    if(k!=(int)wsize)
        return 0;

    return (int)solve(m);
}
