#include <iostream>
#include <algorithm>
#include <vector>
#include <cstring>

using namespace std;

#define NMAX 20

uint32_t colorn[NMAX+8];

struct edge
{
    uint32_t u, v;
};

uint32_t n;
vector<edge> e;

void init()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    uint32_t m;
    cin>>n>>m;
    e.resize(m);
    for(uint32_t i=0; i<m; i++)
    {
        cin>>e[i].u>>e[i].v;
        e[i].u--;
        e[i].v--;
    }

    memset(colorn, -1, sizeof(colorn));
}

bool check()
{
    for(const edge &x:e)
    {
        if(colorn[x.u]!=UINT32_MAX && colorn[x.u]==colorn[x.v])
        {
            return false;
        }
    }

    return true;
}

bool found_sol=false;
uint32_t maxcol=1;

void rec(uint32_t pos=0)
{
    if(pos==n)
    {
        found_sol=true;
        return;
    }


    for(uint32_t i=0; i<=maxcol; i++)
    {
        colorn[pos]=i;
        if(check()==false)
            continue;
        rec(pos+1);
        if(found_sol)
            return;
    }

    colorn[pos]=UINT32_MAX;
}

void show_sol()
{
    cout<<maxcol+1<<endl;
    for(uint32_t i=0; i<n; i++)
        cout<<colorn[i]+1<<' ';
    cout<<endl;
}

int main()
{
    init();
    while(1)
    {
        rec();
        if(found_sol)
        {
            show_sol();
            return 0;
        }
    }

    return 0;
}
