#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>

using namespace std;

#ifdef EVAL
#define endl '\n'
#endif // EVAL


vector<uint32_t> pred;

vector<vector<uint32_t>> ss;

vector<bool> is_infested;

void query1 (uint32_t x)
{
    is_infested[x]=true;
}

void query2 (uint32_t x)
{
    vector<bool> is_immune(is_infested.size());

    while(1)
    {
        is_immune[x]=1;
        if(is_infested[x])
        {
            for(auto ch:ss[x])
            {
                if(is_immune[ch]==0)
                    is_infested[ch]=1;
            }

            is_infested[x]=0;
        }

        if(x==0)
            return;

        x=pred[x];
    }
}

void query3 (uint32_t x)
{
    for(auto ch:ss[x])
    {
        is_infested[ch]=0;
    }

    is_infested[x]=0;
}

uint32_t query4 (uint32_t x)
{
    uint32_t res=is_infested[x];
    for(auto ch:ss[x])
    {
        res+=query4(ch);
    }
    return res;
}

void init()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    uint32_t n;
    cin>>n;
    pred.resize(n);
    ss.resize(n);
    is_infested.resize(n);

    pred[0]=0;
    for(uint32_t i=1; i<n; i++)
    {
        uint32_t tmp;
        cin>>tmp;
        tmp--;
        pred[i]=tmp;
        ss[tmp].push_back(i);
    }
}

int main()
{

    init();
    uint32_t qn, q, x;
    cin>>qn;
    for(uint32_t i=0; i<qn; i++)
    {
        cin>>q>>x;
        x--;
        switch(q)
        {
        case 1:
            query1(x);
            break;

        case 2:
            query2(x);
            break;

        case 3:
            query3(x);
            break;

        case 4:
            cout<<query4(x)<<endl;
            break;
        }

        //for(auto x:is_infested)
        //    cout<<x<<' ';
        //cout<<endl;
    }

    return 0;
}
