#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#ifdef EVAL
#define endl '\n'
#endif // EVAL


vector<uint32_t> pred;

vector<vector<uint32_t>> ss;

vector <pair<uint32_t, uint32_t>> dir_ch_node_seq_range, all_ch_node_seq_range;

vector <uint32_t> node_seq;
vector <uint32_t> map_node_seq;

void init_node_seq (uint32_t x=0)
{
    uint32_t bp=node_seq.size();
    for(auto ch:ss[x])
    {
        node_seq.push_back(ch);
    }
    uint32_t ep=node_seq.size();

    dir_ch_node_seq_range[x]=make_pair(bp, ep);

    for(uint32_t i=bp; i<ep; i++)
        init_node_seq(node_seq[i]);

    all_ch_node_seq_range[x]=make_pair(bp, node_seq.size());
}

void init_map_node_seq ()
{
    map_node_seq.resize(node_seq.size());
    for(uint32_t i=0; i<node_seq.size(); i++)
    {
        map_node_seq[node_seq[i]]=i;
    }
}

void init()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    uint32_t n;
    cin>>n;
    pred.resize(n);
    ss.resize(n);

    node_seq.reserve(n);
    node_seq.push_back(0);


    dir_ch_node_seq_range.resize(n);
    all_ch_node_seq_range.resize(n);

    pred[0]=0;
    for(uint32_t i=1; i<n; i++)
    {
        uint32_t tmp;
        cin>>tmp;
        tmp--;
        pred[i]=tmp;
        ss[tmp].push_back(i);
    }

    init_node_seq();

    /*
    cout<<"Node seq: ";
    for(auto x:node_seq)
        cout<<x<<' ';
    cout<<endl;

    init_map_node_seq();

    cout<<"Map node seq: ";
    for(auto x:map_node_seq)
        cout<<x<<' ';
    cout<<endl;

    cout<<"Dir node ch range:"<<endl;
    for(uint32_t i=0; i<dir_ch_node_seq_range.size(); i++)
    {
        cout<<i<<": "<<dir_ch_node_seq_range[i].first<<' '<<dir_ch_node_seq_range[i].second<<endl;
    }
    cout<<endl;

    cout<<"All node ch range:"<<endl;
    for(uint32_t i=0; i<all_ch_node_seq_range.size(); i++)
    {
        cout<<i<<": "<<all_ch_node_seq_range[i].first<<' '<<all_ch_node_seq_range[i].second<<endl;
    }
    cout<<endl;
    */
}

struct node_data
{
    uint32_t sum_z;
    uint32_t lazy;
};

vector <node_data> tree;



void tree_push_lazy (uint32_t inx, uint32_t l, uint32_t r)
{
    if(tree[inx].lazy==0)
        return;

    tree[inx].lazy=0;
    tree[inx].sum_z=0;

    if(l!=r)
    {
        tree[(inx<<1)  ].lazy=1;
        tree[(inx<<1)|1].lazy=1;
    }
}

uint32_t tree_get_mid(uint32_t l, uint32_t r)
{
    uint32_t res=((l+r)>>1);
    res++;
    return res;
}

void tree_update_single (uint32_t cur, uint32_t l, uint32_t r, uint32_t inx, uint32_t val)
{
    if(!(l<=inx && inx<=r))
        return;

    tree_push_lazy(cur, l, r);

    if(l==r)
        tree[cur].sum_z=val;

    else
    {
        uint32_t mid=tree_get_mid(l, r);
        tree_update_single((cur<<1)  , l, mid-1, inx, val);
        tree_update_single((cur<<1)|1, mid  , r, inx, val);
    }
}

uint32_t tree_query (uint32_t cur, uint32_t l, uint32_t r, uint32_t tl, uint32_t tr)
{
    if((tl<l&&tr<l) || (tl>r&&tr>r))
        return 0;

    tree_push_lazy(cur, l, r);

    if(tl<=l&&r<=tr)
        return tree[cur].sum_z;

    uint32_t res=0;

    uint32_t mid=tree_get_mid(l, r);

    res+=tree_query((cur<<1)  , l, mid-1, tl, tr);
    res+=tree_query((cur<<1)|1, mid  , r, tl, tr);

    return res;
}

void tree_update_range (uint32_t cur, uint32_t l, uint32_t r, uint32_t tl, uint32_t tr, uint32_t val)
{
    if((tl<l&&tr<l) || (tl>r&&tr>r))
        return;

    tree_push_lazy(cur, l, r);

    if(tl<=l&&r<=tr)
    {
        tree[cur].lazy=val;
        return;
    }

    uint32_t mid=tree_get_mid(l, r);

    tree_update_range((cur<<1)  , l, mid-1, tl, tr, val);
    tree_update_range((cur<<1)|1, mid  , r, tl, tr, val);
}

int main()
{
    init();

    return 0;
}
