#include<iostream>
#include<vector>
#include<queue>
#include<stack>
using namespace std;

const int maxn = 1001000;
int n, m;

vector<int> e[maxn];

int col[maxn];

bool poss[maxn][4];
bool in_q1[maxn];
bool in_q2[maxn];

int ans = 2;

int st1[maxn], st2[maxn];
int s1, s2;

int bfs2(int st)
{
    stack<int> q1, q2;
    q1.push(st);
    in_q1[st] = true;
    while(!q1.empty() || !q2.empty())
    {
        int curr;
        if(!q2.empty())
        {
            curr = q2.top();
            q2.pop();
        } else {
            curr = q1.top();
            q1.pop();
        }


        if(col[curr] != 0)  continue;
        //cout << "< " << curr + 1 << endl;

        for(int i = 1; i <= 3; i ++)
        {
            if(!poss[curr][i])
            {
                col[curr] = i;
                ans = max(ans, i);
                break;
            }
        }

        for(int i = 0; i < e[curr].size(); i ++)
        {
            int j = e[curr][i];
            if(col[j] == 0)
            {
                poss[j][col[curr]] = true;
                int cnt = poss[j][1] + poss[j][2] + poss[j][3];
                if(cnt == 2 && !in_q2[j])
                {
                    in_q2[j] = true;
                    q2.push(j);
                }
                if(cnt == 1 && !in_q1[j])
                {
                    in_q1[j] = true;
                    q1.push(j);
                }
            }
        }
    }
}


int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> m;
    int a, b;
    for(int i = 0; i < m; i ++)
    {
        cin >> a >> b;
        a--;b--;
        e[a].push_back(b);
        e[b].push_back(a);
    }
    for(int i = 0; i < n; i ++)
    {
        if(col[i] == 0)
        {
            bfs2(i);
        }
    }
    cout << ans << "\n";
    for(int i = 0; i < n; i ++)
    {
        cout << col[i] << " ";
    }
}
/**
6 5
1 2
2 3
1 4
3 4
6 5
*/
/**
3 3
1 2
2 3
1 3
*/
/**
6 7
1 2
2 3
3 4
4 5
5 6
6 1
2 5
*/
/**
5 7
1 2
2 3
3 4
4 5
5 1
2 5
3 5
*/
/**
5 7
1 2
1 5
4 5
1 3
1 4
2 3
3 4
*/
