#include<iostream>
#include<vector>
#include<queue>
#include<stack>
using namespace std;

const int maxn = 1001000;
int n, m;

vector<int> e[maxn];

int col[maxn];

bool poss[maxn][4];
bool in_q[maxn];

int ans;

int bfs2(int st)
{
    stack<int> q;
    q.push(st);
    col[st] = 1;
    in_q[st] = true;
    while(!q.empty())
    {
        int curr = q.top();
        q.pop();

        for(int i = 1; i <= 3; i ++)
        {
            if(!poss[curr][i])
            {
                col[curr] = i;
                ans = max(ans, i);
                break;
            }
        }
        if(col[curr] == 0)
        {
            col[curr] /= 0;
        }

        for(int i = 0; i < e[curr].size(); i ++)
        {
            int j = e[curr][i];
            if(col[j] == 0)
            {
                poss[j][col[curr]] = true;
                if(!in_q[j])
                {
                    q.push(j);
                    in_q[j] = true;
                }
            }
        }
    }
}


int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> m;
    for(int i = 0; i < m; i ++)
    {
        int a, b;
        cin >> a >> b;
        a--;b--;
        e[a].push_back(b);
        e[b].push_back(a);
    }
    for(int i = 0; i < n; i ++)
    {
        if(col[i] == 0)
        {
            bfs2(i);
        }
    }
    cout << ans << "\n";
    for(int i = 0; i < n; i ++)
    {
        cout << col[i] << " ";
    }
}
/**
6 5
1 2
2 3
1 4
3 4
6 5
*/
/**
3 3
1 2
2 3
1 3
*/
/**
5 6
2 4
1 2
2 3
3 4
4 5
5 1
*/
/**
5 7
1 2
2 3
3 4
4 5
5 1
2 5
3 5
*/
