#include <bits/stdc++.h>

using namespace std;

const int MAXN = 5e5 + 7;

int n, m, c[MAXN];
vector<int> adj[MAXN];
bool used[MAXN];

void color(int u){
	used[u] = true;
	map<int, bool> mp;
    for(int to: adj[u]){
		if(used[to]){
			mp[c[to]] = true;
		}
    }

    int pr = 0;
    for(auto it: mp){
        if(it.first > pr + 1){
            c[u] = pr + 1;
            break;
        }
        pr = it.first;
    }
    if(!c[u]){
		c[u] = pr + 1;
    }
    for(int to: adj[MAXN]){
		if(!used[to]){
			color(to);
		}
    }
}

void solve(){
	for(int i = 1; i <= n; ++i){
		if(!used[i]){
            color(i);
		}
    }

    int mx = 0;
    for(int i = 1; i <= n; ++i){
		mx = max(mx, c[i]);
    }

    if(mx == 1){
		return;
    }

    for(int state = 0; state < (1 << n); ++state){
        for(int i = 1; i <= n; ++i){
            if(state & (1 << (i - 1))){
				c[i] = 1;
            }
            else{
				c[i] = 2;
            }
        }

		bool ok = true;
        for(int i = 1; i <= n && ok; ++i){
			for(int to: adj[i]){
                if(c[i] == c[to]){
					ok = false;
					break;
                }
			}
        }
        if(ok){
			return;
        }
    }

    for(int i = 1; i <= n; ++i){
		used[i] = false;
    }

    for(int i = 1; i <= n; ++i){
		if(!used[i]){
            color(i);
		}
    }
}

void write(){
	int mx = 0;
    for(int i = 1; i <= n; ++i){
		mx = max(mx, c[i]);
    }

    while(mx > 3);

	cout << mx << "\n";
    for(int i = 1; i <= n; ++i){
		cout << c[i] << " ";
    }
    cout << "\n";
}

void read(){
	ios::sync_with_stdio(false);
	cin.tie(NULL);

	cin >> n >> m;
	for(int i = 0; i < m; ++i){
        int u, v;
        cin >> u >> v;

        adj[u].push_back(v);
        adj[v].push_back(u);
	}
}

int main(){
	read();
	solve();
	write();
}
/*
6 5
1 2
2 3
1 4
3 4
6 5
*/
