#include <bits/stdc++.h>

using namespace std;

const int MAXN = 3e5 + 7;

struct segment_tree{
    int arr[4 * MAXN];
    bool type;
    //type ? add : max

	segment_tree(bool type){
		this->type = type;
	}

    void update(int idx, int l, int r, int sl, int sr, int val){
        if(!arr[idx]){
			if(l != r){
                arr[2 * idx] = 0;
                arr[2 * idx + 1] = 0;
			}
        }
		if(l > sr || r < sl){
			return;
		}
		if(sl <= l && r <= sr){
            arr[idx] = val;
            return;
		}

		int mid = (l + r) >> 1;
		update(2 * idx, l, mid, sl, sr, val);
		update(2 * idx + 1, mid + 1, r, sl, sr, val);

		arr[idx] = arr[2 * idx] + arr[2 * idx + 1];
	}

	int query(int idx, int l, int r, int sl, int sr){
		if(!arr[idx]){
			if(l != r){
                arr[2 * idx] = 0;
                arr[2 * idx + 1] = 0;
			}
        }
		if(l > sr || r < sl){
			return 0;
		}
		if(sl <= l && r <= sr){
            return arr[idx];
		}

		int mid = (l + r) >> 1;
		int lvalue = query(2 * idx, l, mid, sl, sr);
		int rvalue = query(2 * idx + 1, mid + 1, r, sl, sr);

		return lvalue + rvalue;
	}
};

segment_tree st(1);

int n, q, par[MAXN];
vector<int> adj[MAXN];
pair<int, int> query[MAXN];
int l[MAXN], r[MAXN], timer, arr[MAXN];

void dfs(int u){
	l[u] = timer;
	arr[timer++] = u;
	for(int to: adj[u]){
        dfs(to);
	}
	r[u] = timer - 1;
}

void ultra(int u, int pr = -1){
	if(st.query(1, 0, n - 1, l[u], l[u])){
        for(int to: adj[u]){
			if(to == pr){
				continue;
			}
            st.update(1, 0, n - 1, l[to], l[to], 1);
        }
        st.update(1, 0, n - 1, l[u], l[u], 0);
	}
    if(u != 1){
		ultra(par[u], u);
    }
}

void solve(){
    dfs(1);

    for(int i = 0; i < q; ++i){
		int type = query[i].first;
		int x = query[i].second;

		if(type == 1){
            st.update(1, 0, n - 1, l[x], l[x], 1);
			continue;
		}
		if(type == 2){
            ultra(x);
			continue;
		}
		if(type == 3){
            for(int to: adj[x]){
                st.update(1, 0, n - 1, l[to], l[to], 0);
            }
            st.update(1, 0, n - 1, l[x], l[x], 0);
			continue;
		}
		if(type == 4){
			cout << st.query(1, 0, n - 1, l[x], r[x]) << "\n";
			continue;
		}
    }
}

void read(){
	ios::sync_with_stdio(false);
	cin.tie(NULL);

	cin >> n;
	for(int i = 0; i < n -1; ++i){
        cin >> par[i + 2];

        adj[par[i + 2]].push_back(i + 2);
	}

	cin >> q;
	for(int i = 0; i < q; ++i){
		cin >> query[i].first >> query[i].second;
	}
}

int main(){
	read();
	solve();
}
/*
5
1 1 3 3
8
1 3
2 5
4 1
1 1
2 1
4 3
3 1
4 3
*/
