#include <bits/stdc++.h>

using namespace std;

const int MAXN = 5e5 + 7;

int n, m, c[MAXN], c_ans[MAXN];
vector<int> adj[MAXN];
bool used[MAXN];

void color(int u){
	used[u] = true;
	map<int, bool> mp;
    for(int to: adj[u]){
		if(used[to]){
			mp[c[to]] = true;
		}
    }

    int pr = 0;
    for(auto it: mp){
        if(it.first > pr + 1){
            c[u] = pr + 1;
            break;
        }
        pr = it.first;
    }
    if(!c[u]){
		c[u] = pr + 1;
    }
    for(int to: adj[MAXN]){
		if(!used[to]){
			color(to);
		}
    }
}

int try_solve(){
	for(int i = 1; i <= n; ++i){
		random_shuffle(adj[i].begin(), adj[i].end());
		used[i] = false;
		c[i] = 0;
	}
    for(int i = 1; i <= n; ++i){
		if(!used[i]){
            color(i);
		}
    }

    int mx = 0;
    for(int i = 1; i <= n; ++i){
		mx = max(mx, c[i]);
    }

    return mx;
}

clock_t timer;

void solve(){
	int mx = n;
	while(((float)clock() - (float)timer) / (float)CLOCKS_PER_SEC < (float)0.25){
        int curr = try_solve();
        if(curr < mx){
			mx =  curr;
			for(int i = 1; i <= n; ++i){
				c_ans[i] = c[i];
			}
        }
	}

    cout << mx << "\n";
    for(int i = 1; i <= n; ++i){
		cout << c_ans[i] << " ";
    }
    cout << "\n";
}

void read(){
	timer = clock();
	ios::sync_with_stdio(false);
	cin.tie(NULL);

	cin >> n >> m;
	for(int i = 0; i < m; ++i){
        int u, v;
        cin >> u >> v;

        adj[u].push_back(v);
        adj[v].push_back(u);
	}
}

int main(){
	read();
	solve();
}
/*
6 5
1 2
2 3
1 4
3 4
6 5
*/
