#include <bits/stdc++.h>
#define pb push_back
#define mp make_pair
#define ll long long
using namespace std;
const int N = 5e5 + 5;

int n;
string s;

struct SA{

    int fh, sh;
    int ind;

    bool operator < (const SA &other)
    {
        if(fh != other.fh)
            return fh < other.fh;
        return sh < other.sh;
    }
}sa[N];

int rnk[N][20];
void build_suffix_array()
{
    n = (int)s.size();
    for(int i = 0; i < n; i++)
        rnk[i][0] = (int)(s[i] - '$');

    for(int lg = 0; (1 << lg) < n; lg++)
    {
        for(int i = 0; i < n; i++)
        {
            sa[i].ind = i;
            sa[i].fh = rnk[i][lg];
            sa[i].sh = (i + (1 << lg) < n) ? rnk[i + (1 << lg)][lg] : -1;
        }

        sort(sa, sa + n);
        int cur = 0;
        rnk[sa[0].ind][lg + 1] = 0;
        for(int i = 1; i < n; i++)
        {
            if(sa[i].fh != sa[i - 1].fh || sa[i].sh != sa[i - 1].sh)
                cur++;
            rnk[sa[i].ind][lg + 1] = cur;
        }
    }

}

int inv_sa[N], lcp[N];
void kasai()
{
    for(int i = 0; i < n; i++)
        inv_sa[sa[i].ind] = i;

    int k = 0;
    for(int i = 0; i < n; i++)
    {
        if(inv_sa[i] == n - 1)
        {
            k = 0;
            continue;
        }

        int j = sa[inv_sa[i] + 1].ind;
        while(i + k < n && j + k < n && s[i + k] == s[j + k])
            k++;

        lcp[inv_sa[i]] = k;
        if(k)
            k--;
    }

    lcp[n - 1] = 0;
}

struct node{

    int pref, suff;
    int val, sz;

}seg[4 * N];

node combine(node l, node r)
{
    node res;
    res.sz = l.sz + r.sz;

    res.pref = l.pref;
    if(l.pref == l.sz)
        res.pref += r.pref;

    res.suff = r.suff;
    if(r.suff == r.sz)
        res.suff += l.suff;

    res.val = max(l.val, r.val);
    res.val = max(res.val, l.suff + r.pref);

    return res;
}

void build(int pos, int low, int high)
{
    if(low == high)
    {
        seg[pos].sz = high - low + 1;
        seg[pos].val = 0;
        seg[pos].pref = 0;
        seg[pos].suff = 0;

        return;
    }

    int mid = (low + high) / 2;
    build(pos * 2, low, mid);
    build(pos * 2 + 1, mid + 1, high);

    seg[pos] = combine(seg[pos * 2], seg[pos * 2 + 1]);
}

void update(int pos, int low, int high, int x)
{
    if(low == high)
    {
        seg[pos].val = 1;
        seg[pos].pref = 1;
        seg[pos].suff = 1;

        return;
    }

    int mid = (low + high) / 2;
    if(x <= mid)
        update(pos * 2, low, mid, x);
    else
        update(pos * 2 + 1, mid + 1, high, x);

    seg[pos] = combine(seg[pos * 2], seg[pos * 2 + 1]);
}


int max_cnt[N];
void calc_max_cnt()
{
    build(1, 1, n);
    vector <pair <int, int> > v;
    for(int i = 0; i < n; i++)
        v.pb({-lcp[i], i + 1});
    sort(v.begin(), v.end());

    int id = 0;
    for(int i = n - 1; i >= 1; i--)
    {
        while(id < n && -v[id].first >= i)
        {
            update(1, 1, n, v[id].second);
            id++;
        }

        max_cnt[i] = seg[1].val + 1;
    }
}

void start(char w[])
{
    for(int i = 0; w[i] != '\0'; i++)
        s.pb(w[i]);

    build_suffix_array();
    kasai();
    calc_max_cnt();
}

int round(int m, int k)
{
    if(m == n)
        return 1;
    if(max_cnt[m] == max_cnt[k + 1])
        return 0;
    return max_cnt[m];
}


//int main()
//{
//    ios_base::sync_with_stdio(false);
//    cin.tie(NULL); cout.tie(NULL);
//
//    cin >> s;
//    build_suffix_array();
//    for(int i = 0; i < n; i++)
//    {
//        for(int j = sa[i].ind; j < n; j++)
//            cerr << s[j];
//        cerr << endl;
//    }
//
//    kasai();
//    for(int i = 0; i < n; i++)
//        cerr << lcp[i] << endl;
//    calc_max_cnt();
//
//    int Q;
//    cin >> Q;
//    while(Q--)
//    {
//        int m, k;
//        cin >> m >> k;
//        cout << round(m, k) << endl;
//    }
//
//    return 0;
//}

/*

abcabcabcdedea

*/
