#include <iostream>
#include <vector>
#include <queue>
#define endl '\n'
using namespace std;

const int MAXN = 500005;

int n, m;
vector<int> g[MAXN];
int vis[MAXN], col[MAXN];
bool odd = 0, ret = 0;

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> m;
    for (int i = 1; i <= m; ++ i)
    {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
}

void DFS(int u, int p)
{
    for (int v : g[u])
    {
        if (v == p or vis[v] < 0) continue;
        if (vis[v] == 0)
        {
            vis[v] = vis[u] + 1;
            DFS(v, u);
        }
        else
        {
            int len = vis[u] - vis[v] + 1;
            if (len % 2 == 1) odd = 1;
        }
    }
    vis[u] = -vis[u];
}

void BFS(int x)
{
    for (int i = 1; i <= n; ++ i)
    {
        vis[i] = 0;
    }

    queue<int> q;
    col[x] = 1;
    vis[x] = 1;
    q.push(x);

    while (!q.empty())
    {
        int u = q.front();
        q.pop();

        bool one = 0, two = 0, three = 0;
        for (int v : g[u])
        {
            if (col[v] != 0)
            {
                if (col[v] == 1) one = 1;
                if (col[v] == 2) two = 1;
                if (col[v] == 3) three = 1;
            }

            if (vis[v] == 0)
            {
                vis[v] = 1;
                q.push(v);
            }
        }

        if (one == 0) col[u] = 1;
        else if (two == 0) col[u] = 2;
        else if (three == 0) col[u] = 3;
        else ret = -1;
    }
}


bool BKTR(int u)
{
    bool one = 0, two = 0, three = 0;
    for (int v : g[u])
    {
        if (col[v] == 1) one = 1;
        if (col[v] == 2) two = 1;
        if (col[v] == 3) three = 1;
    }

    for (int i = 1; i <= 3; ++ i)
    {
        if (i == 1 and one) continue;
        if (i == 2 and two) continue;
        if (i == 3 and three) continue;

        bool genfl = 1;

        col[u] = i;
        for (int v : g[u])
        {
            bool fl = 1;
            if (col[v] == 0) fl = BKTR(v);
            if (fl == 0)
            {
                genfl = 0;
                break;
            }
        }

        if (genfl) return true;
    }
    col[u] = 0;
    return false;
}

int main()
{
    Init();

    for (int i = 1; i <= n; ++ i)
    {
        if (vis[i] == 0)
        {
            vis[i] = 1;
            DFS(i, 0);
        }
    }

    if (odd == 0) cout << 2 << endl;
    else cout << 3 << endl;

    /*if (odd == 0)
    {
        for (int i = 1; i <= n; ++ i)
        {
            if (col[i] == 0) BFS(i);
        }
    }
    else
    {*/
        for (int i = 1; i <= n; ++ i)
        {
            if (col[i] == 0) BKTR(i);
        }
    //}

    for (int i = 1; i <= n; ++ i)
    {
        cout << col[i] << ' ';
    }

    cout << endl;
    return ret;
}


/*
6 7
1 2
2 3
1 4
3 4
6 5
1 5
1 6
*/
