#include <iostream>
#include <vector>
//#define endl '\n'
using namespace std;

const int MAXN = 300005;

int n, q;
vector<int> g[MAXN];

int p[MAXN];
vector<int> tour;

int cnt[MAXN], inp[MAXN];
int timer = 0;

int tree[MAXN * 4];

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n;
    p[1] = 0;
    for (int i = 2; i <= n; ++ i)
    {
        cin >> p[i];
        g[p[i]].push_back(i);
    }
}

void DFS(int u = 1)
{
    inp[u] = ++timer;
    cnt[u] = 1;

    tour.push_back(u);
    for (int v : g[u])
    {
        DFS(v);
        cnt[u] += cnt[v];
    }
}

void update(int x, int v = 1, int l = 1, int r = 4 * n)
{
    if (x < l or x > r) return;
    if (l == x and r == x)
    {
        tree[v]++;
        return;
    }

    int mid = (l + r) / 2;
    update(x, v << 1 | 0, l, mid + 0);
    update(x, v << 1 | 1, mid + 1, r);

    tree[v] = tree[v << 1 | 0] + tree[v << 1 | 1];
}

int query(int le, int ri, int v = 1, int l = 1, int r = 4 * n)
{
    if (le <= l and r <= ri) return tree[v];
    if (ri < l or le > r) return 0;

    int mid = (l + r) / 2;
    return query(le, ri, v << 1 | 0, l, mid + 0) + query(le, ri, v << 1 | 1, mid + 1, r);
}

int main()
{
    Init();
    DFS();

   /* for (int i = 1; i <= n; ++ i)
    {
        cout << inp[i] << ' ' << cnt[i] << endl;
    }*/

    cin >> q;
    for (int i = 1; i <= q; ++ i)
    {
        int t, x;
        cin >> t >> x;
        if (t == 1) update(inp[x]);
        if (t == 4)

        {
            cout << query(inp[x], inp[x] + cnt[x] - 1) << endl;
            if (inp[x] + cnt[x] - 1 > timer) return -1;
        }
    }

    return 0;
}
