#include <iostream>
#include <vector>
#include <queue>
#include <set>
using namespace std;

const int MAXN = 500005;

int n, m;
vector<int> g[MAXN];
int vis[MAXN], col[MAXN];
bool odd = 0;

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> m;
    for (int i = 1; i <= m; ++ i)
    {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
}

void DFS(int u, int p)
{
    for (int v : g[u])
    {
        if (v == p or vis[v] < 0) continue;
        if (vis[v] == 0)
        {
            vis[v] = vis[u] + 1;
            DFS(v, u);
        }
        else
        {
            int len = vis[u] - vis[v] + 1;
            if (len % 2 == 1) odd = 1;
            // cout << "cycle found: " << u << ' '<< v << endl;
        }
    }
    vis[u] = -vis[u];
}

void BFS(int x)
{
    queue<int> q;
    col[x] = 1;
    q.push(x);

    while (!q.empty())
    {
        int u = q.front();
        q.pop();

        if (col[u] != 0 and u != x) continue;

        set<int> s;
        for (int v : g[u])
        {
            if (col[v] != 0) s.insert(col[v]);
            else q.push(v);

        }

        for (int i = 1; i <= 3; ++ i)
        {
            if (s.count(i) == 0)
            {
                col[u] = i;
                break;
            }
        }
    }
}

int main()
{
    Init();

    vis[1] = 1;
    for (int i = 1; i <= n; ++ i)
    {
        if (vis[i] == 0) DFS(i, 0);
    }

    if (odd == 0) cout << 2 << endl;
    else cout << 3 << endl;

    for (int i = 1; i <= n; ++ i)
    {
        if (col[i] == 0) BFS(i);
    }

    for (int i = 1; i <= n; ++ i)
    {
        cout << col[i] << ' ';
    }

    cout << endl;
    return 0;
}


/*
6 7
1 2
2 3
1 4
3 4
6 5
1 5
1 6
*/
