#include <bits/stdc++.h>

using namespace std;

const int maxn = 3e5 + 3;

int n, q;
int p[maxn];
void read()
{
    cin >> n;

    for (int i = 2; i <= n; i++)
        cin >> p[i];

    cin >> q;
}

vector <int> adj[maxn];
vector <int> order;
int sz[maxn];

void pre_dfs(int ver)
{
    order.push_back(ver);
    sz[ver] = 1;

    for (auto i: adj[ver])
    {
        pre_dfs(i);
        sz[ver] += sz[i];
    }
}

int pos[maxn];

int tr[maxn * 4];
void merge(int v)
{
    tr[v] = tr[v * 2] + tr[v * 2 + 1];
}

void update(int v, int l, int r, int pos, int val)
{
    if (l == r)
    {
        tr[v] = val;
        return;
    }

    int mid = (l + r) / 2;
    if (pos <= mid)
        update(v * 2, l, mid, pos, val);

    else
        update(v * 2 + 1, mid + 1, r, pos, val);

    merge(v);
}

int get(int v, int l, int r, int ll, int rr)
{
    if (l > rr || r < ll)
        return 0;

    if (l >= ll && r <= rr)
        return tr[v];

    int mid = (l + r) / 2;

    return get(v * 2, l, mid, ll, rr) + get(v * 2 + 1, mid + 1, r, ll, rr);
}

void update_children(int ver, int val)
{
    for (auto i: adj[ver])
        update(1, 1, n, pos[i], val);
}

void operation4(int ver)
{
    int t = ver;
    while (ver != 1)
    {
        if (get(1, 1, n, pos[ver], pos[ver]))
        update_children(ver, 1);
        ver = p[ver];
    }

    if (get(1, 1, n, pos[1], pos[1]))
    update_children(1, 1);

    while (t != 1)
    {
        update(1, 1, n, pos[t], 0);
        t = p[t];
    }

    update(1, 1, n, pos[1], 0);
}

void solve()
{
    for (int i = 2; i <= n; i++)
    adj[p[i]].push_back(i);

    pre_dfs(1);

    for (int i = 0; i < n; i++)
        pos[order[i]] = i + 1;

    for (int i = 1; i <= q; i++)
    {
        int type, x;
        cin >> type >> x;

        if (type == 1)
        update(1, 1, n, pos[x], 1);

        else
            if (type == 4)
                cout << get(1, 1, n, pos[x], pos[x] + sz[x] - 1) << endl;

        else
            if (type == 3)
        {
            update(1, 1, n, pos[x], 0);
            update_children(x, 0);
        }

        else
        operation4(x);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}
