#include <bits/stdc++.h>

const int32_t MAX_N = 5e5;

struct Vertex {
	bool vis;
	int32_t color;
	std::vector< int32_t > v;
};

Vertex g[MAX_N + 5];

bool check_is_bipartite(int32_t x, int32_t c) {
	g[x].color = c;
	g[x].vis = true;

	for(auto &y : g[x].v) {
		if(g[y].vis) {
			if(g[y].color == c) {
				g[y].color = 3;
				return false;
			}

			continue;
		}

		if(!check_is_bipartite(y, (c == 1 ? 2 : 1))) {
			return false;
		}
	}

	return true;
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	int32_t n, m;
	std::cin >> n >> m;

	for(int32_t i = 0; i < m; i++) {
		int32_t u, v;
		std::cin >> u >> v;

		g[u].v.push_back(v);
		g[v].v.push_back(u);
	}
	
	bool bipartite = true;
	for(int32_t i = 1; i <= n; i++) {
		if(!g[i].vis) {
			bipartite &= check_is_bipartite(i, 1);
		}
	}

	if(bipartite) {
		std::cout << 2 << '\n';
		for(int32_t i = 1; i <= n; i++) {
			std::cout << g[i].color << " ";
		}
		std::cout << '\n';
		return 0;
	}
	
	while(1) {
		for(int32_t i = 1; i <= n; i++) {
			if(g[i].color != 3) {
				g[i].vis = false;	
			}
		}

		bipartite = true;
		for(int32_t i = 1; i <= n; i++) {
			if(!g[i].vis) {
				bipartite &= check_is_bipartite(i, 1);
				if(!bipartite) {
					break;
				}
			}
		}

		if(bipartite) {
			break;
		}
	}

	std::cout << 3 << '\n';
	for(int32_t i = 1; i <= n; i++) {
		std::cout << g[i].color << " ";
	}
	std::cout << '\n';
}
