#include <bits/stdc++.h>
#ifndef LOCAL
	#include "Sgame.h"
#endif

const int32_t MAX_N = 5e5;

#define int32_t int
#define int64_t long long
#define uint64_t unsigned long long

const uint64_t BASE = 147;
const uint64_t BASE2 = 137;
std::vector< uint64_t > basePowers, h, basePowers2, h2;

int32_t n;
std::string s;
std::vector< int32_t > lcp, left, right;

struct SegmentTree {
	int32_t data[4 * MAX_N + 5];
		
	void update(int32_t node, int32_t low, int32_t high, int32_t qInd, int32_t qVal) {
		if(low > qInd || high < qInd) {
			return;
		}
		else if(low == qInd && high == qInd) {
			data[node] = std::max(data[node], qVal);
			return;
		}

		int32_t mid = (low + high) / 2;
		update(2 * node, low, mid, qInd, qVal);
		update(2 * node + 1, mid + 1, high, qInd, qVal);

		data[node] = std::max(data[2 * node], data[2 * node + 1]);
	}

	int32_t query(int32_t node, int32_t low, int32_t high, int32_t qLow, int32_t qHigh) {
		if(low > qHigh || high < qLow) {
			return 0;
		}
		else if(low >= qLow && high <= qHigh) {
			return data[node];
		}

		int32_t mid = (low + high) / 2;
		return std::max(query(2 * node, low, mid, qLow, qHigh), query(2 * node + 1, mid + 1, high, qLow, qHigh));
	}
};

SegmentTree segTree;

bool are_equal(int32_t i, int32_t j, int32_t len) {
	uint64_t aux1 = h[i + len - 1] - (i == 0 ? 0 : h[i - 1]);
	uint64_t aux2 = h[j + len - 1] - (j == 0 ? 0 : h[j - 1]);

	if(i < j) {
		aux1 *= basePowers[j - i];	
	}
	else {
		aux2 *= basePowers[i - j];
	}

	bool p = (aux1 == aux2);
	
	aux1 = h2[i + len - 1] - (i == 0 ? 0 : h2[i - 1]);
	aux2 = h2[j + len - 1] - (j == 0 ? 0 : h2[j - 1]);

	if(i < j) {
		aux1 *= basePowers2[j - i];	
	}
	else {
		aux2 *= basePowers2[i - j];
	}

	bool q = (aux1 == aux2);

	return (p && q);
}

bool cmp(int32_t i, int32_t j) {
	int32_t low = 1, high = std::min(n - i, n - j);
	
	while(low <= high) {
		int32_t mid = (low + high) / 2;

		if(are_equal(i, j, mid)) {
			low = mid + 1;
		}
		else {
			high = mid - 1;
		}
	}
	
	low--;

	if(i + low >= n) {
		return 1;
	}
	else if(j + low >= n) {
		return 0;
	}
	else {
		return s[i + low] < s[j + low]; 
	}
}

void start(char w[]) {
	s = w;
	std::reverse(s.begin(), s.end());
	
	n = s.size();

	basePowers.resize(n);
	h.resize(n);
	
	basePowers2.resize(n);
	h2.resize(n);

	basePowers[0] = 1;
	h[0] = (s[0] - 'a' + 1);

	basePowers2[0] = 1;
	h2[0] = (s[0] - 'a' + 1);
	for(int32_t i = 1; i < n; i++) {
		basePowers[i] = basePowers[i - 1] * BASE;
		h[i] = (s[i] - 'a' + 1) * basePowers[i] + h[i - 1];
		
		basePowers2[i] = basePowers2[i - 1] * BASE2;
		h2[i] = (s[i] - 'a' + 1) * basePowers2[i] + h2[i - 1];
	}
	
	std::vector< int32_t > suffArr(n);
	for(int32_t i = 0; i < n; i++) {
		suffArr[i] = i;
	}

	std::sort(suffArr.begin(), suffArr.end(), cmp);
	
	lcp.resize(n - 1);
	for(int32_t i = 0; i < n - 1; i++) {
		int32_t low = 1, high = std::min(n - suffArr[i], n - suffArr[i + 1]);
	
		while(low <= high) {
			int32_t mid = (low + high) / 2;

			if(are_equal(suffArr[i], suffArr[i + 1], mid)) {
				low = mid + 1;
			}
			else {
				high = mid - 1;
			}
		}
			
		lcp[i] = low - 1;
	}

	left.resize(n);
	right.resize(n);

	std::stack< std::pair< int32_t, int32_t > > st;
	for(int32_t i = 0; i < n - 1; i++) {
		while(!st.empty() && st.top().first >= lcp[i]) {
			st.pop();
		}

		if(st.empty()) {
			left[i] = -1;
		}
		else {
			left[i] = st.top().second;
		}

		st.push({ lcp[i], i });
	}

	while(!st.empty()) {
		st.pop();
	}

	for(int32_t i = n - 2; i >= 0; i--) {
		while(!st.empty() && st.top().first >= lcp[i]) {
			st.pop();
		}

		if(st.empty()) {
			right[i] = n - 1;
		}
		else {
			right[i] = st.top().second;
		}
		
		st.push({ lcp[i], i });
	}

	for(int32_t i = 0; i < n - 1; i++) {
		segTree.update(1, 1, n, lcp[i], right[i] - left[i]);
	}
}

int32_t round(int32_t m, int32_t k) {
	return segTree.query(1, 1, n, m, k);
}

#ifdef LOCAL
	int main() {
		char w[] = "abcabcabcdedea";
		start(w);

		std::cout << round(1, 2) << '\n';
		std::cout << round(2, 3) << '\n';
		std::cout << round(2, 2) << '\n';
	}
#endif
