#include <bits/stdc++.h>

using namespace std;

const int MAXN = 1e5 * 5 + 5;

int n, m;
vector <int> graph[MAXN];
pair <int, int> edges[MAXN];

void read_input()
{
    scanf("%d %d", &n, &m);

    int v, w;
    for(int i = 0; i < m; i++)
    {
        scanf("%d %d", &v, &w);

        graph[v].push_back(w);
        graph[w].push_back(v);
        edges[i] = {v, w};
    }
}

int timer;
int tin[MAXN], fup[MAXN];
set <pair<int, int>> st;
int root;
vector <int> temps;

void dfs(int v, int p)
{
    tin[v] = fup[v] = timer++;
    temps.push_back(v);

    vector <int> vt;
    for(auto x : graph[v])
    {
        if(x == p) continue;
        if(tin[x] != 0)
        {
            fup[v] = min(fup[v], tin[x]);
        }
        else
        {
            vt.push_back(x);
            dfs(x, v);
            if(tin[v] < fup[x] && v != root)
            {
                int first = x, second = v;
                if(first > second) swap(first, second);
                st.insert({first ,second});
            }
            fup[v] = min(fup[v], fup[x]);
        }
    }
    if(v == root && vt.size() >= 2)
    {
        for(auto x : vt)
        {
            int first = x, second = v;
            if(first > second) swap(first, second);
            st.insert({first ,second});
        }
    }
}

int answer[MAXN];

vector <int> t_graph[MAXN];

int vis[MAXN];
int timer2;

void dfs2(int v)
{
    if(vis[v] == timer2) return;
    vis[v] = timer2;

    int res[5];
    for(int i = 0; i < 5; i++)
    {
        res[i] = 0;
    }

    //printf("~~~~%d\n", v);
    for(auto x : graph[v])
    {
        int first = x, second = v;
        if(first > second) swap(first, second);
        if(st.count({first, second})) continue;
        res[answer[x]] = true;
    }

    for(int i = 1; i <= 4; i++)
    {
        if(!res[i])
        {
            answer[v] = i;
            break;
        }
    }

    for(auto x : graph[v])
    {
        int first = x, second = v;
        if(first > second) swap(first, second);
        if(st.count({first, second})) continue;

        dfs2(x);
    }
}

void solve_for()
{
    timer2++;
    for(auto x : temps)
    {
        dfs2(x);
    }
}

void solve()
{
    timer++;
    for(int i = 1; i <= n; i++)
    {
        if(tin[i] == 0)
        {
            temps.clear();
            root = i;
            st.clear();
            dfs(i, i);

            solve_for();
        }
    }
    int ans = 0;
    for(int i = 1; i <= n; i++)
    {
        ans = max(ans, answer[i]);
    }
    printf("%d\n", ans);
    for(int i = 1; i <= n; i++)
    {
        printf("%d ", answer[i]);
    }
}

int main()
{
    read_input();
    solve();

    return 0;
}

/*
6 5
1 2
2 3
1 4
3 4
6 5
*/

/*
6 7
1 2
2 3
1 4
3 4
6 5
6 4
4 5
*/

/*
6 9
1 2
1 3
1 4
1 6
4 6
5 6
4 5
3 4
2 3
*/
