#include <bits/stdc++.h>

using namespace std;

const int MAXN = 1e5 * 3 + 5;
const int TSIZE = (1 << 20);

int n;
vector <int> graph[MAXN];

void read_input()
{
    scanf("%d", &n);

    int p;
    for(int i = 0; i < n - 1; i++)
    {
        scanf("%d", &p);
        graph[i + 2].push_back(p);
        graph[p].push_back(i + 2);
    }
}

int cnt[MAXN];
int heavy[MAXN];
int depth[MAXN];

void dfs(int v, int p, int dpt = 0)
{
    cnt[v] = 1;
    depth[v] = dpt;
    for(auto x : graph[v])
    {
        if(x == p) continue;
        dfs(x, v, dpt + 1);
        cnt[v] += cnt[x];
        if(cnt[x] > cnt[heavy[v]])
        {
            heavy[v] = x;
        }
    }
    //printf("%d %d\n", v, heavy[v]);
}

int pos[MAXN], br;
int head[MAXN], krai[MAXN];
int t_chain[MAXN], tmr;
vector <int> links[MAXN];
int tree[TSIZE], lazy[TSIZE];

void push(int node, int l, int r)
{
    if(lazy[node] != 0)
    {
        if(l != r)
        {
            lazy[node * 2] += lazy[node];
            lazy[node * 2 + 1] += lazy[node];
        }
        tree[node] += lazy[node];
        lazy[node] = 0;
    }
}

void update(int node, int l, int r, int i, int j, int val)
{
    if(r < i || l > j || l > r) return;

    push(node, l, r);

    if(r <= j && l >= i)
    {
        tree[node] += val;
        if(l != r)
        {
            lazy[node * 2] += val;
            lazy[node * 2 + 1] += val;
        }
        return;
    }
    int middle = (l + r) / 2;

    update(node * 2, l, middle, i, j, val);
    update(node * 2 + 1, middle + 1, r, i, j, val);

    tree[node] = tree[node * 2] + tree[node * 2 + 1];
}

int query(int node, int l, int r, int i, int j)
{
    if(r < i || l > j || l > r) return 0;

    push(node, l, r);

    if(r <= j && l >= i)
    {
        return tree[node];
    }
    int middle = (l + r) / 2;

    int ans = query(node * 2, l, middle, i, j) + query(node * 2 + 1, middle + 1, r, i, j);
    return ans;
}

void build_chains(int v, int p)
{
    pos[v] = br++;
    t_chain[v] = tmr;

    if(heavy[v] != 0)
    {
        build_chains(heavy[v], v);
    }
    else
    {
        krai[tmr] = v;
    }
    int temp_chain = tmr;
    for(auto x : graph[v])
    {
        if(x != p && x != heavy[v])
        {
            links[temp_chain].push_back(x);
            tmr++;
            head[tmr] = x;
            build_chains(x, v);
        }
    }
    //printf("%d %d %d %d\n", v, pos[v], t_chain[v], krai[t_chain[v]]);
}

int get_ans(int v)
{
    int temp = query(1, 0, br - 1, pos[v], pos[krai[v]]);

    for(auto x : links[t_chain[v]])
    {
        if(depth[x] > depth[v]) continue;
        temp += get_ans(x);
    }
    return temp;
}

void solve()
{
    int q;
    scanf("%d", &q);

    int t, v;
    for(int i = 0; i < q; i++)
    {
        scanf("%d %d", &t, &v);

        if(t == 1)
        {
            update(1, 0, br - 1, pos[v], pos[v], 1);
        }
        else if(t == 3)
        {
            update(1, 0, br - 1, pos[v], pos[v], 0);
            for(auto x : graph[v])
            {
                if(depth[x] < depth[v])
                update(1, 0, br - 1, pos[x], pos[x], 0);
            }
        }
        else if(t == 4)
        {
            printf("%d\n", get_ans(v));
        }
    }
}

int main()
{
    read_input();
    dfs(1, 1);
    head[0] = 1;
    build_chains(1, 1);

    solve();

    return 0;
}

/*
5
1 1 3 3
8
1 3
2 5
4 1
1 1
2 1
4 3
3 1
4 3

1
2
1
*/
