#include<iostream>
#include<cstring>
#include<vector>
#include<stack>
#include<algorithm>

using namespace std;

const int MAXN = 5e5 + 5;

int n, m;
vector <int> graph[MAXN];

int ansColor[MAXN];
bool marked[MAXN];

int k;
void bruteForce(int ind, int last)
{
    if(ind==n+1)
    {
        for(int x = 1;x<=n;x++)
        {
            for(int y: graph[x])
            {
                if(ansColor[x]==ansColor[y])
                {
                    cout << 1/0 << '\n';
                }
            }
        }

        cout << k << '\n';

        cout << ansColor[1];
        for(int i = 2;i<=n;i++)
        {
            cout << " " << ansColor[i];
        }
        cout << '\n';

        exit(0);
    }

    for(int i = 1;i<=k;i++)
    {
        marked[i] = false;
    }
    for(int x: graph[ind])
    {
        marked[ ansColor[x] ] = true;
    }
    for(int col = 1;col<=k;col++)
    {
        if(marked[col]==true) continue;

        ansColor[ind] = col;
        bruteForce(ind+1, col);
        ansColor[ind] = 0;
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> m;
    for(int i = 0;i<m;i++)
    {
        int u, v;
        cin >> u >> v;
        if(u>v) swap(u, v);

        graph[v].push_back(u);
        graph[u].push_back(v);
    }

    for(k = 1;k<=n;k++)
    {
        bruteForce(1, -1);
    }

    cout << 1/0 << '\n';
}
/*
6 5
1 2
2 3
1 4
3 4
6 5

6 7
1 2
2 3
3 4
4 5
5 6
6 1
1 3
*/
