#include<iostream>
#include<cstring>
#include<string>
#include<map>
#include<algorithm>
#include "Sgame.h"

using namespace std;

const int MAXN = 3e5 + 5;
const long long key1 = 29, key2 = 31;
const long long mod1 = 1e9 + 7, mod2 = 1e9 + 9;

int n;
long long p1[MAXN], p2[MAXN];
pair <long long, long long> h[MAXN];

pair <long long, long long> getHash(int l, int r)
{
    pair <long long, long long> ans = h[r];
    if(l==0) return ans;

    ans.first = (ans.first - (h[l-1].first*p1[r-l+1])%mod1 + mod1)%mod1;
    ans.second = (ans.second - (h[l-1].second*p2[r-l+1])%mod2 + mod2)%mod2;

    return ans;
}

void start(char w[])
{
    n = strlen(w);

    h[0] = {w[0]-'a'+1, w[0]-'a'+1};
    for(int i = 1;i<n;i++)
    {
        h[i].first = (h[i-1].first*key1 + (w[i]-'a'+1))%mod1;
        h[i].second = (h[i-1].second*key2 + (w[i]-'a'+1))%mod2;
    }

    p1[0] = p2[0] = 1;
    for(int i = 1;i<=n;i++)
    {
        p1[i] = (p1[i-1]*key1)%mod1;
        p2[i] = (p2[i-1]*key2)%mod2;
    }

    //cout << getHash(0, 1).first << " " << getHash(2, 3).first << '\n';
}

int round(int m, int k)
{
    map <pair <int, int>, int> mp;
    for(int i = 0;i<n-m+1;i++)
    {
        mp[getHash(i, i+m-1)]++;
    }

    int ans = 0;
    for(auto it = mp.begin();it!=mp.end();it++)
    {
        ans = max(ans, it->second);
    }

    return ans;
}
