#include<iostream>
#include<cstring>
#include<vector>
#include<stack>
#include<algorithm>

using namespace std;

const int MAXN = 5e5 + 5;

int n, m;
vector <int> graph[MAXN], graphExtended[MAXN];

int ansColor[MAXN];
bool marked[MAXN];

int k;
int deg[MAXN];

void bruteForce(int ind, int last)
{
    if(ind==n+1)
    {
        cout << k << '\n';

        cout << ansColor[1];
        for(int i = 2;i<=n;i++)
        {
            cout << " " << ansColor[i];
        }
        cout << '\n';

        exit(0);
    }

    bool marked[k+1];
    for(int i = 1;i<=k;i++)
    {
        marked[i] = false;
    }
    for(int x: graph[ind])
    {
        marked[ ansColor[x] ] = true;
    }
    for(int col = 1;col<=k;col++)
    {
        if(marked[col]==true) continue;

        ansColor[ind] = col;
        bruteForce(ind+1, col);
        ansColor[ind] = 0;
    }
}

void DFS(int x, int color)
{
    ansColor[x] = color + 1;

    for(int y: graphExtended[x])
    {
        if(ansColor[y]!=0) continue;
        DFS(y, color^1);
    }
}

bool isOk()
{
    for(int x = 1;x<=n;x++)
    {
        for(int y: graph[x])
        {
            if(ansColor[y]==ansColor[x]) return false;
        }
    }

    return true;
}

int node = -1;
void DFSOdd(int x, int color)
{
    if(node!=-1) return;
    ansColor[x] = color + 1;

    for(int y: graphExtended[x])
    {
        if(ansColor[y]!=0)
        {
            if(ansColor[y]==color+1)
            {
                node = x;
                return;
            }

            continue;
        }
        DFSOdd(y, color^1);
    }
}

int main()
{
    //ios::sync_with_stdio(false);
    //cin.tie(NULL);

    cin >> n >> m;
    for(int i = 0;i<m;i++)
    {
        int u, v;
        cin >> u >> v;
        if(u>v) swap(u, v);

        deg[u]++;deg[v]++;
        graph[v].push_back(u);
        //graph[u].push_back(v);

        graphExtended[u].push_back(v);
        graphExtended[v].push_back(u);
    }

    k = 2;
    for(int i = 1;i<=n;i++)
    {
        if(ansColor[i]==0)
        {
            DFS(i, 0);
        }
    }

    while(isOk()==false)
    {
        k = 3;
        for(int i = 1;i<=n;i++)
        {
            if(ansColor[i]!=3) ansColor[i] = 0;
        }

        node = -1;
        for(int i = 1;i<=n;i++)
        {
            if(ansColor[i]==0) DFSOdd(i, 0);
        }

        ansColor[node] = 3;
        for(int i = 1;i<=n;i++)
        {
            if(ansColor[i]==0)
            {
                DFS(i, 0);
            }
        }
    }


    cout << k << '\n';

    cout << ansColor[1];
    for(int i = 2;i<=n;i++)
    {
        cout << " " << ansColor[i];
    }
    cout << '\n';
}
/*
6 5
1 2
2 3
1 4
3 4
6 5

6 7
1 2
2 3
3 4
4 5
5 6
6 1
1 3

6 9
1 2
2 3
3 4
4 5
5 6
6 1
1 3
4 6
3 6

6 7
1 2
2 3
3 4
4 5
5 6
6 1
1 4
*/
