#include<iostream>
#include<algorithm>
#include<vector>
#include<cstring>
#include<queue>
#include<cstdio>
#define maxn int(3*1e5+5)
#define endl "\n"
using namespace std;

int pos[maxn];
bool treelamp;
struct Tree
{
    int n;
    struct node
    {
        int t,ch;
        node()
        {t=0;ch=0;}
        node(int _t,int _ch)
        {
            t=_t; ch=_ch;
        }
    };
    vector<node>tree;

    Tree(){}
    Tree(int nn)
    {
        n=nn;
        tree.resize(4*n);
        //cout<<tree[0].ch<<endl;
    }

    void real_update(int k,int l,int r,int x,int y,int ch)
    {
        //cout<<k<<" "<<l<<" "<<r<<" "<<x<<" "<<y<<endl;
        if(l==r)
        {
            //cout<<"l=r "<<l<<endl;
            if(tree[k].t==1)
                treelamp=1;
            if(y==1)
                tree[k].t=1;
            else tree[k].t=max(0,tree[k].t+y);
            tree[k].ch+=ch;
            return ;
        }
        int mid=(l+r)/2;
        if(x<=mid)real_update(k*2,l,mid,x,y,ch);
        else      real_update(k*2+1,mid+1,r,x,y,ch);
        tree[k].t=tree[k*2].t+tree[k*2+1].t;
        tree[k].ch=tree[k*2].ch+tree[k*2+1].ch;
        //cout<<"real_update end\n";
    }

        void print_tree()
    {
        for(int i=0;i<4*n;i++)
            cout<<tree[i].t<<" ";
        cout<<endl;
        for(int i=0;i<4*n;i++)
            cout<<tree[i].ch<<" ";
        cout<<endl;

    }

    void update(int x,int y,int ch)
    {
        //cout<<x<<endl;
        real_update(1,1,n,pos[x],y,ch);
        //print_tree();
    }

    int real_ans(int k,int l,int r,int x,int y)
    {

        if(y<x||x>r)return 0;
        if(x<=l&&y>=r)
            return tree[k].t+tree[k].ch;

        return real_ans(k*2,l,(l+r)/2,x,y)+
               real_ans(k*2+1,(l+r)/2+1,r,x,y);
    }

    int get_ans(int x)
    {

        return real_ans(1,1,n,pos[x],n);
    }
};

int n;
vector<int>v[maxn];
int lvl[maxn];
int nxt[maxn];
int par[maxn];
int head[maxn];
int chnum[maxn];

vector<Tree>T;

int dfs(int i,int p)
{
    if(p==0)par[i]=i;
    else par[i]=p;

    //lvl[i]=lvl[p]+1;

    int j,sz=v[i].size();
    int tsize,msize=0,chsize=1;
    for(j=0;j<sz;j++)
    {
        int t=v[i][j];
        tsize=dfs(t,i);
        if(msize<tsize)
        {//cout<<9<<endl;
            msize=tsize;
            nxt[i]=t;
        }
        chsize+=tsize;
    }
    return chsize;
}

int hld(int i,int p,int chsize)
{
    if(chsize==1)head[i]=i;
    else head[i]=head[p];

    pos[i]=chsize;

    int j,sz=v[i].size();
    for(j=0;j<sz;j++)
    {
        int t=v[i][j];
        if(t!=p&&t!=nxt[i])
            hld(t,i,1);
    }

    if(nxt[i]==-1)
    {
        chnum[i]=T.size();
        T.push_back(Tree(chsize));
    }
    else
        chnum[i]=hld(nxt[i],i,chsize+1);

    return chnum[i];
}

void read()
{
    int i,x;
    cin>>n;

    for(i=2;i<=n;i++)
    {
        cin>>x;
        v[x].push_back(i);
    }
}


void Update(int i)
{
    //cout<<"Update begin\n";
    treelamp=0;
    T[chnum[i]].update(i,1,0);
    if(treelamp==1)
        return;
    //cout<<"     9"<<endl;
    //cout<<chnum[i]<<" "<<hpar[i]]<<endl;
    if(chnum[i]!=chnum[par[head[i]]])
    while(par[i]!=i)
    {
        i=par[head[i]];
        T[chnum[i]].update(i,0,1);

    }
    //cout<<"Update end\n";
}

/*void Update_array(int x)
{
    do
    {

        x=par[head[x]];
    }while(par[x]!=x);
}*/
void clean(int x)
{
    int i,sz=v[x].size(),br=0;
    for(i=0;i<sz;i++)
    {
        int t=v[x][i];
        treelamp=0;
        T[chnum[t]].update(t,-1,0);
        if(treelamp==1&&t!=nxt[x])br++;
    }

    treelamp=0;
    T[chnum[x]].update(x,-1,-br);
    if(treelamp==1)
        br++;

    if(chnum[x]!=chnum[par[head[x]]])
    while(par[x]!=x)
    {
        x=par[head[x]];
        T[chnum[x]].update(x,0,-br);

    }
    return ;
}


int main()
{
    /*ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
*/
    read();


    memset(nxt,-1,sizeof(nxt));
    dfs(1,0);
    hld(1,0,1);

    int m,i,t,x;
    cin>>m;
    for(i=0;i<m;i++)
    {
        cin>>t>>x;
        switch(t)
        {
        case 1:
            {
                Update(x);
                break;
            }
        case 2:
            {
                //Update_array(x);
                break;
            }
        case 3:
            {
                clean(x);
                break;
            }
        case 4:
            {
                cout<<T[chnum[x]].get_ans(x)<<endl;
                break;
            }
        }
    }
    return 0;
}
/*
5
1 1 3 3
8
1 3

4 1
1 1

4 3
3 1
4 3

11
1 1 1 4 4 8 3 8 8 10
10
1 10
1 11
4 8
1 4
1 5
4 1
4 4
4 8

*/
