#include <iostream>

#pragma GCC optimize "O3"
using std::cin; using std::cout; using std::endl;
typedef unsigned long long ull;

const int MAX_N = 5 * 1e5 + 10;
const int BASE = 59;

ull POW[MAX_N];
void calc_pow() {
	POW[0] = 1;
	for(int i = 1;i < MAX_N;i ++) POW[i] = POW[i-1] * BASE;
}

std::string S;

int occurances(std::string pattern) { // O(n)
	ull target = 0, curr = 0;
	const int ps = pattern.size();
	const int ss = S.size();

	for(int i = 0;i < ps;i ++) {
		target += pattern[i] * POW[ps - i - 1];
		curr   += S[i]       * POW[ps - i - 1];
	}

	int ans = curr == target;
	for(int begin = 0;begin < ss - ps;begin ++) {
		curr -= S[begin] * POW[ps - 1];
		curr *= BASE;
		curr += S[begin + ps];

		if(curr == target) ans ++;
	}

	return ans;
}

int occ[MAX_N];
bool calced[MAX_N];

void start(char w[]) {
	// copy w into S
	for(size_t i = 0;w[i] != 0;i ++) S.push_back(w[i]);
	calc_pow();

	/*
	// O(N ^ 3)
	for(int len = 1;len <= S.size();len ++) {
		for(int begin = 0;begin <= S.size() - len;begin ++) {
			const int o = occurances(S.substr(begin, len));
			occ[len] = std::max(occ[len], o);
		}
	}
	*/
}

int round(int m, int k) {
	//cout << "called " << m << ' ' << k << endl;
	if(calced[m]) return occ[m];

	for(int begin = 0;begin <= S.size() - m;begin ++) {
		const int o = occurances(S.substr(begin, m));
		occ[m] = std::max(occ[m], o);
	}

	calced[m] = true;
	return occ[m];
}
