#include <iostream>
#include <vector>
#include <bitset>

#pragma GCC optimize "O3"
using std::cin; using std::cout; using std::endl;

const int MAX_N = 5e3 + 10;
int N, M;
struct State {
	std::bitset<MAX_N * 3> impos;

	template<int MC>
	void color(int idx, int color) {
		for(int i = 0;i < MC;i ++) impos[idx*3 + i] = true;
		impos[idx*3 + color] = false;
	}

	template<int MC>
	int cnt(int idx) const {
		return MC
		     - impos[idx*3 + 0]
		     - impos[idx*3 + 1]
		     - impos[idx*3 + 2];
	}
};

std::vector<int> graph[MAX_N];

template<int MC>
bool Color(int idx, int color, State &curr) {
	curr.color<MC>(idx, color);
	if(curr.cnt<MC>(idx) == 0) return false;

	for(auto nei : graph[idx]) {
		if(curr.impos[nei*3 + color]) continue;
		curr.impos[nei*3 + color] = true;

		const int cnt = curr.cnt<MC>(nei);
		if(cnt == 0) return false;

		if(cnt == 1) {
			// find it
			for(int c = 0;c < MC;c ++) {
				if(!curr.impos[nei*3 + c]) {
					bool r = Color<MC>(nei, c, curr);
					if(!r) return false;
					break;
				}
			}
		}
	}

	return true;
}

template<int MC>
void rec(const State &curr) {
	bool any = false;

	/*
	std::cout << MC << "here" << endl;
	for(int i = 0;i < N;i ++) {
		cout << i << "| ";
		for(int c = 0;c < 3;c ++) cout << curr.impos[i*3 + c] << ' ';
		cout << " = " << curr.cnt<MC>(i);
		cout << '\n';
	} 
	*/

	for(int i = 0;i < N;i ++) {
		if(curr.cnt<MC>(i) == 1) continue;

		any = true;

		for(int color = 0;color < MC;color ++) {
			if(curr.impos[i*3 + color]) continue;

			// make i coloed color
			State ns = curr;
			if(Color<MC>(i, color, ns)) rec<MC>(ns);
		}	
	}

	if(!any) {
		//std::cerr << "OK" << std::endl;
		cout << MC << '\n';
		for(int i = 0;i < N;i ++) {
			for(int c = 0;c < MC;c ++) {
				if(!curr.impos[i*3 + c]) {
					cout << c+1 << ' ';
					break;
				}
			}
		}
		cout << endl;
		exit(0);
	}
}


int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	cin >> N >> M;
	
	for(int i = 0;i < M;i ++) {
		int u, v;
		cin >> u >> v;
		u --;
		v --;
		graph[u].push_back(v);
		graph[v].push_back(u);
	}

	State initial;
	rec<2>(initial);
	rec<3>(initial);
}