#include <iostream>
#include <unordered_map>

#pragma GCC optimize "O3"
using std::cin; using std::cout; using std::endl;
typedef unsigned long long ull;

const int MAX_N = 5 * 1e5 + 10;
const int BASE = 59;

ull POW[MAX_N];
void calc_POW() {
	POW[0] = 1;
	for(int i = 1;i < MAX_N;i ++) POW[i] = POW[i-1] * BASE;
}

std::string S;

int occurances(std::string pattern) { // O(n)
	ull target = 0, curr = 0;
	const int ps = pattern.size();
	const int ss = S.size();

	for(int i = 0;i < ps;i ++) {
		target += pattern[i] * POW[ps - i - 1];
		curr   += S[i]       * POW[ps - i - 1];
	}

	int ans = curr == target;
	for(int begin = 0;begin < ss - ps;begin ++) {
		curr -= S[begin] * POW[ps - 1];
		curr *= BASE;
		curr += S[begin + ps];

		if(curr == target) ans ++;
	}

	return ans;
}

int iamstupid(const int ps) { // o(N)
	const int ss = S.size();
	ull curr = 0;

	for(int i = 0;i < ps;i ++) {
		curr += S[i] * POW[ps - i - 1];
	}

	std::unordered_map<ull, int> hs;
	hs[curr] = 1;

	for(int begin = 0;begin < ss - ps;begin ++) {
		curr -= S[begin] * POW[ps - 1];
		curr *= BASE;
		curr += S[begin + ps];

		hs[curr] += 1;
	}

	int ans = 0;
	for(auto x : hs) ans = std::max(ans, x.second);
	return ans;
}

int occ[MAX_N];
bool calced[MAX_N];

void start(char w[]) {
	// copy w into s
	for(size_t i = 0;w[i] != 0;i ++) S.push_back(w[i]);
	calc_POW();
}

int round(int m, int k) {
	//cout << "called " << m << ' ' << k << endl;
	int treshold = (k == S.size() ? -1 : iamstupid(k+1));
	//cout << "t=" << treshold << endl;

	int cnt = iamstupid(m);
	if(cnt > treshold) return cnt;

	return 0;
}
