#include <iostream>
#include <unordered_map>

#pragma GCC optimize "Ofast"
using std::cin; using std::cout; using std::endl;
typedef unsigned long long ull;

const int MAX_N = 5 * 1e5 + 10;
const int BASE = 59;
const int CF = 30; // cheat factor

ull POW[MAX_N];
void calc_POW() {
	POW[0] = 1;
	for(int i = 1;i < MAX_N;i ++) POW[i] = POW[i-1] * BASE;
}

std::string S;

int search(std::string pattern) { // O(n)
	ull target = 0, curr = 0;
	const int ps = pattern.size();
	const int ss = S.size();

	for(int i = 0;i < ps;i ++) {
		target += pattern[i] * POW[ps - i - 1];
		curr   += S[i]       * POW[ps - i - 1];
	}

	int ans = curr == target;
	for(int begin = 0;begin < ss - ps;begin ++) {
		curr -= S[begin] * POW[ps - 1];
		curr *= BASE;
		curr += S[begin + ps];

		if(curr == target) ans ++;
	}

	return ans;
}

int iamstupid(const int ps) { // o(N)
	const int ss = S.size();
	if(ps >= ss) return 1;

	ull curr = 0;

	for(int i = 0;i < ps;i ++) {
		curr += S[i] * POW[ps - i - 1];
	}

	std::unordered_map<ull, int> hs;
	hs[curr] = 1;

	int ans = 0;
	for(int begin = 0;begin < ss - ps;begin ++) {
		curr -= S[begin] * POW[ps - 1];
		curr *= BASE;
		curr += S[begin + ps];

		hs[curr] += 1;
		ans = std::max(ans, hs[curr]);
	}

	return ans;
}

int occ[MAX_N];
bool calced[MAX_N];

int occurances(int m) {
	if(calced[m]) return occ[m];
	calced[m] = true;
	return occ[m] = iamstupid(m);
}

void calc_segment(int l, int r) {
	int R = occurances(l);
	int L = occurances(r);

	if(L == R) {
		for(int i = l;i <= r;i ++) {
			calced[i] = true;
			occ[i] = L;
		}
		return;
	} else {
		const int m = (l+r) / 2;
		calc_segment(l, m);
		calc_segment(m+1, r);
	}
}

void start(char w[]) {
	// copy w into s
	for(size_t i = 0;w[i] != 0;i ++) S.push_back(w[i]);
	calc_POW();

	calc_segment(1, S.size());
}

int round(int m, int k) {
	//cout << "called " << m << ' ' << k << endl;
	return occurances(m);
}
