#include <iostream>
#include <vector>
#include <bitset>

#pragma GCC optimize "O3"
using std::cin; using std::cout; using std::endl;

const int MAX_N = 5e3 + 10;
int N, M;
struct State {
	std::bitset<MAX_N * 3> impos;

	void color(int idx, int color) {
		impos[idx*3 + 0] = true;
		impos[idx*3 + 1] = true;
		impos[idx*3 + 2] = true;

		impos[idx*3 + color] = false;
	}

	int cnt(int idx) const {
		return 3
		     - impos[idx*3 + 0]
		     - impos[idx*3 + 1]
		     - impos[idx*3 + 2];
	}
};

std::vector<int> graph[MAX_N];

template<int MC>
void rec(const State &curr) {
	bool any = false;

	//std::cout << MC << "here" << endl;

	for(int i = 0;i < N;i ++) {
		if(curr.cnt(i) == 1) continue;
		if(curr.cnt(i) == 0) {
			std::cerr << "ERROR " << endl;
			std::cerr << 1/0 << endl;
		}

		any = true;

		for(int color = 0;color < MC;color ++) {
			if(curr.impos[i*3 + color]) continue;

			// make i coloed color
			State ns = curr;
			ns.color(i, color);
			bool bad = false;
			for(auto nei : graph[i]) {
				ns.impos[nei * 3 + color] = true;

				const int cnt = ns.cnt(nei);
				if(cnt == 0) {
					bad = true;
					break;
				}
			}

			if(bad) continue;

			rec<MC>(ns);
		}	
	}

	if(!any) {
		//std::cerr << "OK" << std::endl;
		cout << MC << '\n';
		for(int i = 0;i < N;i ++) {
			for(int c = 0;c < MC;c ++) {
				if(!curr.impos[i*3 + c]) {
					cout << c+1 << ' ';
					break;
				}
			}
		}
		cout << endl;
		exit(0);
	}
}


int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	cin >> N >> M;
	for(int i = 0;i < N;i ++) {
		graph[i].push_back((i+1) % N);
		graph[(i+1) % N].push_back(i);
	}

	for(int i = 0;i < M;i ++) {
		int u, v;
		cin >> u >> v;
		u --;
		v --;
		graph[u].push_back(v);
		graph[v].push_back(u);
	}

	State initial;
	rec<2>(initial);
	rec<3>(initial);
}