#include <bits/stdc++.h>
#define MAXN 300003
#define endl '\n'
using namespace std;
int n, q;
vector <int> adj[MAXN];
bool inf[MAXN];
int cnt[MAXN];
int par[MAXN];

void clear(int v)
{
    inf[v] = 0;
    ///cout << "c: " << v << endl;
    --cnt[v];
    while (par[v] != -1)
    {
        --cnt[par[v]];
        ///cout << "c: " << par[v] << endl;
        v = par[v];
    }
}

void infect(int v)
{
    inf[v] = 1;
    ++cnt[v];
    ///cout << "i: " << v << endl;
    while (par[v] != -1)
    {
        ++cnt[par[v]];
        ///cout << "i: " << par[v] << endl;
        v = par[v];
    }
}

void query1(int v)
{
    if (!inf[v])
        infect(v);
}

bool used[MAXN];

void spread(int v)
{
    ///cout << "spread " << v << ": " << endl;
    for (int i = 0; i < adj[v].size(); ++i)
    {
        int nb = adj[v][i];
        if (!used[nb])
        {
            ///cout << " > " << nb << endl;
            if (!inf[nb])
                infect(nb);
            //cnt[v]++;
        }
    }
}


int tar;

void dfs(int tmp, int par, stack <int> st)
{
    st.push(tmp);
    if (tmp == tar)
    {
        while (!st.empty())
        {
            used[st.top()] = 1;
            st.pop();
        }
        return;
    }

    for (int i = 0; i < adj[tmp].size(); ++i)
    {
        int nb = adj[tmp][i];
        if (nb != par)
            dfs(nb, tmp, st);
    }
}

void query2(int v)
{
    memset(used, 0, sizeof(used));
    tar = v;
    stack <int> st;
    dfs(1, 1, st);
    ///cout << "query2 " << v << ": " << endl;
    for (int i = 1; i <= n; ++i)
        if (used[i])
        {
            if (inf[i])
            {
                ///cout << "> " << i << endl;
                spread(i);
            }
            if (inf[i])
                clear(i);
            //--cnt[i];
        }
}

void query3(int v)
{
    if (inf[v])
        clear(v);
    for (int i = 0; i < adj[v].size(); ++i)
    {
        int nb = adj[v][i];
        if (inf[nb])
            clear(nb);
    }
}

int dfs_sz(int tmp, int par)
{
    int sz = (inf[tmp] ? 1 : 0);
    for (int i = 0; i < adj[tmp].size(); ++i)
    {
        int nb = adj[tmp][i];
        if (nb != par)
            sz += dfs_sz(nb, tmp);
    }
    return sz;
}

void query4(int v)
{
    //cout << dfs_sz(v, v) << endl;
    cout << cnt[v] << endl;
}

void input()
{
    cin >> n;
    par[1] = -1;
    for (int i = 2; i <= n; ++i)
    {
        int par1;
        cin >> par1;
        //adj[i].push_back(par);
        //adj[par1].push_back(i);
        par[i] = par1;
    }
    cin >> q;
    while (q--)
    {
        int t, v;
        //cout << "*------------------*" << endl;
        cin >> t >> v;
        if (t == 1)
            query1(v);
        /*else if (t == 2)
            query2(v);
        else if (t == 3)
            query3(v);*/
        else
            query4(v);
    }

}

/**
5
1 1 3 3
8
1 3
2 5
4 1
1 1
2 1
4 3
3 1
4 3

*/

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    input();

    return 0;
}
