#include <bits/stdc++.h>
using namespace std;
const int MAXN = 3e5 + 1;
int n,q,inf[MAXN],cnti[MAXN],par[MAXN],ult[MAXN],m,used[MAXN],nump[MAXN];
vector<int> graph[MAXN];
vector<int> path[MAXN];
struct node{
    node *le, *ri;
    int cnti,lazy;
    node() {
        cnti = 0;
        lazy = 0;
        le = nullptr;
        ri = nullptr;
    }
};
node* roots[MAXN];
void find_paths(int s)
{
    used[s] = 1;
    path[m].push_back(s);
    nump[s] = m;
    if(graph[s].size() == 0)
    {
        m++;
        return;
    }
    for(int i = 0; i < graph[s].size(); i++)
    {
        if(!used[graph[s][i]])
        {
            find_paths(graph[s][i]);
        }
    }
}
int find_ind(int x)
{
    int le = 0, ri = path[nump[x]].size() - 1,mid;
    while(le <= ri)
    {
        mid = (le + ri) >> 1;
        if(path[nump[x]][mid] == x) return mid;
        else if(path[nump[x]][mid] > x) ri = mid - 1;
        else le = mid + 1;
    }
}
node* build_tree(int le,int ri)
{
    node* tmp = new node;
    if(le == ri)
    {
        return tmp;
    }
    int mid = (le + ri) >> 1;
    tmp->le = build_tree(le,mid);
    tmp->ri = build_tree(mid+1,ri);
    return tmp;
}
void printTree(node* tmp,int le,int ri)
{
    cout << le << " " << ri << " " << tmp->cnti << " " << tmp->lazy << endl;
    if(le != ri)
    {
        int mid = (le + ri) >> 1;
        printTree(tmp->le,le,mid);
        printTree(tmp->ri,mid+1,ri);
    }
}
node* update_lazy(node* tmp,int le,int ri)
{
    if(tmp->lazy == 0)return tmp;
    tmp->cnti += tmp->lazy;
    if(le != ri)
    {
        tmp->le->lazy += tmp->lazy;
        tmp->ri->lazy += tmp->lazy;
    }
    tmp->lazy = 0;

    return tmp;
}
node* update_int(node* tmp,int le,int ri,int p,int q,int val)
{
    ///cout << tmp->cnti << " " << le << " " << ri << " " << p << " " << q << " " << val << endl;
    tmp = update_lazy(tmp,le,ri);
    if(p <= le && ri <= q)
    {
        tmp->cnti += val;
        if(le != ri)
        {
            tmp->le->lazy += val;
            tmp->ri->lazy += val;
        }
        return tmp;
    }
    int mid = (le + ri) >> 1;
    if(tmp->le != nullptr)tmp->le = update_int(tmp->le,le,mid,p,q,val);
    if(tmp->ri != nullptr)tmp->ri = update_int(tmp->ri,mid+1,ri,p,q,val);
    tmp->cnti = 0;
    if(tmp->le != nullptr)tmp->cnti += tmp->le->cnti;
    if(tmp->ri != nullptr)tmp->cnti += tmp->ri->cnti;
    return tmp;
}
int query(node* tmp,int le,int ri,int x)
{
    update_lazy(tmp,le,ri);
    if(x < le || x > ri)return 0;
    if(le == ri)
    {
        return tmp->cnti;
    }
    int mid = (le + ri) >> 1;
    int cntl = 0,cntr = 0;
    if(tmp->le != nullptr)cntl = query(tmp->le,le,mid,x);
    if(tmp->ri != nullptr)cntr = query(tmp->ri,mid+1,ri,x);
    return cntl + cntr;
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int i,j,p,tp,x;
    cin >> n;
    for(i = 2; i <= n; i++)
    {
        cin >> par[i];
        graph[par[i]].push_back(i);
    }
    find_paths(1);
    for(i = 0; i < m; i++)
    {
        roots[i] = new node;
        roots[i] = build_tree(0,path[i].size() - 1);
        ///printTree(roots[i],0,path[i].size() - 1);
        ///cout << "-----------" << endl;
    }
    /***for(i = 0; i < m; i++)
    {
        cout << path[i].size() << ": ";
        for(j = 0; j < path[i].size(); j++)
        {
            cout << path[i][j] << " ";
        }cout << endl;
    }*/
    cin >> q;
    for(i = 1; i <= q; i++)
    {
        cin >> tp >> x;
        if(tp == 1)
        {
            if(inf[x] == 1)continue;
            int f = x;
            while(f)
            {
                ///cout << f << endl;;
                int ind = find_ind(f);
                ///cout << ind << endl;
                roots[nump[f]] = update_int(roots[nump[f]],0,path[nump[f]].size() - 1,0,ind,1);
                ///printTree(roots[nump[f]],0,path[nump[f]].size() - 1);
                f = par[path[nump[f]][0]];
            }
            ///cout << endl;
            inf[x] = 1;

        }
        else if(tp == 2)
        {
            int f = x,prev = x;
            int cntc = 0, cntni = 0;
            while(f)
            {
                if(inf[f] == 1)
                {
                    inf[f] = 0;
                    cntc++;
                    for(j = 0; j < graph[f].size(); j++)
                    {
                        if(graph[f][j] != prev && inf[graph[f][j]] == 0)
                        {
                            inf[graph[f][j]] = 1;
                            cnti[graph[f][j]]++;
                            cntni++;
                        }
                    }
                }
                cnti[f] = cnti[f] - cntc + cntni;
                prev = f;
                f = par[f];
            }
        }
        else if(tp == 3)
        {
            if(inf[x] == 1)
            {
                inf[x] = 0;
                cnti[x]--;
            }
            for(j = 0; j < graph[x].size(); j++)
            {
                if(inf[graph[x][j]] == 1)
                {
                    inf[graph[x][j]] = 0;
                    cnti[graph[x][j]]--;
                    cnti[x]--;
                }
            }
        }
        else if(tp == 4)
        {
            ///cout << cnti[x] << endl;
            int ind = find_ind(x);
            cout << query(roots[nump[x]],0,path[nump[x]].size()-1,ind) << endl;;
        }
        /***for(j = 1; j <= n; j++)
        {
            cout << inf[j] << " ";
        }
        cout << endl;
        for(j = 1; j <= n; j++)
        {
            cout << cnti[j] << " ";
        }
        cout << endl;
        cout << "-----------" << endl;*/
    }
}
