#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl "\n"
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

int n;
vector<int> parents;
vector<vector<int>> adjList;

vector<bool> status;

void query1(int node) {
	status[node] = true;
}

vector<int> onPath;

void query2(int node) {
	fill(onPath.begin(), onPath.end(), false);
	int currNode = node;
	while (currNode != -1) {
		onPath[currNode] = true;
		currNode = parents[currNode];
	}

	currNode = node;
	while (currNode != -1) {
		if (status[currNode]) {
			for (int adjNode : adjList[currNode]) {
				if (!onPath[adjNode]) {
					status[adjNode] = true;
				}
			}
		}

		status[currNode] = false;

		currNode = parents[currNode];
	}
}

void query3(int node) {
	status[node] = false;
	for (int adjNode : adjList[node]) {
		status[adjNode] = false;
	}
}

int dfs(int node) {
	int answer = status[node];
	for (int adjNode : adjList[node]) {
		if (adjNode != parents[node]) {
			answer += dfs(adjNode);
		}
	}

	return answer;
}

int query4(int node) {
	return dfs(node);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n;

    parents.resize(n + 1, -1);
    adjList.resize(n + 1);
    for (int i = 2; i <= n; i++) {
    	cin >> parents[i];

    	adjList[parents[i]].emplace_back(i);
    }

    status.resize(n + 1, false);
    onPath.resize(n + 1);

    int q;
    cin >> q;

    while (q--) {
    	int type, node;
    	cin >> type >> node;

    	if (type == 1) {
    		query1(node);
    	} else if (type == 2) {
    		query2(node);
    	} else if (type == 3) {
    		query3(node);
    	} else {
    		cout << query4(node) << endl;
    	}
    }

    return EXIT_SUCCESS;
}
