#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl "\n"
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

class FenwickTree {
private:
	vector<int> tree;

	int query(int pos) {
		int answer = 0;
		for (int i = pos; i > 0; i -= i & -i) {
			answer += this->tree[i];
		}

		return answer;
	}

public:
	void update(int pos, int delta) {
		for (int i = pos; i < (int)this->tree.size(); i += i & -i) {
			this->tree[pos] += delta;
		}
	}

	int query(int l, int r) {
		return this->query(r) - this->query(l - 1);
	}

	void init(int n) {
		this->tree.resize(n + 1, 0);
	}
};

int n;
vector<int> parents;
vector<vector<int>> adjList;

int dfsTime = 0;
vector<int> pos, maxPos;

void dfs(int node) {
	pos[node] = maxPos[node] = ++dfsTime;
	for (int adjNode : adjList[node]) {
		if (adjNode != parents[node]) {
			dfs(adjNode);
			maxPos[node] = maxPos[adjNode];
		}
	}
}

FenwickTree tree;

void query1(int node) {
	tree.update(node, 1);
}

int query4(int node) {
	return tree.query(pos[node], maxPos[node]);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n;

    parents.resize(n + 1, -1);
    adjList.resize(n + 1);
    for (int i = 2; i <= n; i++) {
    	cin >> parents[i];

    	adjList[parents[i]].emplace_back(i);
    }

    pos.resize(n + 1);
    maxPos.resize(n + 1);
    dfs(1);

    tree.init(dfsTime);

    int q;
    cin >> q;

    while (q--) {
    	int type, node;
    	cin >> type >> node;

    	if (type == 1) {
    		query1(node);
    	} else if (type == 2) {
    		query2(node);
    	} else if (type == 3) {
    		query3(node);
    	} else {
    		cout << query4(node) << endl;
    	}
    }

    return EXIT_SUCCESS;
}
