#include <bits/stdc++.h>
#include "Sgame.h"

#pragma GCC optimize "-O3"

#define endl "\n"
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

const int BASE1 = 29;
const int MOD1 = (int)1e9 + 7;
const int BASE2 = 31;
const int MOD2 = (int)1e9 + 9;

int n;
vector<pair<int, int>> prefixHash;
vector<pair<int, int>> powBase;

vector<int> answerForLen;

pair<int, int> getSubstringHash(int l, int r) {
    pair<int, int> hash1 = prefixHash[r];

    if (l == 0) {
        return hash1;
    }

    pair<int, int> hash2 = prefixHash[l - 1];

    hash2.first = ((long long)hash2.first * powBase[r - l + 1].first) % MOD1;
    hash2.second = ((long long)hash2.second * powBase[r - l + 1].second) % MOD2;

    hash1.first = (hash1.first - hash2.first + MOD1) % MOD1;
    hash1.second = (hash1.second - hash2.second + MOD2) % MOD2;

    return hash1;
}

void start (char str[]) {
    n = strlen(str);

    prefixHash.resize(n);
    prefixHash[0] = {str[0] - 'a' + 1, str[0] - 'a' + 1};
    for (int i = 1; i < n; i++) {
        prefixHash[i].first = ((long long)prefixHash[i - 1].first * BASE1 + (str[i] - 'a' + 1)) % MOD1;
        prefixHash[i].second = ((long long)prefixHash[i - 1].second * BASE2 + (str[i] - 'a' + 1)) % MOD2;
    }

    powBase.resize(n + 1);
    powBase[0] = {1, 1};
    for (int i = 1; i <= n; i++) {
        powBase[i].first = ((long long)powBase[i - 1].first * BASE1) % MOD1;
        powBase[i].second = ((long long)powBase[i - 1].second * BASE2) % MOD2;
    }


    answerForLen.resize(n + 1, 0);
    for (int len = 1; len <= k; len++) {
        map<pair<int, int>, int> cnt;
        for (int start = 0; start <= n - len; start++) {
            pair<int, int> hash = getSubstringHash(start, start + len - 1);
            cnt[hash]++;
            if (cnt[hash] > answerForLen[len]) {
                answerForLen[len] = cnt[hash];
            }
        }
    }
}

int round (int m, int k) {
    int maxCnt = 0;
    for (int len = m; len <= k; len++) {
        if (answerForLen[len] > maxCnt) {
            maxCnt = answerForLen[len];
        }
    }

    return maxCnt;
}
