#include <bits/stdc++.h>
#include "Sgame.h"

#pragma GCC optimize "-O3"

#define endl "\n"
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

const int BASE1 = 29;
const int MOD1 = (int)1e9 + 7;
const int BASE2 = 31;
const int MOD2 = (int)1e9 + 9;

class String {
public:
    pair<int, int> hash;
    int start;
    int cnt;

    String(pair<int, int> hash, int start, int cnt) {
        this->hash = hash;
        this->start = start;
        this->cnt = cnt;
    }

    bool operator <(const String &other) const {
        return this->cnt > other.cnt;
    }
};

int n;
vector<pair<int, int>> prefixHash;
vector<pair<int, int>> powBase;

vector<int> answerForLen;

pair<int, int> getSubstringHash(int l, int r) {
    pair<int, int> hash1 = prefixHash[r];

    if (l == 0) {
        return hash1;
    }

    pair<int, int> hash2 = prefixHash[l - 1];

    hash2.first = ((long long)hash2.first * powBase[r - l + 1].first) % MOD1;
    hash2.second = ((long long)hash2.second * powBase[r - l + 1].second) % MOD2;

    hash1.first = (hash1.first - hash2.first + MOD1) % MOD1;
    hash1.second = (hash1.second - hash2.second + MOD2) % MOD2;

    return hash1;
}

void start (char str[]) {
    n = strlen(str);

    prefixHash.resize(n);
    prefixHash[0] = {str[0] - 'a' + 1, str[0] - 'a' + 1};
    for (int i = 1; i < n; i++) {
        prefixHash[i].first = ((long long)prefixHash[i - 1].first * BASE1 + (str[i] - 'a' + 1)) % MOD1;
        prefixHash[i].second = ((long long)prefixHash[i - 1].second * BASE2 + (str[i] - 'a' + 1)) % MOD2;
    }

    powBase.resize(n + 1);
    powBase[0] = {1, 1};
    for (int i = 1; i <= n; i++) {
        powBase[i].first = ((long long)powBase[i - 1].first * BASE1) % MOD1;
        powBase[i].second = ((long long)powBase[i - 1].second * BASE2) % MOD2;
    }
}

int m, k;

int getCnt(pair<int, int> hash, int len) {
    int cnt = 0;
    for (int start = 0; start <= n - len; start++) {
        if (getSubstringHash(start, start + len - 1) == hash) {
            cnt++;
        }
    }

    return cnt;
}

bool legit(String str) {
    for (int i = str.start - 1; i > 0; i--) {
        if (str.start + m - i <= k) {
            continue;
        }

        if (getCnt(getSubstringHash(i, str.start + m - 1), str.start + m - i) >= str.cnt) {
            return false;
        }
    }

    for (int i = str.start + m; i < n; i++) {
        if (i - str.start + 1 <= k) {
            continue;
        }

        if (getCnt(getSubstringHash(str.start, i), i - str.start + 1) >= str.cnt) {
            return false;
        }
    }

    return true;
}

int round (int m, int k) {
    ::k = k;
    ::m = m;

    int maxCnt = 0;
    for (int start = 0; start <= n - m; start++) {
        pair<int, int> hash = getSubstringHash(start, start + m - 1);
        int cnt = getCnt(hash, m);
        if (legit(String(hash, start, cnt))) {
            if (cnt > maxCnt) {
                maxCnt = cnt;
            }
        }
    }

    return maxCnt;
}
