#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl "\n"
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

int n, m;
vector<vector<int>> adjList;

vector<int> color;

void f(int node) {
	queue<int> q;
	q.emplace(node);

	while (!q.empty()) {
		int now = q.front();
		q.pop();

		if (color[now] != -1) {
			continue;
		}

		set<int> denidedColors;
		for (int adjNode : adjList[now]) {
			if (color[adjNode] != -1) {
				denidedColors.emplace(color[adjNode]);
			}
		}

/*
		trace(now);
		copy(denidedColors.begin(), denidedColors.end(), ostream_iterator<int>(cerr, " "));
		cerr << endl;
		copy(adjList[now].begin(), adjList[now].end(), ostream_iterator<int>(cerr, " "));
		cerr << endl;
		*/

		int minColor = 1;
		while (denidedColors.find(minColor) != denidedColors.end()) {
			minColor++;
		}

		color[now] = minColor;

		for (int adjNode : adjList[now]) {
			if (color[adjNode] == -1) {
				q.emplace(adjNode);
			}
		}
	}
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n >> m;

    adjList.resize(n + 1);
    for (int i = 1; i <= m; i++) {
        int u, v;
        cin >> u >> v;

        adjList[u].emplace_back(v);
        adjList[v].emplace_back(u);
    }

    for (int i = 1; i < n; i++) {
    	adjList[i].emplace_back(i + 1);
    	adjList[i + 1].emplace_back(i);
    }
    adjList[1].emplace_back(n);
    adjList[n].emplace_back(1);

    color.resize(n + 1, -1);

    int minAnswer = (int)1e9;
    vector<int> answer;

    for (int i = 1; i <= n; i++) {
    	fill(color.begin(), color.end(), -1);

    	bfs(i);

    	int currAnswer = *max_element(next(color.begin()), color.end());
    	if (currAnswer < minAnswer) {
    		minAnswer = currAnswer;
    		answer = color;
    	}
    }
    
    cout << minAnswer << endl;
    for (int i = 1; i <= n; i++) {
    	cout << answer[i] << " \n"[i == n];
    }

    return EXIT_SUCCESS;
}
