#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl "\n"
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

int n, m;
vector<vector<int>> adjList;

vector<int> answer;
vector<bool> used;

int bfs(int node) {
    fill(used.begin(), used.end(), false);
    queue<int> q;
    q.emplace(node);
    answer[node] = 1;
    int cnt = 1;

    while (!q.empty()) {
        int now = q.front();
        q.pop();

        for (int adjNode : adjList[node]) {
            if (!used[adjNode]) {
                used[adjNode] = true;
                if (answer[now] == 1) {
                    answer[adjNode] = 2;
                    if (cnt == 1) {
                        cnt++;
                    }
                } else {
                    answer[adjNode] = 1;
                }
                q.emplace(adjNode);
            }
        }
    }

    return cnt;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n >> m;

    adjList.resize(n + 1);
    for (int i = 1; i <= m; i++) {
        int u, v;
        cin >> u >> v;

        adjList[u].emplace_back(v);
        adjList[v].emplace_back(u);
    }

    used.resize(n + 1);
    answer.resize(n + 1);
    for (int i = 1; i <= n; i++) {
        if (!used[i]) {
            bfs(i);
        }
    }

    cout << (*max_element(answer.begin(), answer.end())) << endl;
    for (int i = 1; i <= n; i++) {
        cout << answer[i] << " \n"[i == n];
    }

    return EXIT_SUCCESS;
}
