#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl "\n"
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

int n, m;
vector<vector<int>> adjList;

vector<int> color;

void f(int node) {
	set<int> denidedColors;
	for (int adjNode : adjList[node]) {
		if (color[adjNode] != -1) {
			denidedColors.emplace(color[adjNode]);
		}
	}

	int minColor = 1;
	while (denidedColors.find(minColor) != denidedColors.end()) {
		minColor++;
	}

	color[node] = minColor;

	for (int adjNode : adjList[node]) {
		if (color[adjNode] == -1) {
			f(adjNode);
		}
	}
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n >> m;

    adjList.resize(n + 1);
    for (int i = 1; i <= m; i++) {
        int u, v;
        cin >> u >> v;

        adjList[u].emplace_back(v);
        adjList[v].emplace_back(u);
    }

    color.resize(n + 1, -1);
    for (int i = 1; i <= n; i++) {
    	if (color[i] == -1) {
    		f(i);
    	}
    }

    int maxColor = 0;
    for (int i = 1; i <= n; i++) {
    	if (color[i] > maxColor) {
    		maxColor = color[i];
    	}
    }
    cout << maxColor << endl;
    for (int i = 1; i <= n; i++) {
    	cout << color[i] << " \n"[i == n];
    }

    return EXIT_SUCCESS;
}
