#include <bits/stdc++.h>

using namespace std;

const int MAX_N = 500000;

vector<int> graph[1+MAX_N];
map<int, bool> adj[1+MAX_N];
int color[1+MAX_N];
bool bipartit = true;

void bipart(int nod, int col = 1) {
	color[nod] = col;
	for(auto it: graph[nod])
		if(color[it] == 0)
			bipart(it, 3 - col);
		else if(color[nod] == color[it]) {
			bipartit = false;
		}
}

int main() {
	int N, M;
	scanf("%d%d", &N, &M);
	for(int i = 0; i < M; ++i) {
		int a, b;
		scanf("%d%d", &a, &b);
		graph[a].push_back(b);
		graph[b].push_back(a);
		adj[a][b] = adj[b][a] = true;
	}

	for(int i = 1; i <= N; ++i)
		sort(graph[i].begin(), graph[i].end());
	
	for(int i = 1; i <= N; ++i)
		if(color[i] == 0)
			bipart(i);
	
	if(bipartit)
		printf("2\n");
	else {
		printf("3\n");
		int a, b;
		a = 1;
		b = 2;

		color[a] = 1;
		color[b] = 2;

		while(a != b) {
			int na = (a - 1), nb = b + 1;
			if(na == 0) na = N;
			if(nb == N + 1) nb = 1;

			if(adj[na][b]) {
				color[na] = 1 + 2 + 3 - color[a] - color[b];
				a = na;
			} else {
				color[nb] = 1 + 2 + 3 - color[a] - color[b];
				b = nb;
			}
		}
	}

	for(int i = 1; i <= N; ++i)
		printf("%d ", color[i]);

	return 0;
}

