#include <bits/stdc++.h>
#include "Sgame.h"

using namespace std;

const int MOD1 = (int) 1e9 + 7;
const int MOD2 = (int) 1e9 + 9;

inline void mod(int &x, int md) {
    if(x >= md) x -= md;
}
inline void add(int &x, int y, int md) {
    x += y;
    mod(x, md);
}
inline void sub(int &x, int y, int md) {
    x -= y;
    if(x < 0) x += md;
}
inline void mul(int &x, int y, int md) {
    x = (1LL * x * y) % md;
}

struct Hash {
    int a, b;
    Hash(int _a, int _b) {
        a = _a, b = _b;
    }

    Hash() {
        a = 0, b = 0;
    }

    bool operator <(const Hash &other) const {
        if(a == other.a) return b < other.b;
        return a < other.a;
    }

    Hash operator +(const int x) {
        Hash ans(a, b);
        add(ans.a, x, MOD1);
        add(ans.b, x, MOD2);
        return ans;
    }

    Hash operator -(const int x) {
        Hash ans(a, b);
        sub(ans.a, x, MOD1);
        sub(ans.b, x, MOD2);
        return ans;
    }

    Hash operator +(const Hash &other) {
        Hash ans(a, b);
        add(ans.a, other.a, MOD1);
        add(ans.b, other.b, MOD2);
        return ans;
    }

    Hash operator -(const Hash &other) {
        Hash ans(a, b);
        sub(ans.a, other.a, MOD1);
        sub(ans.b, other.b, MOD2);
        return ans;
    }

    Hash operator *(const int x) {
        Hash ans(a, b);
        ans.a = (1LL * ans.a * x) % MOD1;
        ans.b = (1LL * ans.b * x) % MOD2;
        return ans;
    }

    void operator =(const Hash &other) {
        a = other.a, b = other.b;
    }

    bool operator ==(const Hash &other) {
        return a == other.a && b == other.b;
    }
};

const int MAXN = (int) 5e5;
const int B = 71;
char str[MAXN + 1];
Hash pw[MAXN + 1];
int dp[101][101], K[101][101];
int n = 0;

void start(char *w) {
    while(w[n] != '\0') {
        str[n + 1] = w[n];
        n++;
    }
    str[0] = 'a' - 1;

    pw[0] = Hash(1, 1);
    for(int i = 1; i <= n; i++) {
        pw[i] = pw[i - 1] * B;
    }

    int i;
    for(int l = 1; l <= n; l++) {
        for(int r = l; r <= n; r++) {
            Hash cur(0, 0);
            for(i = l; i <= r; i++) {
                cur = cur * B + str[i] - 'a' + 1;
            }
            Hash hsh(0, 0);
            vector <Hash> arr;
            int len = r - l + 1;
            for(i = 1; i <= n; i++) {
                hsh = hsh * B + str[i] - 'a' + 1;
                if(i >= len) {
                    hsh = hsh - pw[len] * (str[i - len] - 'a' + 1);
                    arr.push_back(hsh);
                }
            }
            sort(arr.begin(), arr.end());
            dp[l][r] = upper_bound(arr.begin(), arr.end(), cur) - lower_bound(arr.begin(), arr.end(), cur);
        }
    }

    for(int l = 1; l <= n; l++) {
        for(int r = l; r <= n; r++) {
            //cerr << dp[l][r] << " ";
            for(i = 1; i <= l; i++) {
                int res = r;
                for(int step = 1 << 6; step; step >>= 1) {
                    if(res + step <= n && dp[l][r] == dp[i][res + step]) {
                        res += step;
                    }
                }
                K[l][r] = max(K[l][r], res - l + 1);
            }
        }
        //cerr << "\n";
    }
}

int round(int m, int k) {
    int ans = 0;
    for(int l = 1; l <= n; l++) {
        for(int r = l + m - 1; r < l + k; r++) {
            if(K[l][r] <= k) {
                ans = max(ans, dp[l][r]);
            }
        }
    }
    return ans;
}
