#include <iostream>
#include <vector>

using namespace std;

const int MAX_N = 3e5 + 10;

int sz[MAX_N];
int lvl[MAX_N];
int p[20][MAX_N];

int ix[MAX_N];
int inv[MAX_N];
int top_node[MAX_N];

int climb(int x, int l) {
    for (int i = 19; i >= 0; i--)
        if ((1 << i) <= l) {
            x = p[i][x];
            l -= (1 << i);
        }
    return x;
}

vector<int> sons[MAX_N];

void dfs_calc_sz(int u) {
    sz[u] = 1;
    for (int v : sons[u]) {
        lvl[v] = lvl[u] + 1;
        dfs_calc_sz(v);
        sz[u] += sz[v];
    }
}

int hp_ix = 0;
void dfs_hp(int u) {
    ix[u] = hp_ix++;
    inv[ix[u]] = u;
    if (ix[u] == ix[p[0][u]] + 1)
        top_node[u] = top_node[p[0][u]];
    else
        top_node[u] = u;

    if (sons[u].size()) {
        int mx = sons[u][0];
        for (int i = 1; i < sons[u].size(); i++)
            if (sz[mx] < sz[sons[u][i]])
                mx = sons[u][i];
        dfs_hp(mx);
        for (int v : sons[u])
            if (v != mx)
                dfs_hp(v);
    }
}

int aint[MAX_N * 4];
int lazy[MAX_N * 4];

void propag(int n, int st, int dr) {
    if (lazy[n]) {
        aint[n] = lazy[n] = 0;
        if (st != dr) {
            lazy[n * 2 + 1] = lazy[n * 2 + 2] = 1;
        }
    }
}

void infest(int x, int n = 0, int st = 0, int dr = MAX_N - 1) {
    propag(n, st, dr);
    if (st == dr) {
        aint[n] = 1;
        return;
    }

    int mid = (st + dr) / 2;
    if (x <= mid) {
        infest(x, n * 2 + 1, st, mid);
    } else {
        infest(x, n * 2 + 2, mid + 1, dr);
    }
    aint[n] = aint[n * 2 + 1] + aint[n * 2 + 2];
}

void desinfest(int st, int dr, int n = 0, int nst = 0, int ndr = MAX_N - 1) {
    propag(n, nst, ndr);
    if (st == nst && dr == ndr) {
        lazy[n] = 1;
        aint[n] = 0;
        return;
    }

    int mid = (nst + ndr) / 2;
    if (st <= mid)
        desinfest(st, min(mid, dr), n * 2 + 1, nst, mid);
    if (dr > mid)
        desinfest(max(mid + 1, st), dr, n * 2 + 2, mid + 1, ndr);

    aint[n] = aint[n * 2 + 1] + aint[n * 2 + 2];
}

int query(int st, int dr, int n = 0, int nst = 0, int ndr = MAX_N - 1) {
    propag(n, nst, ndr);
    if (st == nst && dr == ndr || !aint[n]) {
        return aint[n];
    }

    int mid = (nst + ndr) / 2;
    int ans = 0;
    if (st <= mid)
        ans += query(st, min(mid, dr), n * 2 + 1, nst, mid);
    if (dr > mid)
        ans += query(max(mid + 1, st), dr, n * 2 + 2, mid + 1, ndr);

    return ans;
}

vector<int> to_spread;
int x0;
void spread(int st, int dr, int n = 0, int nst = 0, int ndr = MAX_N - 1) {
    propag(n, nst, ndr);
    if (!aint[n])
        return;

    if (nst == ndr) {
        for (int u : sons[inv[ndr]])
            if (climb(x0, lvl[x0] - lvl[u]) != u)
                to_spread.push_back(u);
        aint[n] = 0;
    } else {
        int mid = (nst + ndr) / 2;
        if (st <= mid)
            spread(st, min(mid, dr), n * 2 + 1, nst, mid);
        if (dr > mid)
            spread(max(mid + 1, st), dr, n * 2 + 2, mid + 1, ndr);
        aint[n] = aint[n * 2 + 1] + aint[n * 2 + 2];
    }
}


int main() {
//    freopen("input.txt", "r", stdin);

    int n, q;
    cin >> n;

    for (int i = 2; i <= n; i++) {
        cin >> p[0][i];
        sons[p[0][i]].push_back(i);
    }

    for (int l = 1; l < 20; l++)
        for (int i = 1; i <= n; i++)
            p[l][i] = p[l - 1][p[l - 1][i]];

    lvl[1] = 1;
    dfs_calc_sz(1);
    dfs_hp(1);

    for (cin >> q; q > 0; q--) {
        int t, x;
        cin >> t >> x;

        if (t == 1)
            infest(ix[x]);
        if (t == 2) {
            x0 = x;
            to_spread.clear();
            while (lvl[x] >= 1) {
                spread(ix[top_node[x]], ix[x]);
                x = p[0][top_node[x]];
            }
            for (int u : to_spread)
                infest(ix[u]);

//            cout << x0 << ": ";
//            for (int u : to_spread)
//                cout << u << ' ';
//            cout << endl;
        }
        if (t == 3) {
            desinfest(ix[x], ix[x]);
            for (int u : sons[x])
                desinfest(ix[u], ix[u]);
        } if (t == 4)
            cout << query(ix[x], ix[x] + sz[x] - 1) << '\n';

//    cerr << "HEllloooo" << endl;
    }
    return 0;
}
