#include <iostream>
#include <algorithm>
#include <cstdio>

using namespace std;

const int MAX_N = 5e5 + 10;

int color[MAX_N];
pair<int, int> e[MAX_N];

bool cmp(pair<int, int> a, pair<int, int> b) {
    return (a.first != b.first ? a.first < b.first : a.second > b.second);
//    return a.second - a.first < b.second - b.first;
}

int ix = 0, n, m;
void solve(int st, int dr) {
    int x = color[st];
    while (st < dr) {
        color[st] = x;
//        cout << st << ": ";
//        for (int i = 1; i <= n; i++)
//            cout << color[i] << ' ';
//        cout << endl;
        if (ix < m && e[ix].first == st) {
            if (e[ix].second == dr)
                ix++;
            else {
//                cout << e[ix].first << ' ' << e[ix].second << endl;
                st = e[ix++].second;
                color[st] = x = (x ^ color[dr]);
                solve(e[ix - 1].first, e[ix - 1].second);
            }
        } else {
            st++;
            x ^= color[dr];
        }
    }
}

int main() {
    freopen("input.txt", "r", stdin);
    cin >> n >> m;

    bool twocolors = (n % 2 == 0);
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        if (u % 2 == v % 2)
            twocolors = 0;

        if (u > v)
            swap(u, v);
        e[i].first = u;
        e[i].second = v;
    }
//    e[m].first = 1;
//    e[m].second = n;
//    m++;

    if (twocolors) {
        cout << 2 << endl;
        for (int i = 0; i < n; i+= 2)
            cout << "1 2 ";
        cout << endl;
    } else {
        sort(e, e + m, cmp);
        color[1] = 1;
        color[n] = 2;
        solve(1, n);
        cout << 3 << endl;
        for (int i = 1; i <= n; i++)
            cout << color[i] << ' ';
        cout << endl;
    }

    return 0;
}
