#include <iostream>
#include <algorithm>
#include <cstdio>

using namespace std;

const int MAX_N = 5e5 + 10;

int color[MAX_N];
pair<int, int> e[MAX_N];

const int BSIZE = 10000;
int bix = 0;
char buf[BSIZE];

void flushbuf() {
    fwrite(buf, 1, bix, stdout);
    bix = 0;
}

void putch(char ch) {
    if (bix == BSIZE)
        flushbuf();
    buf[bix++] = ch;
}

bool cmp(pair<int, int> a, pair<int, int> b) {
    return (a.first != b.first ? a.first < b.first : a.second > b.second);
}

int ix = 0, n, m;
void solve(int st, int dr) {
    int x = color[st];
    while (st < dr) {
        color[st] = x;
        if (ix < m && e[ix].first == st) {
            if (e[ix].second == dr)
                ix++;
            else {
                st = e[ix++].second;
                color[st] = x = (x ^ color[dr]);
                solve(e[ix - 1].first, e[ix - 1].second);
            }
        } else {
            st++;
            x ^= color[dr];
        }
    }
}

int main() {
    freopen("input.txt", "r", stdin);
    cin >> n >> m;

    bool twocolors = (n % 2 == 0);
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        if (u % 2 == v % 2)
            twocolors = 0;

        if (u > v)
            swap(u, v);
        e[i].first = u;
        e[i].second = v;
    }

    if (twocolors) {
        putch('2');
        putch('\n');
        for (int i = 0; i < n; i+=2) {
            putch('1');
            putch(' ');
            putch('2');
            putch(' ');
        }
        putch('\n');
    } else {
        sort(e, e + m, cmp);
        color[1] = 1;
        color[n] = 2;
        solve(1, n);
        putch('3');
        putch('\n');
        for (int i = 1; i <= n; i++) {
            putch('0' + color[i]);
            putch(' ');
        }
        putch('\n');
    }
    flushbuf();

    return 0;
}
