#include <bits/stdc++.h>
using namespace std;

const int DIM = 500005;

int val[DIM];
vector<int> edg[DIM];
deque<int> gph[DIM];

int _n;
int nextNode(int x) {
	++x;
	if (x > _n)
		x -= _n;
	return x;
}

void addEdge(int x, int y) {
	gph[x].push_back(y);
	gph[y].push_back(x);
}

void dfs(int x, int y, int z, bool ok) {
	if (y == z)
		return;
	if (!ok) {
		sort(gph[x].begin(), gph[x].end());
		while (gph[x].front() < x) {
			gph[x].push_back(gph[x].front());
			gph[x].pop_front();
		}
	}
	int vl0 = 0, vl1 = 0;
	for (int i = 0; i < gph[x].size(); ++i) {
		if (i & 1 and !vl1)
			vl1 = val[gph[x][i]];
		if (!(i & 1) and !vl0)
			vl0 = val[gph[x][i]];
	}
	while (!vl0 or vl0 == vl1 or vl0 == val[x])
		++vl0;
	while (!vl1 or vl1 == vl0 or vl1 == val[x])
		++vl1;
	for (int i = 0; i < gph[x].size(); ++i) {
		if (i & 1)
			val[gph[x][i]] = vl1;
		else
			val[gph[x][i]] = vl0;
	}
	if (ok)
		dfs(gph[x][0], nextNode(gph[x][0]), gph[x][1], false);
	else {
		for (int i = 1; i < gph[x].size(); ++i)
			dfs(x, gph[x][i - 1], gph[x][i], true);
	}
}

void check(int x, bool &ok, int v = 1) {
	val[x] = v;
	for (int y : edg[x]) {
		if (!val[y])
			check(y, ok, 3 - v);
		else if (val[y] == val[x])
			ok = false;
	}
}

int main(void) {
#ifdef HOME
	freopen("circle.in", "r", stdin);
	freopen("circle.out", "w", stdout);
#endif
	int n, m;
	scanf("%d %d", &n, &m); _n = n;
	for (int i = 1; i <= m; ++i) {
		int x, y;
		cin >> x >> y;
		if (x > y)
			swap(x, y);
		edg[x].push_back(y);
		edg[y].push_back(x);

		if ((y - x) == 1 or (x == 1 and y == n)) 
			continue;
		addEdge(x, y);	
	}
	for (int i = 1; i < n; ++i)
		addEdge(i, i + 1);
	addEdge(n, 1);
	// check if bipartite
	{
		bool ok = true;
		for (int i = 1; i <= n; ++i) 
			if (!val[i])
				check(i, ok);
		if (ok) {
			printf("2\n");
			for (int i = 1; i <= n; ++i)
				printf("%d ", val[i]);
			return 0;
		}
	}
	memset(val, 0, sizeof val);
	val[2] = 1;
	int x = 1;
	dfs(2, 3, 1, false);
	printf("3\n");
	for (int i = 1; i <= n; ++i)
		printf("%d ", val[i]);
	return 0;
}
