#include <bits/stdc++.h>

using namespace std;

const int Nmax = 3e5 + 5;

int n, tmp, q;
int T[Nmax], w[Nmax];
int L[Nmax], R[Nmax];
vector<int> v[Nmax];
bool state[Nmax];

set<int> S[Nmax];

class AIB
{
    int a[Nmax];
    int ub(int x) { return (x&(-x)); }

public:
    int query(int l, int r)
    {
        int ans = 0;
        for(; r; r-=ub(r)) ans += a[r];
        for(--l; l; l-=ub(l)) ans -= a[l];
        return ans;
    }
    void update(int p, int add)
    {
        for(; p<=n; p+=ub(p)) a[p] += add;
    }

} aib;

void dfs(int node)
{
    w[node] = 1;
    L[node] = ++tmp;
    for(auto it : v[node])
    {
        dfs(it);
        w[node] += w[it];
    }
    R[node] = tmp;
}


void prepare()
{
    dfs(1);
}

static void become_infested(int node) /// 1
{
    if(state[node]) return;
    state[node] = 1;
    S[T[node]].insert(node);
    aib.update(L[node], +1);
}

void move_to_neg(int x, int prv = -1) /// 2
{
    if(state[x])
    {
        for(auto it : v[x])
            if(it != prv)
                become_infested(it);    
        state[x] = 0;
        aib.update(L[x], -1);
    }

   if(x == 1) return; 
   move_to_neg(T[x], x);
}

void clear_neg(int node) /// 3
{
    if(state[node])
    {
        aib.update(L[node], -1);
        if(node!=1) S[T[node]].erase(node);
        state[node] = 0;
    }

    for(auto it : S[node])
        aib.update(L[it], -1), state[it] = 0;

    S[node].clear();
}

int query(int node) /// 4
{
    return aib.query(L[node], R[node]);
}

int main()
{
    //freopen("input", "r", stdin);
    cin.sync_with_stdio(false); cin.tie(0);

    cin >> n;
    int i;
    for(i=2; i<=n; ++i)
    {
        cin >> T[i];
        v[T[i]].push_back(i);
    }

    prepare();

    int Q;
    cin >> Q;

    while(Q--)
    {
        int tip, x;
        cin >> tip >> x;

        if(tip == 1) become_infested(x);
            else if(tip == 2) move_to_neg(x);
                else if(tip == 3) clear_neg(x);
                    else cout << query(x) << '\n';
    }

    return 0;
}

