#include <bits/stdc++.h>

using namespace std;

const int Nmax = 5e5 + 5;

char w[Nmax], rw[Nmax];

int lcp1[Nmax], lcp2[Nmax], ord1[Nmax], ord2[Nmax];
int n;
int c[21][Nmax];
pair<pair<int,int>, int> vl[Nmax];

int st[Nmax];
int best_len[Nmax];



struct candidates
{
    int len, start, occur;
    bool operator < (const candidates &other) const
    {
        if(len == other.len)
        {
            if(start == other.start) return occur < other.occur;
            return start < other.start;
        }
        return len < other.len;
    }
    bool operator == (const candidates &other) const
    {
        return len == other.len && occur == other.occur && start == other.start;
    }
};
vector<candidates> cand, cand1, cand2;


#define left_son (node<<1)
#define right_son ((node<<1)|1)
#define mid ((st+dr)>>1)
class Aint
{
    int a[Nmax<<2];
public:
    int get_min(int node, int st, int dr, int L, int R)
    {
        if(L <= st && dr <= R)
            return a[node];

        int res = 2e9;
        if(L <= mid) res = min(res, get_min(left_son, st, mid, L, R));
        if(mid < R) res = min(res, get_min(right_son, mid+1, dr, L, R));
        return res;
    }

    void build(int node, int st, int dr, int A[])
    {
        if(st == dr)
        {
            a[node] = A[st];
            return;
        }
        build(left_son, st, mid, A);
        build(right_son, mid+1, dr, A);
        a[node] = min(a[left_son], a[right_son]);
    }
} aint;



int get_lcp(int x, int y)
{
    int i, nr = 0;

    for(i=19; i>=0; --i)
        if(x + (1<<i) - 1 <= n && y + (1<<i) - 1 <= n && c[i][x] == c[i][y]) nr += (1<<i), x += (1<<i), y += (1<<i);

    return nr;
}

void suffix_array(char w[], int lcp[], int ord[])
{
    int i, step;
    for(i=1; i<=n; ++i) c[0][i] = w[i] - 'a' + 1;

    for(step=1; step<20; ++step)
    {
        for(i=1; i<=n; ++i)
        {
            vl[i].second = i;
            vl[i].first.first = c[step-1][i];
            vl[i].first.second = (i + (1<<(step-1)) <= n ? c[step-1][i + (1<<(step-1))] : 0);
        }

        sort(vl+1, vl+n+1);

        int cnn = 0;
        for(i=1; i<=n; ++i)
        {
            if(vl[i].first != vl[i-1].first) ++cnn;
            c[step][vl[i].second] = cnn;
        }
    }

    for(i=2; i<=n; ++i)
    {
        ord[i-1] = vl[i-1].second;
        ord[i] = vl[i].second;
        lcp[i] = get_lcp(ord[i-1], ord[i]);
    }
}

int get_min(int a[], int x, int y)
{
    int ans = n+1;
    int i;
    for(i=x; i<=y; ++i) ans = min(ans, a[i]);
    return ans;
}

void prepare(int lcp[], int ord[], vector<candidates> &cand)
{
    int i, j, k;
    lcp[1] = -1; lcp[n+1] = -1;

    for(i=1; i<=n; ++i)
        for(j=i+1; j<=n; ++j)
        {
            int mn = get_min(lcp, i+1, j);
            if(mn > lcp[i] && mn > lcp[j+1])
                cand.push_back({mn, get_min(ord, i, j), j-i+1});
        }
    return ;
/*

    aint.build(1, 1, n, ord);


    int i;
    int nr = 0;
    st[0] = 1;
    lcp[1] = -1;

    for(i=2; i<=n; ++i)
    {
        while(lcp[i] <= lcp[st[nr]])
        {
            cand.push_back({ lcp[st[nr]], get_min(ord, st[nr-1], i-1), (i-1) - st[nr-1] + 1 });
            --nr;
        }
        st[++nr] = i;
    }

    while(nr)
    {
        cand.push_back({ lcp[st[nr]], get_min(ord, st[nr-1], n), n - st[nr-1] + 1 });
        --nr;
    }
*/
}

void start(char word[])
{
    int i;
    n = strlen(word);

    for(i=1; i<=n; ++i) w[i] = word[i-1];
    for(i=1; i<=n; ++i) rw[i] = word[n-i];

    suffix_array(w, lcp1, ord1);
    suffix_array(rw, lcp2, ord2);

    for(i=1; i<=n; ++i)
        ord2[i] = n - ord2[i] + 1;

    prepare(lcp1, ord1, cand1);
    prepare(lcp2, ord2, cand2);

 //   for(i=1; i<=n; ++i)
    //    if(lcp1[i-1] < n-ord1[i]+1 && lcp1[i] < n-ord1[i]+1) cand1.push_back({n-ord1[i]+1, i, 1});

   // for(i=1; i<=n; ++i)
      //  if(lcp2[i-1] < ord2[i] && lcp2[i] < ord2[i]) cand2.push_back({ord2[i], i, 1});

    for(auto &it : cand2)
        it.start -= it.len - 1;

    sort(cand1.begin(), cand1.end());
    sort(cand2.begin(), cand2.end());

    for(auto it : cand1)
    {
        int pos = lower_bound(cand2.begin(), cand2.end(), it) - cand2.begin();
        if(0<=pos && pos<cand2.size() && it == cand2[pos])
            cand.push_back(it);
    }

    cand.push_back({n, 1, 1});

    for(i=1; i<=n; ++i) best_len[i] = 1e9;
    for(auto it : cand)
        best_len[it.len] = min(best_len[it.len], -it.occur);

    aint.build(1, 1, n, best_len);
}

int round(int m, int k)
{
    if(m > k) return 0;
    return -aint.get_min(1, 1, n, m, k); /// aici vreau maxim
}
