#include <bits/stdc++.h>
using namespace std;

const int N = 5e5 + 5;

struct Nod {
	int lazy;
	int sum; };

struct Chain {
	int fst, snd, lst, subarb;
	int fst_child, lst_child; };

vector<int> g[N];
Nod pom[N * 4];
Chain chain[N];
int h[N], far[N], siz[N], line[N], st_l[N], dr_l[N], my_lin[N], my_chn[N], subarb[N], child[N];
bool f[N];

vector<int> updates;
int n, q, ql, qr, qval, lptr;

static inline void prop(int nod, int st, int dr) {
	switch (pom[nod].lazy) {
	case 0: return;
	case 1: { // set to zero
		pom[2 * nod].lazy = 1;
		pom[2 * nod + 1].lazy = 1;
		pom[nod].sum = 0;
		break; }
	case 2: { // set to one
		pom[2 * nod].lazy = 2;
		pom[2 * nod + 1].lazy = 2;
		pom[nod].sum = dr - st + 1;
		break; } } }

static inline int eval(int nod, int st, int dr) {
	switch (pom[nod].lazy) {
	case 0: return pom[nod].sum;
	case 1: return 0;
	case 2: return dr - st + 1; } }

static void update(int nod, int st, int dr) {
	if (ql > qr) return;
	if (ql <= st && dr <= qr) {
		switch (qval) {
		case 0: break; // never
		case 1: {
			pom[nod].sum = 0;
			pom[nod].lazy = 1;
			break; }
		case 2: {
			pom[nod].sum = dr - st  + 1;
			pom[nod].lazy = 2;
			break; } }
		return; }
	prop(nod, st, dr);
	int mid = (st + dr) / 2;
	if (ql <= mid)
		update(2 * nod, st, mid);
	if (mid < qr)
		update(2 * nod + 1, mid + 1, dr);
	pom[nod] = {0, eval(2 * nod, st, mid) + eval(2 * nod + 1, mid + 1, dr)};
}

static int query(int nod, int st, int dr) {
	if (ql > qr) return 0;
	if (ql <= st && dr <= qr) {
		switch (pom[nod].lazy) {
		case 0: return pom[nod].sum;
		case 1: return 0;
		case 2: return (dr - st + 1); } }
	prop(nod, st, dr);
	int ant = 0, mid = (st + dr) / 2;
	if (ql <= mid)
		ant+= query(2 * nod, st, mid);
	if (mid < qr)
		ant+= query(2 * nod + 1, mid + 1, dr);
	return ant; }

static void get_heavy(int nod) {
	int largest = 0;
	siz[nod] = 1;

	if (g[nod].empty()) {
		chain[nod] = {nod, nod, nod};
		my_chn[nod] = nod;
		return; }

	for (auto v: g[nod]) {
		h[v] = h[nod] + 1;
		get_heavy(v);
		siz[nod]+= siz[v];
		if (siz[v] > siz[largest])
			largest = v; }
	my_chn[nod] = my_chn[largest];
	chain[my_chn[nod]].snd = chain[my_chn[nod]].fst;
	chain[my_chn[nod]].fst = nod; }

static void get_updates(int nod, int st, int dr) {
	if (dr < ql || qr < st) return;
	if (st == dr) {
		switch (pom[nod].lazy) {
		case 0: {
			if (pom[nod].sum)
				updates.push_back(line[st]);
			break; }
		case 2: {
			updates.push_back(line[st]);
			break; } }
		return; }
	prop(nod, st, dr);
	if (pom[nod].sum == 0)
		return;

	int mid = (st + dr) / 2;
	get_updates(2 * nod, st, mid);
	get_updates(2 * nod + 1, mid + 1, dr);
	pom[nod] = {0, eval(2 * nod, st, mid) + eval(2 * nod + 1, mid + 1, dr)}; }

static void dfs(int nod) {
	int chn = my_chn[nod];

	if (nod == 1)
		line[++lptr] = 1;
	for (int i = chain[chn].lst; i != chain[chn].fst; i = far[i])
		line[++lptr] = i;

	chain[chn].fst_child = lptr + 1;
	for (int prv = 0, i = chain[chn].lst; prv != chain[chn].fst; prv = i, i = far[i]) {
		st_l[i] = lptr + 1;
		for (auto v: g[i]) if (my_chn[v] != my_chn[i])
			line[++lptr] = v;
		dr_l[i] = lptr; }
	chain[chn].lst_child = lptr;

	for (int prv = 0, i = chain[chn].lst; prv != chain[chn].fst; prv = i, i = far[i]) {
		child[i] = prv;
		for (auto v: g[i]) if (my_chn[v] != my_chn[i])
			dfs(v);
		subarb[i] = lptr; }
	chain[chn].subarb = lptr; }

static void infestation_update(int nod) {
	ql = qr = my_lin[nod];
	qval = 2;
	update(1, 1, n); }

static void direct_clear(int nod) {
	ql = qr = my_lin[nod];
	qval = 1;
	update(1, 1, n);
	ql = st_l[nod], qr = dr_l[nod];
	qval = 1;
	update(1, 1, n);

	if (child[nod]) { // erase my chain child
		ql = qr = my_lin[child[nod]];
		qval = 1;
		update(1, 1, n); } }

static void lightning_update(int nod) {
	int cnod = nod;

	updates.clear();
	while (nod != 0) { // get updates
		int chn = my_chn[nod];
		ql = qr = my_lin[chain[chn].fst];
		get_updates(1, 1, n);
		if (my_chn[far[nod]] == my_chn[nod]) {
			ql = my_lin[nod], qr = my_lin[chain[chn].snd];
			get_updates(1, 1, n); }	
		nod = far[chain[chn].fst]; }

	// infect updates
	nod = cnod;
	for (auto i: updates) {
		ql = st_l[i], qr = dr_l[i];
		qval = 2;
		update(1, 1, n);
		if (child[i]) {
			ql = qr = my_lin[child[i]];
			qval = 2;
			update(1, 1, n); } }

	updates.clear();
	// clean me		
	while (nod != 0) { // get updates
		int chn = my_chn[nod];
		ql = qr = my_lin[chain[chn].fst];
		get_updates(1, 1, n);
		if (my_chn[far[nod]] == my_chn[nod]) {
			ql = my_lin[nod], qr = my_lin[chain[chn].snd];
			get_updates(1, 1, n); }	
		nod = far[chain[chn].fst]; }

	for (auto i: updates) {
		ql = my_lin[i], qr = my_lin[i];
		qval = 1;
		update(1, 1, n); } }

static int query(int nod) {
	int chn = my_chn[nod];
	int ans = 0;
	if (chain[chn].fst == chain[chn].lst) {
		ql = my_lin[nod], qr = my_lin[nod];
		return query(1, 1, n); }

	if (nod == chain[chn].fst) {
		ql = my_lin[chain[chn].lst], qr = chain[chn].subarb;
		ans+= query(1, 1, n);
		ql = qr = my_lin[chain[chn].fst];
		ans+= query(1, 1, n);
		return ans; }

	qr = my_lin[nod], ql = my_lin[chain[chn].lst]; // add compoments
	ans = query(1, 1, n);
	qr = dr_l[nod], ql = st_l[chain[chn].lst]; // add children
	ans+= query(1, 1, n);
	qr = subarb[nod];
	ql = chain[chn].lst_child + 1; // add subtrees
	ans+= query(1, 1, n);
	return ans; }

int gp(int pos) { // debug use only
	ql = qr = pos;
	return query(1, 1, n); }

int main() {
#ifdef HOME
	freopen("infestation.in", "r", stdin);
	freopen("infestation.out", "w", stdout);
#endif
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	updates.reserve(N);

	cin >> n;
	for (int t, i = 2; i <= n; ++i) {
		cin >> far[i];
		g[far[i]].push_back(i); }

	get_heavy(1);
	dfs(1);
	for (int i = 1; i <= n; ++i)
		my_lin[line[i]] = i;

	assert(n == lptr);

	cin >> q;
	while (q--) {
		int op;
		cin >> op;
		switch (op) {
		case 1: {
			int nod;
			cin >> nod;
			infestation_update(nod);
			break; }
		case 2: {
			int nod;
			cin >> nod;
			lightning_update(nod);
			break; }
		case 3: {
			int nod;
			cin >> nod;
			direct_clear(nod);
			break; }
		case 4: {
			int nod;
			cin >> nod;
			cout << query(nod) << '\n';
			break; } } }

	return 0; }

