#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int NMAX = 3e5 + 5;

int N, T[NMAX], Type, X, ans = 0, Q;

vector < int > G[NMAX];
bool Sel[NMAX];

int V[2 * NMAX], M;

int First[NMAX], Last[NMAX];

int AINT[4 * 2 * NMAX];

static inline void Update (int Node, int a, int b, int pos, int val)
{
    if(a == b)
    {
        AINT[Node] += val;

        return;
    }

    int Mid = (a + b) / 2;

    if(pos <= Mid)
        Update(2 * Node, a, Mid, pos, val);

    if(pos > Mid)
        Update(2 * Node + 1, Mid + 1, b, pos, val);

    AINT[Node] = AINT[2 * Node] + AINT[2 * Node + 1];

    return;
}

static inline int Query (int Node, int a, int b, int qa, int qb)
{
    if(qa <= a && b <= qb)
        return AINT[Node];

    int Mid = (a + b) / 2, p1 = 0, p2 = 0;

    if(qa <= Mid)
        p1 = Query(2 * Node, a, Mid, qa, qb);

    if(qb > Mid)
        p2 = Query(2 * Node + 1, Mid + 1, b, qa, qb);

    return (p1 + p2);
}

static inline void Read ()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(NULL);

    cin >> N;

    T[1] = 0;

    for(int i = 2; i <= N; ++i)
    {
        cin >> T[i];

        G[T[i]].push_back(i);
    }

    return;
}

static inline void Go1 ()
{
    Update(1, 1, M, First[X], 1);

    return;
}

static inline void Go4 ()
{
    cout << Query(1, 1, M, First[X], Last[X]);

    return;
}

static inline void Test_Case ()
{
    cin >> Type >> X;

    if(Type == 1)
        Go1();

    if(Type == 4)
        Go4();

    return;
}

static inline void DFS (int Node)
{
    Sel[Node] = 1;
    V[++M] = Node;

    for(auto it : G[Node])
        if(!Sel[it])
        {
            DFS(it);

            V[++M] = Node;
        }

    return;
}

static inline void Load ()
{
    for(int i = 1; i <= M; ++i)
    {
        if(!First[V[i]])
            First[V[i]] = i;

        Last[V[i]] = i;
    }

    return;
}

int main()
{
    Read();

    DFS(1);

    Load();

    cin >> Q;

    while(Q--)
        Test_Case();

    return 0;
}
