#include <iostream>
#include <vector>

using namespace std;

const int NMAX = 5e5 + 5;

int N, M;
bool Sel[NMAX];
vector < int > G[NMAX];

int Grad[NMAX], d[NMAX];
int Colour[NMAX], Ap[NMAX], ans;

int Max;
vector < int > V;

static inline void Read ()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(NULL);

    cin >> N >> M;

    for(int i = 1; i <= M; ++i)
    {
        int x = 0, y = 0;

        cin >> x >> y;

        G[x].push_back(y);
        G[y].push_back(x);
    }

    return;
}

static inline void Load_Degrees ()
{
    for(int i = 1; i <= N; ++i)
        Grad[i] = (int)G[i].size();

    return;
}

static inline void Go (int Node, int Dist)
{
    Sel[Node] = 1;
    V.push_back(Node);

    d[Node] = Dist;

    Max = max(Max, (int)V.size());

    for(auto it : G[Node])
        if(!Sel[it])
            Go(it, Dist + 1);

    return;
}

static inline void Solve ()
{
    Load_Degrees();

    for(int i = 1; i <= N; ++i)
        if(!Sel[i])
        {
            Max = 0;
            V.clear();

            Go(i, 1);

            if((int)V.size() == 1)
            {
                Colour[V[0]] = 1;

                continue;
            }

            if((int)V.size() == 2)
            {
                Colour[V[0]] = 1;
                Colour[V[1]] = 2;

                continue;
            }

            for(auto it : V)
            {
                int Node = it;

                Colour[Node] = d[Node] % 2 + 1;
            }

            bool done = 1;

            while(done)
            {
                done = 0;

                for(auto j : V)
                    for(auto it : G[j])
                        if(Colour[it] == Colour[j])
                        {
                            done = 1;

                            ++Colour[j];
                        }
            }
        }

    return;
}

static inline void Write ()
{
    for(int i = 1; i <= N; ++i)
        ++Ap[Colour[i]];

    for(int i = 1; i <= N; ++i)
        if(Ap[i])
            ++ans;

    cout << ans << '\n';

    for(int i = 1; i <= N; ++i)
        cout << Colour[i] << ' ';

    return;
}

int main()
{
    Read();

    Solve();

    Write();

    return 0;
}
