#include <iostream>
#include <vector>
#include <queue>

using namespace std;

typedef pair < int, int > PII;

const int NMAX = 5e5 + 5;

int N, M, Elem;
bool Sel[NMAX];
vector < int > G[NMAX];

int Grad[NMAX], d[NMAX];
int Colour[NMAX], Ap[NMAX], ans;

int Max;
vector < int > V;

static inline void Read ()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(NULL);

    cin >> N >> M;

    for(int i = 1; i <= M; ++i)
    {
        int x = 0, y = 0;

        cin >> x >> y;

        G[x].push_back(y);
        G[y].push_back(x);
    }

    return;
}

static inline void Load_Degrees ()
{
    for(int i = 1; i <= N; ++i)
        Grad[i] = (int)G[i].size();

    return;
}

static inline void Go (int Node, int Dist)
{
    Sel[Node] = 1;
    V.push_back(Node);

    d[Node] = Dist;

    Max = max(Max, (int)V.size());

    for(auto it : G[Node])
        if(!Sel[it])
            Go(it, Dist + 1);

    return;
}

static inline void Lant ()
{
    for(auto it : V)
        if(d[it] % 2 == 1)
            Colour[it] = 1;
        else
            Colour[it] = 2;

    return;
}

static inline void Center ()
{
    for(auto it : V)
        if(Grad[it] == 1)
            Colour[it] = 2;
        else
            Colour[it] = 1;

    return;
}

static inline void SOL ()
{
    priority_queue < PII, vector < PII >, greater < PII >  > H;

    for(auto it : V)
        H.push({d[it], it});

    while(!H.empty())
    {
        int Node = H.top().second;

        for(int j = 1; j <= Elem; ++j)
        {
            bool Ok = 1;

            for(auto it : G[Node])
                if(Colour[it] == j)
                {
                    Ok = 0;

                    break;
                }

            if(Ok)
            {
                Colour[Node] = j;

                break;
            }
        }

        H.pop();
    }

    return;
}

static inline void Hard_Task ()
{
    int gr1 = 0, alt_grad = 0, ce_are = 0;

    for(auto it : V)
    {
        if(Grad[it] == 1)
            ++gr1;
        else
        {
            ++alt_grad;

            ce_are = Grad[it];
        }
    }

    if(gr1 == Elem - 1 && alt_grad == 1 && ce_are == Elem - 1)
        Center();
    else
        SOL();

    return;
}

static inline void Solve ()
{
    Load_Degrees();

    for(int i = 1; i <= N; ++i)
        if(!Sel[i])
        {
            Max = 0;
            V.clear();

            Go(i, 1);

            if((int)V.size() == 1)
            {
                Colour[V[0]] = 1;

                continue;
            }

            if((int)V.size() == 2)
            {
                Colour[V[0]] = 1;
                Colour[V[1]] = 2;

                continue;
            }

            int gr1 = 0, gr2 = 0;

            for(auto it : V)
            {
                if(Grad[it] == 1)
                    ++gr1;

                if(Grad[it] == 2)
                    ++gr2;
            }

            Elem = (int)V.size();

            if(gr1 == 2 && gr2 == Elem - 2)
            {
                Lant();

                continue;
            }

            Hard_Task();
        }

    return;
}

static inline void Write ()
{
    for(int i = 1; i <= N; ++i)
        ++Ap[Colour[i]];

    for(int i = 1; i <= N; ++i)
        if(Ap[i])
            ++ans;

    cout << ans << '\n';

    for(int i = 1; i <= N; ++i)
        cout << Colour[i] << ' ';

    return;
}

int main()
{
    Read();

    Solve();

    Write();

    return 0;
}
