#include <iostream>
#include <vector>

using namespace std;

const int NMAX = 5e5 + 5;

int N, M, Elem;
bool Sel[NMAX];
vector < int > G[NMAX];

int d[NMAX];
int Colour[NMAX], Ap[NMAX], ans;

vector < int > V;

static inline void Read ()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(NULL);

    cin >> N >> M;

    for(int i = 1; i <= M; ++i)
    {
        int x = 0, y = 0;

        cin >> x >> y;

        G[x].push_back(y);
        G[y].push_back(x);
    }

    return;
}

static inline void Go (int Node, int Dist)
{
    Sel[Node] = 1;
    V.push_back(Node);

    d[Node] = Dist;

    for(auto it : G[Node])
        if(!Sel[it])
            Go(it, Dist + 1);

    return;
}

static inline void Back (int Node)
{
    if(!Colour[Node])
    {
        for(int i = 1; i <= Elem; ++i)
        {
            bool Ok = 1;

            for(auto it : G[Node])
                if(Colour[it] == i)
                {
                    Ok = 0;

                    break;
                }

            if(Ok)
            {
                Colour[Node] = i;

                break;
            }
        }
    }

    for(auto it : G[Node])
        if(!Colour[it])
            Back(it);
        else
        {
            if(Colour[Node] == Colour[it])
            {
                ++Colour[it];

                Back(it);
            }
        }

    return;
}

static inline void Solve ()
{
    for(int i = 1; i <= N; ++i)
        if(!Sel[i])
        {
            V.clear();

            Go(i, 1);

            if((int)V.size() == 1)
            {
                Colour[V[0]] = 1;

                continue;
            }

            if((int)V.size() == 2)
            {
                Colour[V[0]] = 1;
                Colour[V[1]] = 2;

                continue;
            }

            Elem = (int)V.size();

            Back(V[0]);
        }

    return;
}

static inline void Write ()
{
    for(int i = 1; i <= N; ++i)
        ++Ap[Colour[i]];

    for(int i = 1; i <= N; ++i)
        if(Ap[i])
            ++ans;

    cout << ans << '\n';

    for(int i = 1; i <= N; ++i)
        cout << Colour[i] << ' ';

    return;
}

int main()
{
    Read();

    Solve();

    Write();

    return 0;
}
