#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int NMAX = 5e5 + 5;

int N, M, Elem;
bool Sel[NMAX];
vector < int > G[NMAX];

int d[NMAX];
int Colour[NMAX], Ap[NMAX], ans;

vector < int > V;

int K;
vector < int > New[NMAX];

static inline void Read ()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(NULL);

    cin >> N >> M;

    for(int i = 1; i <= M; ++i)
    {
        int x = 0, y = 0;

        cin >> x >> y;

        G[x].push_back(y);
        G[y].push_back(x);
    }

    for(int i = 1; i <= N; ++i)
        if(!G[i].empty())
            sort(G[i].begin(), G[i].end());

    return;
}

static inline void Go (int Node, int Dist)
{
    Sel[Node] = 1;
    V.push_back(Node);

    d[Node] = Dist;

    for(auto it : G[Node])
        if(!Sel[it])
            Go(it, Dist + 1);

    return;
}

static inline bool Ok (int X, int Y)
{
    if(binary_search(G[X].begin(), G[X].end(), Y))
        return 0;

    return 1;
}

static inline void Solve ()
{
    for(int ii = 1; ii <= N; ++ii)
        if(!Sel[ii])
        {
            V.clear();

            Go(ii, 1);

            if((int)V.size() == 1)
            {
                Colour[V[0]] = 1;

                continue;
            }

            if((int)V.size() == 2)
            {
                Colour[V[0]] = 1;
                Colour[V[1]] = 2;

                continue;
            }

            Elem = (int)V.size();

            K = 1;
            New[1].push_back(V[0]);

            for(int i = 1; i < Elem; ++i)
            {
                bool GK = 0;

                for(int j = 1; j <= K; ++j)
                {
                    bool OK = 1;

                    for(auto it : New[j])
                        if(Ok(V[i], it))
                            continue;
                        else
                        {
                            OK = 0;

                            break;
                        }

                    if(OK)
                    {
                        GK = 1;

                        New[j].push_back(V[i]);

                        break;
                    }
                }

                if(!GK)
                    New[++K].push_back(V[i]);
            }

            for(int i = 1; i <= K; ++i)
                for(auto it : New[i])
                    Colour[it] = i;
        }

    return;
}

static inline void Write ()
{
    for(int i = 1; i <= N; ++i)
        ++Ap[Colour[i]];

    for(int i = 1; i <= N; ++i)
        if(Ap[i])
            ++ans;

    cout << ans << '\n';

    for(int i = 1; i <= N; ++i)
        cout << Colour[i] << ' ';

    return;
}

int main()
{
    Read();

    Solve();

    Write();

    return 0;
}
