#include <iostream>
#include <vector>
#include <queue>

using namespace std;

typedef pair < int, int > PII;

const int NMAX = 5e5 + 5;

int N, M, Grad[NMAX], d[NMAX], Q;

int Colour[NMAX], Ap[NMAX], ans;

bool Sel[NMAX];

vector < int > G[NMAX];

vector < int > V;

priority_queue < PII, vector < PII >, greater < PII > > H;

static inline void Read ()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(NULL);

    cin >> N >> M;

    for(int i = 1; i <= M; ++i)
    {
        int x = 0, y = 0;

        cin >> x >> y;

        G[x].push_back(y);
        G[y].push_back(x);
    }

    for(int i = 1; i <= N; ++i)
        Grad[i] = (int)G[i].size();

    return;
}

static inline void DFS (int Node, int Dist)
{
    Sel[Node] = 1;
    V.push_back(Node);

    d[Dist] = Dist;

    for(auto it : G[Node])
        if(!Sel[it])
            DFS(it, Dist + 1);

    return;
}

static inline void Solve ()
{
    for(int i = 1; i <= N; ++i)
        if(!Sel[i])
        {
            V.clear();

            DFS(i, 1);

            Q = (int)V.size();

            if(Q == 1)
            {
                Colour[V[0]] = 1;

                continue;
            }

            if(Q == 2)
            {
                Colour[V[0]] = 1;
                Colour[V[1]] = 2;

                continue;
            }

            for(auto it : V)
                H.push({Grad[it], it});

            while(!H.empty())
            {
                int Node = H.top().second;
                H.pop();

                for(int j = 1; j <= N; ++j)
                {
                    bool Ok = 1;

                    for(auto it : G[Node])
                        if(Colour[it] == j)
                        {
                            Ok = 0;

                            break;
                        }

                    if(Ok)
                    {
                        Colour[Node] = j;

                        break;
                    }
                }
            }
        }

    return;
}

static inline void Write ()
{
    for(int i = 1; i <= N; ++i)
        ++Ap[Colour[i]];

    for(int i = 1; i <= N; ++i)
        if(Ap[i])
            ++ans;

    cout << ans << '\n';

    for(int i = 1; i <= N; ++i)
        cout << Colour[i] << ' ';

    return;
}

int main()
{
    Read();

    Solve();

    Write();

    return 0;
}
