#include <iostream>
#include <vector>

using namespace std;

const int NMAX = 5e5 + 5;

int N, M;
bool Sel[NMAX];

vector < int > G[NMAX];
vector < int > V;

int Colour[NMAX], Ap[NMAX], ans;

static inline void Read ()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(NULL);

    cin >> N >> M;

    for(int i = 1; i <= M; ++i)
    {
        int x = 0, y = 0;

        cin >> x >> y;

        G[x].push_back(y);
        G[y].push_back(x);
    }

    return;
}

static inline void DFS (int Node)
{
    V.push_back(Node);
    Sel[Node] = 1;

    for(auto it : G[Node])
        if(!Sel[it])
            DFS(it);

    return;
}

static inline void Write ()
{
    for(int i = 1; i <= N; ++i)
        ++Ap[Colour[i]];

    for(int i = 1; i <= N; ++i)
        if(Ap[i])
            ++ans;

    cout << ans << '\n';

    for(int i = 1; i <= N; ++i)
        cout << Colour[i] << ' ';

    cout << '\n';

    return;
}

static inline bool Ok (int Node, int C)
{
    for(auto it : G[Node])
        if(Colour[it] == C)
            return 0;

    return 1;
}

int main()
{
    Read();

    for(int i = 1; i <= N; ++i)
        if(!Sel[i])
        {
            DFS(i);

            int Elem = (int)V.size();

            if(Elem == 1)
            {
                Colour[V[0]] = 1;

                V.clear();

                continue;
            }

            if(Elem == 2)
            {
                Colour[V[0]] = 1;
                Colour[V[1]] = 2;

                V.clear();

                continue;
            }

            for(auto it : V)
            {
                int Node = it;

                for(int j = 1; j <= N; ++j)
                    if(Ok(Node, j))
                    {
                        Colour[Node] = j;

                        break;
                    }
            }

            V.clear();
        }

    Write();

    return 0;
}
