#include <bits/stdc++.h>

#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define f first
#define s second
#define size(x) (int)x.size()

using namespace std;

typedef long long ll;
typedef long double ld;

void io() {
#ifdef MLOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

vector<int> p;
vector<vector<int>> g;
vector<int> top, sz;

void dfs(int v) {
    sz[v] = 1;
    for(int i : g[v]) {
        dfs(i);
        sz[v] += sz[i];
    }
    top.push_back(v);
}

struct node {
    int x, y, sum, sz, toset;
    node *l, *r;
    node(int x_) {
        x = x_;
        y = rand();
        sum = x;
        toset = -1;
        l = nullptr;
        r = nullptr;
        sz = 1;
    }
};

typedef node* treap;

void push(treap &t) {
    if(t && t->toset != -1) {
        t->x = t->toset;
        t->sum = t->toset * t->sz;
        if(t->l) {
            t->l->toset = t->toset;
        }
        if(t->r) {
            t->r->toset = t->toset;
        }
        t->toset = -1;
    }
}

int siz(treap t) {
    if(t) {
        return t->sz;
    }else {
        return 0;
    }
}

int sum(treap t) {
    if(t) {
        return t->sum;
    }else {
        return 0;
    }
}

void upd(treap t) {
    if(t) {
        t->sz = siz(t->l) + siz(t->r) + 1;
        t->sum = sum(t->l) + sum(t->r) + t->x;
    }
}

void split(treap t, treap &l, treap &r, int x, int add = 0) {
    if(!t) {
        l = nullptr;
        r = nullptr;
        return;
    }
    push(t);
    int cur = add + siz(t->l);
    if(x <= cur) {
        split(t->l, l, t->l, x, add);
        r = t;
    }else {
        split(t->r, t->r, r, x, cur + 1);
        l = t;
    }
    upd(t);
}

void merge(treap &t, treap l, treap r) {
    push(l);
    push(r);
    if(!l) {
        t = r;
    }else if(!r) {
        t = l;
    }else if(l->y > r->y) {
        merge(l->r, l->r, r);
        t = l;
    }else {
        merge(r->l, l, r->l);
        t = r;
    }
    upd(t);
}

int summ(treap &t, int l, int r) {
    treap t1, t2, t3;
    split(t, t1, t2, l);
    split(t2, t2, t3, r - l + 1);
    int sum1 = sum(t2);
    merge(t, t1, t2);
    merge(t, t, t3);
    return sum1;
}

void setone(treap &t, int x, int l, int r) {
   treap t1, t2, t3;
   split(t, t1, t2, l);
   split(t2, t2, t3, r - l + 1);
   t2->toset = x;
   merge(t, t1, t2);
   merge(t, t, t3);
}

void solve() {
    int n;
    cin >> n;
    p.resize(n);
    g.resize(n);
    p[0] = -1;
    for(int i = 0; i < n - 1; i++) {
        int x;
        cin >> x;
        g[x - 1].push_back(i + 1);
        p[i + 1] = x - 1;
    }
    sz.assign(n, 0);
    dfs(0);
    reverse(all(top));
    vector<int> pos(n);
    for(int i = 0; i < n; i++) {
        pos[top[i]] = i;
    }
    int q;
    cin >> q;
    treap a = nullptr;
    for(int i = 0; i < n; i++) {
        treap it = new node(0);
        merge(a, a, it);
    }
    while(q--) {
        int t, x;
        cin >> t >> x;
        if(t == 1) {
            setone(a, 1, pos[x - 1], pos[x - 1]);
        }else if(t == 4) {
            int l = pos[x - 1], r = pos[x - 1] + sz[x - 1] - 1;
            cout << summ(a, l, r) << "\n";
        }else if(t == 3) {
            int l = pos[x - 1], r = pos[x - 1] + size(g[x - 1]) - 1;
            setone(a, 0, l, r);
        }
    }
}

int main() {
    io();
    solve();
    return 0;
}
