#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <string.h>
#include <math.h>
#include <algorithm>
#include <bitset>
#include <time.h>
typedef long long ll;
#define fori(n) for (int i = 0; i < n; i++)
#define forj(n) for (int j = 0; j < n; j++)
#define ff first
#define ss second
#define all(v) v.begin(), v.end()
#define normsize(v) int(v.size())
#define pb push_back
using namespace std;
//#pragma GCC target("avx")
#pragma GCC optimize("no-stack-protector", "unroll-loops", "fast-math", "O3")
struct segment_tree {
    vector < int > t;
    vector < int > del;
    int siz;
    void build(int siz1) {
        siz = siz1;
        t.resize(4 * siz);
        del.resize(4 * siz);
    }
    void push(int v, int l, int r) {
        if (v * 2 + 1 < 4 * siz) {
            del[v * 2 + 1] += del[v];
        }
        if (v * 2 + 2 < 4 * siz) {
            del[v * 2 + 2] += del[v];
        }
        t[v] += del[v] * (r - l + 1);
        del[v] = 0;
    }
    int ask(int v, int l, int r, int tl, int tr) {
        push(v, l, r);
        if (l == tl && r == tr) {
            return t[v];
        }
        int m = (l + r) / 2;
        int ans = 0;
        push(v * 2 + 1, l, m);
        push(v * 2 + 2, m + 1, r);
        if (tr >= m + 1) ans += ask(v * 2 + 2, m + 1, r, max(m + 1, tl), tr);
        if (tl <= m) ans += ask(v * 2 + 1, l, m, tl, min(m, tr));
        return ans;
    }
    void upd(int v, int l, int r, int tl, int tr) {
        if (l == tl && r == tr) {
            del[v]++;
            push(v, l, r);
            return ;
        }
        push(v, l, r);
        int m = (l + r) / 2;
        push(v * 2 + 1, l, m);
        push(v * 2 + 2, m + 1, r);
        if (tl <= m)
            upd(v * 2 + 1, l, m, tl, min(m, tr));
        if (tr >= m + 1)
            upd(v * 2 + 2, m + 1, r, max(m + 1, tl), tr);
    }
    int reask(int l, int r) {
        return ask(0, 0, siz - 1, l, r);
    }
    void reupd(int l, int r) {
        upd(0, 0, siz - 1, l, r);
    }
};
vector < vector < int > > childrens;
vector < int > deep, p;
vector < int > siz;
vector < vector < int > > bubas;
vector < segment_tree > t;
vector < bool > inf;
vector < int > sum;
vector < int > ind; /// for each vertex index of hld
vector < int > whatinbubas; /// for each v index in bubas[ind[v]]
int n;
void precalc(int v) {
    siz[v] = 1;
    fori(childrens[v].size()) {
        int to = childrens[v][i];
        deep[to] = deep[v] + 1;
        precalc(to);
        siz[v] += siz[to];
    }
}
void tryxard(int v) {
    fori(childrens[v].size()) {
        int to = childrens[v][i];
        tryxard(to);
        if (siz[to] * 2 >= siz[v]) {
            if (ind[to] == -1) {
                vector < int > temp;
                temp.pb(to);
                bubas.pb(temp);
                ind[to] = bubas.size() - 1;
            }
            ind[v] = ind[to];
            bubas[ind[v]].pb(v);
        }

    }
}
void upd(int v) {
    if (inf[v] == 1) return ;
    inf[v] = 1;
    while (true) {
        if (v == -1) break;
        if (ind[v] == -1) {
            sum[v]++;
            v = p[v];
            continue;
        }
        int index = ind[v];
        int what = whatinbubas[v];
        t[index].reupd(what, bubas[index].size() - 1);
        v = bubas[index].back();
        v = p[v];
    }
}
int ask(int v) {
    if (ind[v] == -1) return sum[v];
    int what = whatinbubas[v];
    return t[ind[v]].reask(what, what);
}
int main() {

    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    inf.resize(n);
    deep.resize(n); childrens.resize(n); p.resize(n);
    siz.resize(n);
    ind.resize(n);
    sum.resize(n);
    p[0] = -1;
    fori(n) ind[i] = -1;
    for (int i = 1; i < n; i++) {
        int x;
        cin >> x;
        p[x] = i;
        childrens[i].pb(x);
    }
    precalc(0);
    tryxard(0);
    t.resize(bubas.size());
    fori(bubas.size()) {
        t[i].build(bubas[i].size());
        forj(bubas[i].size()) {
            whatinbubas[bubas[i][j]] = j;
        }
    }
    int q;
    cin >> q;
    fori(q) {
        int t;
        cin >> t;
        int x;
        cin >> x;
        x--;
        if (t == 1) {
            upd(x);
        } else if (t == 4) {
            cout << ask(x) << "\n";
        }
    }
}

/**
5
1 1 3 3
2
1 3
4 3

5
1 1 3 3
5
1 3
4 1
1 1
4 3
4 3

**/




