#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define int long long
#define ld long double
#define fs first
#define sc second
#define pr pair
#define mp make_pair
#define pb push_back
#define vc vector
#define len(v) (int)v.size()
#define all(v) v.begin(),v.end()

using namespace std;
using namespace __gnu_pbds;

using ortree = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

const int MAXN = 5e5;
const int INF = 1e9;
const int MOD = 1e9+7;

int t[MAXN];

void add(int v, int u){
	for (; v < MAXN; v = (v | (v + 1))){
		t[v] += u;
	}
}

int gets(int v){
	int ans = 0;
	for (; v >= 0; v = (v & (v + 1)) - 1){
		ans += t[v];
	}
	return ans;
}

//-fsanitize=address,bounds,undefined -D_GLIBCXX_DEBUG
int p[MAXN];
int hld[MAXN];
int sroot[MAXN];
int stree[MAXN];
set<pr<int, int>> changes[MAXN];
set<int> blacks[MAXN];
set<int> sexchanges[MAXN];
set<int> unsexchanges[MAXN];
int posintree = 0;
int lasts = 0;

vc<int> g[MAXN];
int glub[MAXN];
int sz[MAXN];
int color[MAXN];

void dfs(int v){
	sz[v] = 1;
	for (auto to : g[v]){
		glub[to] = glub[v] + 1;
		dfs(to);
		sz[v] += sz[to];
	}
}

void build_hld(int v, int cld){
	if (sroot[cld] == -1){
		stree[cld] = posintree;
		sroot[cld] = v;
	}
	hld[v] = cld;
	posintree++;

	pr<int, int> maxi = {0, -1};
	for (auto to : g[v]){
		maxi = max(maxi, {sz[to], to});
	}
	if (maxi.sc != -1){
		build_hld(maxi.sc, cld);
	}
	for (auto to : g[v]){
		if (to != maxi.sc){
			build_hld(to, lasts++);
		}
	}
}


void marka(int v){
	while(v != -1){
		int l = hld[v];
		int x = sroot[l];
		changes[l].insert({glub[v], v});
		v = p[x];
	}
}

void paintblack(int v){
	if (color[v] == 1){
		return;
	}
	if (p[v] != -1){
		sexchanges[p[v]].erase(v);
		unsexchanges[p[v]].insert(v);
	}
	color[v] = 1;
	if (len(sexchanges[v])){
		marka(v);
	}
	blacks[hld[v]].insert(v);
	while(v != -1){
		int l = hld[v];
		int x = sroot[l];
		add(stree[l], 1);
		add(stree[l] + glub[v] - glub[x] + 1, -1);
		v = p[x];
	}
}

void paintwhite(int v){
	if (color[v] == 0){
		return;
	}
	if (p[v] != -1){
		unsexchanges[p[v]].erase(v);
		sexchanges[p[v]].insert(v);
		if (color[p[v]] == 1 && len(sexchanges[p[v]]) == 1){
			marka(p[v]);
		}
	}
	color[v] = 0;
	blacks[hld[v]].erase(v);
	while(v != -1){
		int l = hld[v];
		int x = sroot[l];
		add(stree[l], -1);
		add(stree[l] + glub[v] - glub[x] + 1, 1);
		v = p[x];
	}
}

int getans(int v){
	int ans = 0;
	int l = hld[v];
	int x = sroot[l];
	ans += gets(stree[l] + glub[v] - glub[x]);
	return ans;
}

void solve(istream &in, ostream &out){
	int n;
	in >> n;
	p[0] = -1;
	for (int i = 0; i < n - 1; i++){
		in >> p[i + 1];
		p[i + 1]--;
		g[p[i + 1]].pb(i + 1);
	}
	for (int i = 0; i < n; i++){
		sroot[i] = -1;
	}
	dfs(0);
	build_hld(0, lasts++);
	int q;
	in >> q;
	for (int i = 0; i < q; i++){
		int t;
		in >> t;
		if (t == 1){
			int x;
			in >> x;
			x--;
			paintblack(x);
		}
		if (t == 2){
			int x;
			in >> x;
			x--;
		}
		if (t == 3){
			int x;
			in >> x;
			x--;
			vc<int> ms;
			for (auto to : unsexchanges[x]){
				ms.pb(to);
			}
			ms.pb(x);
			for (auto v : ms){
				paintwhite(v);
			}
		}
		if (t == 4){
			int x;
			in >> x;
			x--;
			out << getans(x) << '\n';
		}
	}
}

signed main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	solve(cin, cout);
}