#include <bits/stdc++.h>
using namespace std;

#define ll int
#define ld long double

ll INF = (ll) 1e20;
ll iINF = (int) 1e20;
ll mod = 1e9 + 7;

#pragma GCC-optimize("Ofast");

void precalc(ll v, vector <vector <ll> > &nodes, vector <ll> &pr, vector <ll> &s, vector <ll> &d) {
    s[v] = 1;
    for(int i = 0; i < nodes[v].size(); ++i) {
        if(nodes[v][i] != pr[v]) {
            d[nodes[v][i]] = d[v] + 1;
            precalc(nodes[v][i], nodes, pr, s, d);
            s[v] += s[nodes[v][i]];
        }
    }
}

void split(ll v, vector <vector <ll> > &nodes, vector <vector <ll> > &ways, ll id, vector <ll> &pr, vector <ll> &s) {
    ways[id].push_back(v);
    for(int i = 0; i < nodes[v].size(); ++i) {
        if(nodes[v][i] != pr[v]) {
            if(s[nodes[v][i]] * 2 > s[v]) {
                split(nodes[v][i], nodes, ways, id, pr, s);
            }
            else {
                ways.push_back({});
                split(nodes[v][i], nodes, ways, ways.size() - 1, pr, s);
            }
        }
    }
}

struct dero {
    vector <ll> t;
    vector <ll> psh;
    dero() { }
    dero(ll n) {
        t.resize(6 * n);
        psh.resize(6 * n);
        build(1, 0, n - 1);
    }

    void build(ll v, ll l, ll r) {
        t[v] = 0;
        psh[v] = 0;
        if(l == r) {
            return;
        }
        ll m = (l + r) / 2;
        build(v * 2, l, m);
        build(v * 2 + 1, m + 1, r);
    }

    void push(ll v, ll l, ll r) {
        if(psh[v] == 0)
        return;
        t[v] += psh[v];
        if(l != r) {
            psh[v * 2] += psh[v];
            psh[v * 2 + 1] += psh[v];
        }
        psh[v] = 0;
    }

    void add(ll v, ll l, ll r, ll ql, ll qr) {
        push(v, l, r);
        if(l > qr || r < ql)
            return;
        if(l >= ql && r <= qr) {
            psh[v]++;
            push(v, l, r);
            return;
        }
        ll m = (l + r) / 2;
        add(v * 2, l, m, ql, qr);
        add(v * 2 + 1, m + 1, r, ql, qr);
    }

    ll get(ll v, ll l, ll r, ll id) {
        push(v, l, r);
        if(l > id || r < id)
        return 0;
        if(l == r) {
            return t[v];
        }
        ll m = (l + r) / 2;
        return get(v * 2, l, m, id) + get(v * 2 + 1, m + 1, r, id);
    }
};

signed main() {
    ll n;
    cin >> n;
    vector <vector <ll> > nodes(n);
    vector <ll> pr(n, -1);
    for(int i = 1; i < n; ++i) {
        ll p;
        cin >> p;
        pr[i] = p - 1;
        nodes[i].push_back(p - 1);
        nodes[p - 1].push_back(i);
    }


    vector <ll> s(n), d(n);
    d[0] = 0;
    precalc(0, nodes, pr, s, d);
    vector <vector <ll> > ways;
    ways.push_back({});
    split(0, nodes, ways, 0, pr, s);

    vector <dero> hld(ways.size());
    vector <ll> way_id(n), id_in_way(n);
    for(int i = 0; i < ways.size(); ++i) {
        hld[i] = dero(ways[i].size());
        for(int j = 0; j < ways[i].size(); ++j) {
            way_id[ways[i][j]] = i;
            id_in_way[ways[i][j]] = j;
            cout << ways[i][j] << ' ';
        }
        cout << '\n';
    }

    ll q;
    cin >> q;
    vector <bool> inf(n, false);
    for(int i = 0; i < q; ++i) {
        ll t;
        cin >> t;
        if(t == 1) {
            ll v;
            cin >> v;
            --v;
            if(!inf[v]) {
                ll num = d[v] + 1;
                inf[v] = true;
                while(num) {
                    ll here = min(num, id_in_way[v] + 1);
                    hld[way_id[v]].add(1, 0, ways[way_id[v]].size() - 1, id_in_way[v] - here + 1, id_in_way[v]);
                    //cout << v << ' ' << pr[ways[way_id[v]][0]] << '\n';
                    v = pr[ways[way_id[v]][0]];
                    num -= here;
                }
            }
        }
        else {
            ll v;
            cin >> v;
            --v;
            cout << hld[way_id[v]].get(1, 0, ways[way_id[v]].size() - 1, id_in_way[v]) << '\n';
        }
    }
}
/*
5
1 1 3 3
8
1 3
2 5
4 1
1 1
2 1
4 3
3 1
4 3
*/
