#include <iostream>
#include <cstdio>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cstring>
#include <cmath>
#include <cassert>
#include <string>
#include <vector>
#include <deque>
#include <queue>
#include <algorithm>
#include <numeric>
#include <random>
#include <bitset>
#define rep(i, n) for (int i = 0; i < (n); i++)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

using namespace std;
using ll = long long;
using ld = long double;
using ul = unsigned long long;

const int N = 300001, L = 19;
int tin[N], tout[N], ct, h[N], par[N], f[N], x[N], hn[N], hp[N], ho[N], sz[N], hs, tp[N], mod[N], dp[N];
int r0;
set<int> es[N], td[N];
vector<int> g[N];

void add(int v, int d) {
	for (int i = v; i < N; i |= (i + 1))
		f[i] += d;
}

int sum(int v) {
	int res = 0;
	for (int i = v; i; i &= (i - 1))
		res += f[i - 1];
	return res;
}

int sum(int l, int r) {
	return sum(r) - sum(l);
}

void dfs(int v) {
	tin[v] = ct++;
	sz[v] = 1;
	for (int u : g[v]) {
		h[u] = h[v] + 1;
		dfs(u);
		sz[v] += sz[u];
	}
	tout[v] = ct;
}

void build(int v) {
	ho[hs] = v;
	hn[v] = hs++;
	int mv = -1;
	for (int u : g[v])
		if (mv == -1 || sz[u] > sz[mv])
			mv = u;
	if (mv == -1)
		return;
	hp[mv] = hp[v];
	build(mv);
	for (int u : g[v])
		if (u != mv) {
			hp[u] = u;
			build(u);
		}
}

int isr(int v) {
	if (v == 0)
		return r0;
	if (tp[par[v]])
		return !es[par[v]].count(v);
	return es[par[v]].count(v);
}

void proc(int v, int p) {
	if (!isr(p))
		return;
	if (p) {
		if (tp[par[p]])
			es[par[p]].insert(p);
		else
			es[par[p]].erase(p);
	}
	else
		r0 = 0;
	int ds = (int) g[p].size() - (int) (tp[p] ? g[p].size() - es[p].size() : es[p].size()) - (v == -1 ? 0 : 1);
	add(tin[p], ds);
	if (p)
		add(tin[par[p]], -1);
	tp[p] = 1;
	es[p].clear();
	if (v != -1)
		es[p].insert(v);
	int u = ho[hn[p] + 1];
	if (hp[u] != u && u != v)
		td[hp[u]].insert(hn[u]);
}

void dfs2(int v) {
	dp[v] = isr(v);
	for (int u : g[v]) {
		dfs2(u);
		dp[v] += dp[u];
	}
}

int main() {
#ifdef ONPC
	freopen("in", "r", stdin);
#endif
	ios_base::sync_with_stdio(0); cin.tie(0);
	int n, q, t, v, u, nv;
	cin >> n;
	for (int i = 1; i < n; i++) {
		cin >> par[i];
		par[i]--;
		g[par[i]].push_back(i);
	}
	dfs(0);
	build(0);
	cin >> q;
	rep(z, q) {
		cin >> t >> v;
		v--;
		if (t == 1) {
			if (isr(v))
				continue;
			if (v == 0)
				r0 = 1;
			if (v)
				add(tin[par[v]], 1);
			if (v) {
				if (tp[par[v]])
					es[par[v]].erase(v);
				else
					es[par[v]].insert(v);
			}
			if (v != hp[v])
				td[hp[v]].insert(hn[v]);
		}
		else if (t == 2) {
			proc(-1, v);
			if (!v)
				continue;
			while (v) {
				proc(v, par[v]);
				v = par[v];
			}
			/*proc(v, par[v]);
			while (1) {
				nv = hp[v];
				while (!td[nv].empty() && *td[nv].begin() < hn[v]) {
					u = ho[*td[nv].begin()];
					td[nv].erase(td[nv].begin());
					proc(ho[hn[u] + 1], u);
				}
				if (v != nv)
					proc(ho[hn[nv] + 1], nv);
				if (!nv)
					break;
				v = par[nv];
				proc(nv, v);
			}*/
		}
		else if (t == 3) {
			if (isr(v)) {
				if (v) {
					add(tin[par[v]], -1);
					if (tp[par[v]])
						es[par[v]].insert(v);
					else
						es[par[v]].erase(v);
				}
				else
					r0 = 0;
			}
			int ds = (tp[v] ? g[v].size() - es[v].size() : es[v].size());
			add(tin[v], -ds);
			tp[v] = 0;
			es[v].clear();
		}
		else if (t == 4)
			cout << sum(tin[v], tout[v]) + isr(v) << '\n';
		dfs2(0);
		rep(i, n)
			assert(sum(tin[i], tout[i]) + isr(i) == dp[i]);
		/*rep(i, n)
			cout << isr(i) << ' ';
		cout << "!\n";*/
	}
}

