#include "Sgame.h"
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define all(x) (x).begin(), (x).end()
#define FAST_IO ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define f first
#define s second

const int MAXN = 5e5 + 5;
int n;
string s;

int get(string t) {
    int res = 0;
    for (int i = 0; i + t.size() <= s.size(); ++i) {
        if (s.substr(i, t.size()) == t) {
            res++;
        }
    }
    return res;
}

vector<int> build_sa(string s) {
    int n = s.size();
    vector<int> sa(n);
    int N = n + 500;
    vector<int> cnt(N);
    rep(i, n) {
        cnt[s[i]]++;
    }
    for (int i = 1; i < N; ++i) {
        cnt[i] += cnt[i - 1];
    }
    for (int i = n - 1; i >= 0; --i) {
        sa[cnt[s[i]] - 1] = i;
        cnt[s[i]]--;
    }

    // rep(i, n) {
    //     cout << sa[i] << ' ';
    // }
    // cout << endl;

    vector<int> rank(n);
    rank[0] = 0;
    for (int i = 1; i < n; ++i) {
        rank[sa[i]] = rank[sa[i - 1]];
        if (s[sa[i - 1]] != s[sa[i]]) {
            rank[sa[i]]++;
        }
    }
    // rep(i, n) {
    //     cout << rank[i] << ' ';
    // }
    // cout << endl;
    vector<int> wh(n);
    vector<int> nr(n);
    vector<int> nsa(n);
    for (int len = 1; len < n; len *= 2) {
        // cout << "ITER " << len << endl;
        rep(i, N) cnt[i] = 0;
        rep(i, n) cnt[rank[i]]++;
        for (int i = 1; i < N; ++i) cnt[i] += cnt[i - 1];
        for (int i = n - 1; i >= 0; --i) {
            if (sa[i] < len) continue;
            int pos = sa[i] - len;
            // cout << "i < n: " << cnt[rank[pos]] - 1 << ' ' << pos << endl;
            nsa[cnt[rank[pos]] - 1] = pos;
            cnt[rank[pos]]--;
        }
        for (int i = n + len - 1; i >= n; --i) {
            int pos = i - len;
            // cout << "i > n: " << cnt[rank[pos]] - 1 << ' ' << pos << endl;
            nsa[cnt[rank[pos]] - 1] = pos;
            cnt[rank[pos]]--;
        }

        swap(sa, nsa);
        // for (int i = n - 1; i >= 0; --i) {
        //     int pos = sa[i];
        //     sa[cnt[rank[pos]] - 1] = pos;
        //     cnt[rank[pos]]--;
        // }

        // rep(i, n) {
        //     cout << sa[i] << ' ';
        // }
        // cout << endl;

        nr[sa[0]] = 0;
        pii last = {0, (sa[0] + len < n ? rank[sa[0] + len] : 0)};
        for (int i = 1; i < n; ++i) {
            nr[sa[i]] = nr[sa[i - 1]];
            pii cur = {rank[sa[i]], (sa[i] + len < n ? rank[sa[i] + len] : 0)};
            if (last != cur) {
                nr[sa[i]]++;
            }
            last = cur;
        }
        swap(rank, nr);

        // for (auto it : sa) {
        //     cout << it << " (" << s.substr(it) << ")" << endl;
        // }
    }

    // vector<int> rank(n);
    // vector<int> pos(n);
    // rep(i, n) {
    //     pos[i] = 
    // }
    return sa;
}

vector<int> stup(string s) {
    vector<pair<string, int>> v;
    rep(i, s.size()) {
        v.push_back({s.substr(i), i});
    }
    sort(all(v));
    vector<int> res;
    rep(i, n) {
        res.push_back(v[i].s);
    }
    return res;
}

vector<int> build_lcp(string s, vector<int> sa) {
    int n = s.size();
    vector<int> lcp(n - 1);
    for (int i = 0; i + 1 < sa.size(); ++i) {
        lcp[i] = 0;
        while (sa[i] + lcp[i] < n && sa[i + 1] + lcp[i] < n && s[sa[i] + lcp[i]] == s[sa[i + 1] + lcp[i]]) {
            lcp[i]++;
        }
    }
    return lcp;
}

int best[MAXN];

void start(char w[]) {
    s = w;
    n = s.size();

    auto sa = build_sa(s);
    auto lcp = build_lcp(s, sa);

    set<string> good;
    rep(i, n) {
        int len = n - sa[i];
        if ((i == 0 || len > lcp[i - 1]) && (i == n - 1 || len > lcp[i])) {
            good.insert(s.substr(sa[i]));
        }
    }
    rep(i, n - 1) {
        good.insert(s.substr(sa[i], lcp[i]));
    }

    // for (auto it : good) {
    //     cout << it << endl;
    // }

    reverse(all(s));
    sa = build_sa(s);
    lcp = build_lcp(s, sa);

    set<string> ans;

    rep(i, n) {
        int len = n - sa[i];
        if ((i == 0 || len > lcp[i - 1]) && (i == n - 1 || len > lcp[i])) {
            string t = s.substr(sa[i]);
            reverse(all(t));
            // cout << t << endl;
            if (good.count(t)) ans.insert(t);
        }
    }
    rep(i, n - 1) {
        string t = s.substr(sa[i], lcp[i]);
        reverse(all(t));
        // cout << t << endl;
        if (good.count(t)) ans.insert(t);
    }

    reverse(all(s));

    // for (auto it : ans) {
    //     cout << it << endl;
    // }

    for (auto it : ans) {
        int cnt = get(it);
        best[it.size()] = max(best[it.size()], cnt);
    }

    // auto sa = build_sa(s);

    // // for (auto it : sa) {
    // //     cout << it << ' ';
    // // }
    // // cout << endl;
    // for (auto it : sa) {
    //     cout << s.substr(it) << endl;
    // }

    // auto lcp = build_lcp(s, sa);
    // for (auto it : lcp) {
    //     cout << it << ' ';
    // }
    // cout << endl;
}

int round(int m, int k) {
    // cout << "round " << m << ' ' << k << endl;
    int res = 0;
    for (int i = m; i <= k; ++i) {
        res = max(res, best[i]);
    }
    return res;
}
