#include "Sgame.h"
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define all(x) (x).begin(), (x).end()
#define FAST_IO ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define f first
#define s second
#define hash hash123
using pll = pair<ll, ll>;

const pll base = {41, 31};
const pll mod = {1e9 + 7, 1e9 + 9};
const int MAXN = 5e5 + 5;
int n;
string s;
pll pw[MAXN];
vector<pll> hash;

void init() {
    pw[0].f = 1;
    pw[0].s = 1;
    for (int i = 1; i < MAXN; ++i) {
        pw[i].f = (pw[i - 1].f * base.f) % mod.f;
        pw[i].s = (pw[i - 1].s * base.s) % mod.s;
    }
}

vector<pll> build_hash(const string &s) {
    int n = s.size();
    vector<pll> res(n);
    for (int i = 0; i < n; ++i) {
        res[i].f = (pw[i].f * (s[i] - 'a' + 1)) % mod.f;
        res[i].s = (pw[i].s * (s[i] - 'a' + 1)) % mod.s;
    }
    for (int i = 1; i < n; ++i) {
        res[i].f = (res[i - 1].f + res[i].f) % mod.f;
        res[i].s = (res[i - 1].s + res[i].s) % mod.s;
    }
    return res;
}

pll get_hash(const vector<pll> &h, int l, int r) {
    pll res = {h[r].f, h[r].s};
    if (l) {
        res.f = (res.f + mod.f - h[l - 1].f) % mod.f;
        res.s = (res.s + mod.s - h[l - 1].s) % mod.s;
    }
    res.f = (res.f * pw[n - l].f) % mod.f;
    res.s = (res.s * pw[n - l].s) % mod.s;
    return res;
}

// int get(string t) {
//     int res = 0;
//     for (int i = 0; i + t.size() <= s.size(); ++i) {
//         if (s.substr(i, t.size()) == t) {
//             res++;
//         }
//     }
//     return res;
// }

vector<int> build_sa(string s) {
    int n = s.size();
    vector<int> sa(n);
    int N = n + 500;
    vector<int> cnt(N);
    rep(i, n) {
        cnt[s[i]]++;
    }
    for (int i = 1; i < N; ++i) {
        cnt[i] += cnt[i - 1];
    }
    for (int i = n - 1; i >= 0; --i) {
        sa[cnt[s[i]] - 1] = i;
        cnt[s[i]]--;
    }

    vector<int> rank(n);
    rank[0] = 0;
    for (int i = 1; i < n; ++i) {
        rank[sa[i]] = rank[sa[i - 1]];
        if (s[sa[i - 1]] != s[sa[i]]) {
            rank[sa[i]]++;
        }
    }

    vector<int> wh(n);
    vector<int> nr(n);
    vector<int> nsa(n);
    for (int len = 1; len < n; len *= 2) {
        rep(i, N) cnt[i] = 0;
        rep(i, n) cnt[rank[i]]++;
        for (int i = 1; i < N; ++i) cnt[i] += cnt[i - 1];
        for (int i = n - 1; i >= 0; --i) {
            if (sa[i] < len) continue;
            int pos = sa[i] - len;
            nsa[cnt[rank[pos]] - 1] = pos;
            cnt[rank[pos]]--;
        }
        for (int i = n + len - 1; i >= n; --i) {
            int pos = i - len;
            nsa[cnt[rank[pos]] - 1] = pos;
            cnt[rank[pos]]--;
        }

        swap(sa, nsa);

        nr[sa[0]] = 0;
        pii last = {0, (sa[0] + len < n ? rank[sa[0] + len] : 0)};
        for (int i = 1; i < n; ++i) {
            nr[sa[i]] = nr[sa[i - 1]];
            pii cur = {rank[sa[i]], (sa[i] + len < n ? rank[sa[i] + len] : 0)};
            if (last != cur) {
                nr[sa[i]]++;
            }
            last = cur;
        }
        swap(rank, nr);
    }

    return sa;
}

// vector<int> stup(string s) {
//     vector<pair<string, int>> v;
//     rep(i, s.size()) {
//         v.push_back({s.substr(i), i});
//     }
//     sort(all(v));
//     vector<int> res;
//     rep(i, n) {
//         res.push_back(v[i].s);
//     }
//     return res;
// }

vector<int> build_lcp(string s, vector<int> sa) {
    auto hash = build_hash(s);

    // int n = s.size();
    // vector<int> lcp(n - 1);
    // for (int i = 0; i + 1 < sa.size(); ++i) {
    //     lcp[i] = 0;
    //     while (sa[i] + lcp[i] < n && sa[i + 1] + lcp[i] < n && s[sa[i] + lcp[i]] == s[sa[i + 1] + lcp[i]]) {
    //         lcp[i]++;
    //     }
    // }
    // return lcp;
    int n = s.size();
    vector<int> lcp(n - 1);
    for (int i = 0; i + 1 < sa.size(); ++i) {
        int l = 0, r = n - max(sa[i], sa[i + 1]) + 1;
        while (r - l > 1) {
            int m = l + (r - l) / 2;
            if (get_hash(hash, sa[i], sa[i] + m - 1) == get_hash(hash, sa[i + 1], sa[i + 1] + m - 1)) {
                l = m;
            } else {
                r = m;
            }
        }
        lcp[i] = l;
    }

    // rep(i, n) {
    //     cout << s.substr(sa[i]) << endl;
    //     if (i != n - 1) {
    //         rep(j, lcp[i]) {
    //             cout << '=';
    //         }
    //         cout << endl;
    //     }
    // }

    return lcp;
}

int best[MAXN];
int t[MAXN * 4];

void build(int v, int tl, int tr) {
    if (tr - tl == 1) {
        t[v] = best[tl];
        return;
    }

    int tm = tl + (tr - tl) / 2;
    build(v * 2 + 1, tl, tm);
    build(v * 2 + 2, tm, tr);
    t[v] = max(t[v * 2 + 1], t[v * 2 + 2]);
}

int get(int v, int tl, int tr, int l, int r) {
    if (r <= tl || tr <= l) return 0;
    if (l <= tl && tr <= r) return t[v];

    int tm = tl + (tr - tl) / 2;
    int a = get(v * 2 + 1, tl, tm, l, r);
    int b = get(v * 2 + 2, tm, tr, l, r);
    return max(a, b);
}

// int sp[20][MAXN];
// int min_pw[MAXN];

// void build_sp(const vector<ll> &lcp) {
//     min_pw[0] = 0;
//     min_pw[1] = 0;
//     for (int i = 2; i < MAXN; ++i) {
//         min_pw[i] = min_pw[i / 2] + 1;
//     }
//     int n = lcp.size();
//     rep(i, n) {
//         sp[0][i] = lcp[i];
//     }
//     for (int pw = 1; pw < 20; ++pw) {
//         for (int i = 0; i + (1 << pw) <= n; ++i) {
//             sp[pw][i] = min(sp[pw - 1][i], sp[pw - 1][i + (1 << (pw - 1))]);
//         }
//     }
// }

// int get_sp(int l, int r) {
//     assert(r >= l);
//     int pw = min_pw[r - l + 1];
//     return min(pw, )
// }

vector<int> get_less(const vector<int> &a) {
    vector<int> st;
    int n = a.size();
    vector<int> res(n);
    rep(i, n) {
        while (!st.empty() && a[st.back()] >= a[i]) {
            st.pop_back();
        }
        if (st.empty()) {
            res[i] = -1;
        } else {
            res[i] = st.back();
        }
        st.push_back(i);
    }
    return res;
}

void start(char w[]) {
    s = w;
    n = s.size();
    init();

    hash = build_hash(s);

    auto sa = build_sa(s);
    auto lcp = build_lcp(s, sa);

    auto prev_min = get_less(lcp);
    reverse(all(lcp));
    auto next_min = get_less(lcp);
    reverse(all(lcp));
    reverse(all(next_min));
    rep(i, n - 1) {
        next_min[i] = (n - 1) - next_min[i] - 1;
    }

    vector<int> lcp_cnt(n - 1);
    rep(i, n - 1) {
        lcp_cnt[i] = next_min[i] - prev_min[i];
    }

    // rep(i, n - 1) {
    //     cout << lcp[i] << ' ';
    // }
    // cout << endl;
    // rep(i, n - 1) {
    //     cout << prev_min[i] << ' ';
    // }
    // cout << endl;
    // rep(i, n - 1) {
    //     cout << next_min[i] << ' ';
    // }
    // cout << endl;
    // rep(i, n - 1) {
    //     cout << lcp_cnt[i] << ' ';
    // }
    // cout << endl;

    // set<string> good;
    map<pll, pair<int, int>> good; // len, cnt

    rep(i, n) {
        int len = n - sa[i];
        if ((i == 0 || len > lcp[i - 1]) && (i == n - 1 || len > lcp[i])) {
            // good.insert(s.substr(sa[i]));
            pll h = get_hash(hash, sa[i], n - 1);
            // cout << s.substr(sa[i]) << ' ' << h << endl;
            good[h] = {n - sa[i], 1};
        }
    }
    rep(i, n - 1) {
        // good.insert(s.substr(sa[i], lcp[i]));
        pll h = get_hash(hash, sa[i], sa[i] + lcp[i] - 1);
        // cout << s.substr(sa[i], lcp[i]) << ' ' << h << endl;
        // good[h] = {lcp[i], get(s.substr(sa[i], lcp[i]))};
        good[h] = {lcp[i], lcp_cnt[i]};
    }
    // cout << endl << endl;

    // for (auto it : good) {
    //     cout << it << endl;
    // }

    reverse(all(s));
    sa = build_sa(s);
    lcp = build_lcp(s, sa);

    // set<string> ans;
    set<pair<int, int>> ans;

    rep(i, n) {
        int len = n - sa[i];
        if ((i == 0 || len > lcp[i - 1]) && (i == n - 1 || len > lcp[i])) {
            // string t = s.substr(sa[i]);
            // reverse(all(t));
            // cout << t << endl;
            pll h = get_hash(hash, 0, n - sa[i] - 1);
            // cout << t << ' ' << h << endl;
            // if (good.count(t)) ans.insert(t);
            if (good.count(h)) {
                ans.insert(good[h]);
            }
        }
    }
    rep(i, n - 1) {
        // string t = s.substr(sa[i], lcp[i]);
        // reverse(all(t));
        // cout << t << endl;
        pll h = get_hash(hash, n - (sa[i] + lcp[i] - 1) - 1, n - sa[i] - 1);
        // cout << t << ' ' << h << endl;
        // if (good.count(t)) ans.insert(t);
        if (good.count(h)) {
            ans.insert(good[h]);
        }
    }

    reverse(all(s));

    // for (auto it : ans) {
    //     cout << it << endl;
    // }

    for (auto it : ans) {
        best[it.f] = it.s;
        // int cnt = get(it);
        // best[it.size()] = max(best[it.size()], cnt);
    }

    // auto sa = build_sa(s);

    // // for (auto it : sa) {
    // //     cout << it << ' ';
    // // }
    // // cout << endl;
    // for (auto it : sa) {
    //     cout << s.substr(it) << endl;
    // }

    // auto lcp = build_lcp(s, sa);
    // for (auto it : lcp) {
    //     cout << it << ' ';
    // }
    // cout << endl;

    build(0, 0, MAXN);
}

int round(int m, int k) {
    // cout << "round " << m << ' ' << k << endl;
    // int res = 0;
    // for (int i = m; i <= k; ++i) {
    //     res = max(res, best[i]);
    // }
    return get(0, 0, MAXN, m, k + 1);
}
