#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#pragma GCC optimize("Ofast")

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(const T &x, ostream& out = cerr) {
	output(all(x), out);
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b; 
		return 1;
	}
	return 0;
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int mx = 5e5 + 228;
int n, m, clr[mx], U[mx], V[mx], deg[mx], cnt[mx], to[2 * mx], srt[mx];
int deg_ptr[mx], cnt_ptr[mx];

void calc_deg_ptr() {
	deg_ptr[0] = 0;
	for (int i = 1; i < n; ++i) {
		deg_ptr[i] = deg_ptr[i - 1] + deg[i - 1];
	}
}

void calc_cnt_ptr() {
	cnt_ptr[0] = 0;
	for (int i = 1; i < n; ++i) {
		cnt_ptr[i] = cnt_ptr[i - 1] + cnt[i - 1];
	}
}

void read_graph() {
	cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		cin >> U[i] >> V[i];
		U[i]--;
		V[i]--;
		if (U[i] > V[i]) {
			swap(U[i], V[i]);
		}
		deg[U[i]]++;
		deg[V[i]]++;
		cnt[V[i] - U[i]]++;
	}
	calc_deg_ptr();
	for (int i = 0; i < m; ++i) {
		to[deg_ptr[U[i]]++] = V[i];
		to[deg_ptr[V[i]]++] = U[i];
	}
	calc_cnt_ptr();
	for (int i = 0; i < m; ++i) {
		srt[cnt_ptr[V[i] - U[i]]++] = i;
	}
	calc_deg_ptr();
	calc_cnt_ptr();

	// cerr << "deg" << endl;
	// output(deg, deg + n);
	// cerr << "to" << endl;
	// output(to, to + 2 * m);
}

void print() {
	cout << (*max_element(clr, clr + n)) + 1 << endl;
	for (int i = 0; i < n; ++i) {
		cout << clr[i] + 1 << " ";
	}
	cout << endl;
}

int in_perm[mx];
vector<int> perm;

void enable(int v) {
	if (in_perm[v] == 0) {
		perm.push_back(v);
		in_perm[v] = 1;
	}
}

void build_perm() {
	for (int i = m - 1; i >= 0; --i) {
		int id = srt[i];
		enable(U[id]);
		enable(V[id]);
	}
	for (int i = 0; i < n; ++i) {
		enable(i);
	}
	// cerr << "perm" << endl;
	// output(all(perm));
	// cerr << "deg_ptr" << endl;
	// output(deg_ptr, deg_ptr + n);
}

void make3() {
	fill(clr, clr + n, -1);
	vector<int> used(3);
	for (int i = 0; i < n; ++i) {
		int v = perm[i];
		for (int j = 0; j < 3; ++j) {
			used[j] = 0;
		}
		for (int id = deg_ptr[v]; id < deg_ptr[v] + deg[v]; ++id) {
			int v1 = to[id];
			if (clr[v1] != -1) {
				used[clr[v1]] = 1;
			}
		}
		for (int j = 0; j < 3; ++j) {
			if (used[j] == 0) {
				clr[v] = j;
				break;
			}
		}
		assert(clr[v] != -1);
	}
	print();
}

int main() {
	fast_io();
	read_graph();
	build_perm();
	make3();
}
