#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(const T &x, ostream& out = cerr) {
	output(all(x), out);
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

struct fenwick {
	fenwick() {}

	vector<int> t;
	int n;

	void init(int _n) {
		n = _n;
		t.resize(n);
	}

	void add(int pos, int val) {
		while (pos < n) {
			t[pos] += val;
			pos = (pos | (pos + 1));
		}
	}

	int get(int r) {
		int res = 0;
		while (r >= 0) {
			res += t[r];
			r = (r & (r + 1)) - 1;
		}
		return res;
	}

	int get(int l, int r) {
		return get(r) - get(l - 1);
	}

	void update(int pos, int val) {
		add(pos, val - get(pos, pos));
	}
} f;

const int mx = 3e5 + 228;
int n, p[mx], infected[mx], tin[mx], tout[mx], timer;
vector<vector<int> > children;
vector<set<int> > infected_children;

void dfs(int v) {
	tin[v] = timer++;
	for (auto v1 : children[v]) {
		dfs(v1);
	}
	tout[v] = timer - 1;
}

void infect(int v) {
	f.update(v, 1);
	if (v != 0) {
		infected_children[p[v]].insert(v);
	}
}

void clear_with_children(int v) {
	f.update(v, 0);
	if (v != 0) {
		infected_children[p[v]].erase(v);
	}
	for (auto v1 : infected_children[v]) {
		f.update(v1, 0);
	}
	infected_children[v].clear();
}

int get(int v) {
	int res = f.get(tin[v], tout[v]);
	return res;
}

void read_tree() {
	cin >> n;
	infected_children.resize(n);
	children.resize(n);
	for (int i = 1; i < n; ++i) {
		cin >> p[i];
		p[i]--;
		children[p[i]].push_back(i);
	}
	dfs(0);
	f.init(n);
}

void process() {
	int q;
	cin >> q;
	for (int i = 0; i < q; ++i) {
		int type, v;
		cin >> type >> v;
		v--;
		if (type == 1) {
			 infect(v);
		}
		if (type == 3) {
			clear_with_children(v);
		}
		if (type == 4) {
			int res = get(v);
			cout << res << "\n";
		}
	}
}

int main() {
	fast_io();
	read_tree();
	process();
}
