#include "Sgame.h"
#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(const T &x, ostream& out = cerr) {
	output(all(x), out);
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int mx = 5e5 + 228;
const int K = 26;

struct node {
	vector<int> go;
	int link, len, term;

	node(): go(vector<int> (K, -1)), link(-1), len(0), term(0) {}
};

vector<node> nd;
int last;

void init() {
	nd.emplace_back();
	last = 0;
}

void expand(int c) {
	// cerr << "expand " << c << endl;
	int t = nd.size(), p;
	nd.emplace_back();
	nd[t].len = nd[last].len + 1;
	nd[t].term = 1;
	for (p = last; p != -1 && nd[p].go[c] == -1; p = nd[p].link) {
		nd[p].go[c] = t;
	}
	if (p == -1) {
		nd[t].link = 0;
	} else {
		int q = nd[p].go[c];
		if (nd[q].len == nd[p].len + 1) {
			nd[t].link = q;
		} else {
			// cerr << "p = " << p << endl;
			// cerr << "q = " << q << endl;
			int clone = nd.size();
			// cerr << "clone = " << clone << endl;
			nd.emplace_back();
			nd[clone].go = nd[q].go;
			nd[clone].link = nd[q].link;
			nd[clone].len = nd[p].len + 1;
			nd[t].link = nd[q].link = clone;
			for (int v = p; v != -1 && nd[v].go[c] == q; v = nd[v].link) {
				nd[v].go[c] = clone;
			}
		}
	}
	last = t;
}

void print() {
	for (int i = 0; i < nd.size(); ++i) {
		cerr << "node " << i << " [";
		cerr << "link: " << nd[i].link << ", len: " << nd[i].len << "]" << endl;
		for (int j = 0; j < K; ++j) {
			if (nd[i].go[j] != -1) {
				cerr << (char)('a' + j) << " -> " << nd[i].go[j] << endl;
			}
		}
	}
}

int max_occ[mx];

vector<vector<int> > children;

void dfs(int v) {
	for (auto v1 : children[v]) {
		dfs(v1);
		nd[v].term += nd[v1].term;
	}
}

int n;

void calc_ans() {
	int S = nd.size();
	children.resize(S);
	for (int i = 1; i < S; ++i) {
		children[nd[i].link].push_back(i);
	}
	dfs(0);
	for (int i = 0; i < S; ++i) {
		chkmax(max_occ[nd[i].len], nd[i].term);
	}
	for (int i = n - 1; i >= 1; --i) {
		chkmax(max_occ[i], max_occ[i + 1]);
	}
}

string s;

void start(char *w) {
	while (w[n] != 0) {
		s.push_back(w[n++]);
	}
	init();
	for (int i = 0; i < n; ++i) {
		expand(s[i] - 'a');
	}
	// print();
	calc_ans();
}

int round(int m, int k) {
	assert(k == n);
	return max_occ[m];
}
