#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(const T &x, ostream& out = cerr) {
	output(all(x), out);
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int mx = 3e5 + 228;
int n, p[mx], infected[mx];
vector<vector<int> > children;

void infect(int v) {
	infected[v] = 1;
}

void clear_path(int v, int ch) {
	if (infected[v]) {
		infected[v] = 0;
		for (auto v1 : children[v]) {
			if (v1 != ch) {
				infected[v1] = 1;
			}
		}
	}
	if (v != 0) {
		clear_path(p[v], v);
	}
}

void clear_path(int v) {
	clear_path(v, v);
}

void clear_with_children(int v) {
	infected[v] = 0;
	for (auto v1 : children[v]) {
		infected[v1] = 0;
	}
}

int dfs(int v) {
	int res = infected[v];
	for (auto v1 : children[v]) {
		res += dfs(v1);
	}
	return res;
}

int get(int v) {
	int res = dfs(v);
	return res;
}

void read_tree() {
	cin >> n;
	children.resize(n);
	for (int i = 1; i < n; ++i) {
		cin >> p[i];
		p[i]--;
		children[p[i]].push_back(i);
	}
}

void process() {
	int q;
	cin >> q;
	for (int i = 0; i < q; ++i) {
		int type, v;
		cin >> type >> v;
		v--;
		if (type == 1) {
			 infect(v);
		}
		if (type == 2) {
			clear_path(v);
		}
		if (type == 3) {
			clear_with_children(v);
		}
		if (type == 4) {
			int res = get(v);
			cout << res << "\n";
		}
	}
}

int main() {
	fast_io();
	read_tree();
	process();
}
