#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(const T &x, ostream& out = cerr) {
	output(all(x), out);
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b; 
		return 1;
	}
	return 0;
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int mx = 5e5 + 228;
int n, m, clr[mx];
vector<vector<pair<int, int> > > g;
vector<pair<int, int> > e;

void read_graph() {
	cin >> n >> m;
	g.resize(n);
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		u--;
		v--;
		if (u > v) {
			swap(u, v);
		}
		g[u].emplace_back(v, i);
		g[v].emplace_back(u, i);
		e.emplace_back(u, v);
	}
}

int dfs(int v, int new_clr) {
	clr[v] = new_clr;
	for (auto pp : g[v]) {
		int v1 = pp.first;
		if (clr[v1] != -1 && clr[v1] == new_clr) {
			return 1;
		}
		if (clr[v1] == -1 && dfs(v1, new_clr ^ 1)) {
			return 1;
		}
	}
	return 0;
}

void print() {
	cout << (*max_element(clr, clr + n)) + 1 << endl;
	for (int i = 0; i < n; ++i) {
		cout << clr[i] + 1 << " ";
	}
	cout << endl;
}

void check2() {
	fill(clr, clr + n, -1);
	for (int i = 0; i < n; ++i) {
		if (clr[i] == -1 && dfs(i, 0)) {
			return;
		}
	}
	print();
	exit(0);
}

int in_perm[mx];
vector<int> perm;
vector<vector<int> > children;

void enable(int v) {
	if (in_perm[v] == 0) {
		perm.push_back(v);
		in_perm[v] = 1;
	}
}

void edge_dfs(int en) {
	for (auto v1 : children[en]) {
		enable(e[v1].first);
		enable(e[v1].second);
	}
	for (auto v1 : children[en]) {
		edge_dfs(v1);
	}
}

void build_perm() {
	for (int i = 0; i < n; ++i) {
		sort(rall(g[i]));
	}
	vector<int> st;
	children.resize(e.size());
	for (int i = 0; i < n; ++i) {
		for (auto pp : g[i]) {
			int v = pp.first;
			if (v > i) {
				continue;
			}
			while (!st.empty()) {
				if (v <= e[st.back()].first) {
					children[pp.second].push_back(st.back());
					st.pop_back();
				} else {
					break;
				}
			}
			st.push_back(pp.second);
		}
	}
	for (auto id : st) {
		enable(e[id].first);
		enable(e[id].second);
	}
	for (auto id : st) {
		edge_dfs(id);
	}
	for (int i = 0; i < n; ++i) {
		enable(i);
	}
}

void make3() {
	fill(clr, clr + n, -1);
	vector<int> used(3);
	for (int i = 0; i < n; ++i) {
		int v = perm[i];
		for (int j = 0; j < 3; ++j) {
			used[j] = 0;
		}
		for (auto pp : g[v]) {
			int v1 = pp.first;
			if (clr[v1] != -1) {
				used[clr[v1]] = 1;
			}
		}
		for (int j = 0; j < 3; ++j) {
			if (used[j] == 0) {
				clr[v] = j;
				break;
			}
		}
		assert(clr[v] != -1);
	}
	print();
}

int main() {
	fast_io();
	read_graph();
	check2();
	build_perm();
	make3();
}
