#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
#define FOR(i, n) for (int i = 0; i < n; ++i)
#define debug(x) std::cout << #x << ": " << x << '\n';
#define pb push_back
typedef long long ll;
const int N = 3e5 + 100, LG = 17;
int pred[N], used[N], tin[N], tout[N], timer = 0, LCA[N][LG];
std::vector<int> g[N];
struct fenw
{
	ll f[N];
	fenw() {
		memset(f, 0, sizeof(f));
	}
	void upd(int i, int x) {
		for (; i < N; i = (i | (i + 1))) {
			f[i] += x;
		}
	}
	void upd(int l, int r, int x) {
		upd(l, x);
		upd(r + 1, -x);
	}
	ll get(int r) {
		ll s = 0;
		for (; r >= 0; r = (r & (r + 1)) - 1) {
			s += f[r];
		}
		return s;
	}
	ll get(int l, int r) {
		return get(r) - get(l - 1);
	}
};
fenw tree1, tree2;
int n;
void dfs(int v) {
	if (v == 0) LCA[v][0] = 0;
	else LCA[v][0] = pred[v];
	for (int i = 1; i < LG; ++i) {
		LCA[v][i] = LCA[LCA[v][i - 1]][i];
	}
	tin[v] = timer++;
	for (auto e : g[v]) {
		dfs(e);
	}
	tout[v] = timer - 1;
}
void updVertex(int x, int delta) {
	tree1.upd(tin[x], delta);
	tree2.upd(tin[x], tout[x], delta);
}
int getSubtree(int x) {
	return tree1.get(tin[x], tout[x]);
}
int getVertex(int x) {
	return tree1.get(tin[x], tin[x]);
}
int getPath(int x) {
	return tree2.get(tin[x]);
}
void clearVertex(int x) {
	if (getVertex(x)) {
		updVertex(x, -1);
	}
	for (auto e : g[x]) {
		if (getVertex(e)) {
			updVertex(e, -1);
		}
	}
}
inline bool isPred(int &a, int &b) {
	return tin[a] <= tin[b] && tout[a] >= tout[b];
}
void propVertex(int x, int from) {
	updVertex(x, -1);
	for (auto e : g[x]) {
		if (!isPred(e, from) && !getVertex(e)) {
			updVertex(e, 1);
		}
	}
}
int find(int x) {
	for (int i = LG - 1; i >= 0; --i) {
		int to = LCA[x][i];
		if (getPath(to) == getPath(x)) {
			x = to;
		}
	}
	return x;
}
int main() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(0);
	std::cin >> n;
	pred[0] = -1;
	FOR(i, n - 1) {
		int p;
		std::cin >> p;
		--p;
		g[p].pb(i + 1);
		pred[i + 1] = p;
	}
	dfs(0);
	// FOR(i, n) {
	// 	debug(tin[i] << ' ' << tout[i])
	// }
	int q;
	std::cin >> q;
	FOR(QUERY, q) {
		int t, x;
		std::cin >> t >> x;
		if (t == 1) {
			--x;
			if (!getVertex(x))
				updVertex(x, 1);
		}
		if (t == 2) {
			--x;
			while (getPath(x) != 0) {
				int go = find(x);
				propVertex(go, x);
				x = go;
			}
		}
		if (t == 3) {
			--x;
			clearVertex(x);
		}
		if (t == 4) {
			--x;
			// debug(tin[x] << ' ' << tout[x])
			std::cout << getSubtree(x) << '\n';
		}
	}
}