#include <bits/stdc++.h>
#define FOR(i, n) for (int i = 0; i < n; ++i)
#define debug(x) std::cout << #x << ": " << x << '\n';
#define pb push_back
typedef long long ll;
const int N = 3e5 + 100, LG = 5;
int pred[N], used[N], tin[N], tout[N], timer = 0, LCA[N][LG];
std::vector<int> g[N];
struct seg_tree
{
	ll tree[4 * N], push[4 * N];
	void doPush(int v, int tl, int tr) {
		tree[v] += push[v] * (tr - tl + 1);
		if (2 * v < 4 * N) {
			push[2 * v] += push[v];
			push[2 * v + 1] += push[v];
		}
		push[v] = 0;
	}
	void upd(int v, int tl, int tr, int l, int r, int x) {
		doPush(v, tl, tr);
		if (l > r) return;
		if (tl == l && tr == r) {
			push[v] += x;
			doPush(v, tl, tr);
			return;
		}
		int tm = (tl + tr) / 2;
		upd(v * 2, tl, tm, l, std::min(r, tm), x);
		upd(v * 2 + 1, tm + 1, tr, std::max(l, tm + 1), r, x);
		tree[v] = tree[v * 2] + tree[v * 2 + 1];
	}
	ll get(int v, int tl, int tr, int l, int r) {
		if (l > r) return 0;
		doPush(v, tl, tr);
		if (tl == l && tr == r) {
			return tree[v];
		}
		int tm = (tl + tr) / 2;
		return get(v * 2, tl, tm, l, std::min(r, tm)) + get(v * 2 + 1, tm + 1, tr, std::max(l, tm + 1), r);
	}
};
seg_tree tree1, tree2;
int n;
void dfs(int v) {
	if (v == 0) LCA[v][0] = 0;
	else LCA[v][0] = pred[v];
	for (int i = 1; i < LG; ++i) {
		LCA[v][i] = LCA[LCA[v][i - 1]][i];
	}
	tin[v] = timer++;
	for (auto e : g[v]) {
		dfs(e);
	}
	tout[v] = timer - 1;
}
std::set<int> good[N], bad[N];
void updVertex(int x, int delta) {
	// debug(x << ' ' << delta)
	if (pred[x] != -1) {
		if (delta == 1) {
			good[pred[x]].erase(x);
			bad[pred[x]].insert(x);
		}
		if (delta == -1) {
			good[pred[x]].insert(x);
			bad[pred[x]].erase(x);
		}
	}
	tree1.upd(1, 0, n - 1, tin[x], tin[x], delta);
	tree2.upd(1, 0, n - 1, tin[x], tout[x], delta);
}
int getSubtree(int x) {
	return tree1.get(1, 0, n - 1, tin[x], tout[x]);
}
int getVertex(int x) {
	return tree1.get(1, 0, n - 1, tin[x], tin[x]);
}
int getPath(int x) {
	return tree2.get(1, 0, n - 1, tin[x], tin[x]);
}
void clearVertex(int x) {
	if (getVertex(x)) {
		updVertex(x, -1);
	}
	for (auto e : bad[x]) {
		updVertex(e, -1);
		// good[x].insert(e);
	}
	// bad[x].clear();
}
inline bool isPred(int &a, int &b) {
	return tin[a] <= tin[b] && tout[a] >= tout[b];
}
void propVertex(int x, int from) {
	updVertex(x, -1);
	for (auto e : good[x]) {
		if (!isPred(e, from)) {
			updVertex(e, 1);
			// bad[x].insert(e);
			// nowGood.pb(e);
		}
	}
	// for (auto e : nowGood) {
	// 	good[x].erase(e);
	// }
}
int find(int x) {
	for (int i = LG - 1; i >= 0; --i) {
		int to = LCA[x][i];
		if (getPath(to) == getPath(x)) {
			x = to;
		}
	}
	return x;
}
int main() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(0);
	std::cin >> n;
	pred[0] = -1;
	FOR(i, n - 1) {
		int p;
		std::cin >> p;
		--p;
		g[p].pb(i + 1);
		pred[i + 1] = p;
	}
	FOR(i, n) {
		for (auto e : g[i]) {
			good[i].insert(e);
		}
	}
	dfs(0);
	int q;
	std::cin >> q;
	FOR(QUERY, q) {
		int t, x;
		std::cin >> t >> x;
		if (t == 1) {
			--x;
			int delta = 1 - getVertex(x);
			updVertex(x, delta);
		}
		if (t == 2) {
			--x;
			while (getPath(x) != 0) {
				int go = find(x);
				propVertex(go, x);
				x = go;
			}
		}
		if (t == 3) {
			--x;
			clearVertex(x);
		}
		if (t == 4) {
			--x;
			std::cout << getSubtree(x) << '\n';
		}
	}
}