#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

#define x first
#define y second
#define all(x) begin(x), end(x)
#define sz(x) (int((x).size()))
typedef long long ll;
typedef long double float80;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const int MAX_N = 5e5 + 10;

vector<int> edges[MAX_N];
int seenBefore[MAX_N];

int answer[MAX_N], glans;

map<pair<int, int>, int> solvemem;

int solveFor(int l, int r) {
	// cout << "solving for " << l << " " << r << endl;
	bool isConnected = true;
	bool hasEdge = false;
	int curr = l;
	if (seenBefore[l] != 0 && edges[l][seenBefore[l] - 1] == r) {
		--seenBefore[l];
		hasEdge = true;
	}
	int ans = 1;
	int iterations = 0;
	while (curr != r) {
		// cout << curr << endl;
		if (seenBefore[curr] == 0) {
			isConnected = false;
			++curr;
		} else {
			int next = edges[curr][seenBefore[curr] - 1];
			ans = max(ans, solveFor(curr, next));
			curr = next;
		}
		++iterations;
	}
	// cout << "on " << l << " " << r << ": " << ans << " " << hasEdge << " " << iterations << " " << isConnected << "\n";
	if (hasEdge)
		ans = max(ans, 2);
	if (hasEdge && isConnected && ans == 2 && !(iterations & 1))
		ans = 3;
	return solvemem[{l, r}] = ans;
}

int n;
int perm[4];

void buildAns(int l, int r) {
	// cout << "building ans " << l << " " << r << endl;
	assert(0 <= l && l < r && r < n);
	vector<pair<int, int>> ce;
	vector<int> cv;
	bool isConnected = true;
	bool hasEdge = false;
	int curr = l;
	if (seenBefore[l] != 0 && edges[l][seenBefore[l] - 1] == r) {
		--seenBefore[l];
		hasEdge = true;
	}
	assert((l == 0 && r == n - 1) || hasEdge);
	int ans = 1;
	int iterations = 0;
	while (curr != r) {
		// cout << curr << endl;
		cv.push_back(curr);
		if (seenBefore[curr] == 0) {
			isConnected = false;
			// ce.push_back({curr, -1});
			++curr;
		} else {
			int next = edges[curr][seenBefore[curr] - 1];
			assert(solvemem.find({curr, next}) != solvemem.end());
			ans = max(ans, solvemem[{curr, next}]);
			ce.push_back({curr, next});
			curr = next;
		}
		++iterations;
	}
	cv.push_back(r);
	int oldl = answer[l], oldr = answer[r];
	int color = 1;
	for (int u : cv) {
		answer[u] = color;
		color = 3 - color;
	}
	// for (int i = 0; i < n; ++i)
	// 	cout << answer[i] << " ";
	// cout << "\n";
	if (hasEdge) {
		assert(oldl == 0 || oldl != oldr);
		if (answer[r] == answer[l]) {
			if (isConnected) {
				answer[r] = 3;
			} else {
				int prev = r;
				int currit = ce.size() - 1;
				while (ce[currit].y == prev) {
					// cout << "invert " << prev << "\n";
					answer[prev] = 3 - answer[prev];
					prev = ce[currit].x;
					--currit;
					assert(currit >= 0);
				}
				answer[prev] = 3 - answer[prev];
			}
		}
	}
	// for (int i = 0; i < n; ++i)
	// 	cout << answer[i] << " ";
	// cout << "\n";
	if (oldl == 0) {
		assert(oldr == 0);
	} else {
		perm[answer[l]] = oldl;
		perm[answer[r]] = oldr;
		perm[6 - answer[l] - answer[r]] = 6 - oldl - oldr;
		for (int v : cv) {
			answer[v] = perm[answer[v]];
		}
	}
	// for (int i = 0; i < n; ++i)
	// 	cout << answer[i] << " ";
	// cout << "\n";
	for (auto e : ce)
		buildAns(e.x, e.y);
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int m;
	cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		if (a > b)
			swap(a, b);
		--a, --b;
		edges[a].push_back(b);
	}
	for (int i = 0; i < n; ++i) {
		sort(all(edges[i]));
		seenBefore[i] = edges[i].size();
	}
	glans = solveFor(0, n - 1);
	for (int i = 0; i < n; ++i)
		seenBefore[i] = edges[i].size();
	cout << glans << "\n";
	buildAns(0, n - 1);
	for (int i = 0; i < n; ++i)
		cout << answer[i] << " ";
	cout << "\n";
	return 0;
}