#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

#define x first
#define y second
#define all(x) begin(x), end(x)
#define sz(x) (int((x).size()))
typedef long long ll;
typedef long double float80;

const int MAX_N = 524288, MAX_TREE = 1048576;

vector<int> children[MAX_N];
int parent[MAX_N];

int stIndex[MAX_N];
int timer = 0;
int endSubsttree[MAX_N];

void dfs(int u) {
	stIndex[u] = timer++;
	for (int v : children[u])
		dfs(v);
	endSubsttree[u] = timer - 1;
}

int sttree[MAX_TREE];

void add(int i, int c) {
	i += MAX_N;
	while (i) {
		sttree[i] += c;
		i /= 2;
	}
}

int getSum(int l, int r) {
	l += MAX_N;
	r += MAX_N;
	int res = 0;
	while (l <= r) {
		if (l & 1)		res += sttree[l];
		if (!(r & 1))	res += sttree[r];
		l = (l + 1) / 2;
		r = (r - 1) / 2;
	}
	return res;
}

char isBad[MAX_N];

void setBad(int u) {
	// cout << "set bad " << u << endl;
	if (isBad[u])
		return;
	isBad[u] = 1;
	add(stIndex[u], 1);
}

void setGood(int u) {
	// cout << "set good " << u << endl;
	if (!isBad[u])
		return;
	isBad[u] = 0;
	add(stIndex[u], -1);
}

int query4(int u) {
	// cout << "In ST: " << stIndex[u] << " " << endSubsttree[u] << "\n";
	return getSum(stIndex[u], endSubsttree[u]);
}

int ultrasound[MAX_N];
int ultrasoundVersion = 15;

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n, q;
	cin >> n;
	for (int i = 1; i < n; ++i) {
		cin >> parent[i];
		--parent[i];
		children[parent[i]].push_back(i);
	}
	dfs(0);
	parent[0] = -1;
	cin >> q;
	for (int i = 0; i < q; ++i) {
		int type, u;
		cin >> type >> u;
		// cout << type << " " << u << "\n";
		--u;
		if (type == 1) {
			setBad(u);
		} else if (type == 2) {
			++ultrasoundVersion;
			while (u != -1) {
				if (isBad[u]) {
					setGood(u);
					for (int v : children[u]) {
						if (ultrasound[v] != ultrasoundVersion)
							setBad(v);
					}
				}
				ultrasound[u] = ultrasoundVersion;
				u = parent[u];
			}
		} else if (type == 3) {
			setGood(u);
			for (int v : children[u])
				setGood(v);
		} else if (type == 4) {
			// for (int i = 0; i < n; ++i)
			// 	cout << isBad[i] + 0 << " ";
			// cout << "\n";
			cout << query4(u) << "\n";
		}
		// cout << "Done " << i << endl;
	}
	return 0;
}