#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "Sgame.h"
using namespace std;
using namespace __gnu_pbds;

#define x first
#define y second
#define all(x) begin(x), end(x)
#define sz(x) (int((x).size()))
typedef long long ll;
typedef long double float80;

const int MAX_N = 524288, MAX_NODES = 1048576, MAX_TREE = 1048576;

int nextAlloc = 0;
int go[MAX_NODES][26];
int len[MAX_NODES], link[MAX_NODES];

inline int allocVertex() {
	assert(nextAlloc < MAX_NODES);
	len[nextAlloc] = link[nextAlloc] = -1;
	for (int i = 0; i < 26; ++i)
		go[nextAlloc][i] = -1;
	return nextAlloc++;
}

struct SA {
	int last, root;
	char shift;

	SA(char shift_) : last(allocVertex()), root(last), shift(shift_) {
		len[last] = 0;
	}

	int cloneVertex(int u) {
		int res = allocVertex();
		for (int i = 0; i < 26; ++i)
			go[res][i] = go[u][i];
		len[res] = len[u];
		link[res] = link[u];
		return res;
	}

	void append(int x) {
		int c = x - shift;
		int nlast = allocVertex();
		int p = last;
		len[nlast] = len[last] + 1;
		last = nlast;
		while (p != -1 && go[p][c] == -1) {
			go[p][c] = nlast;
			p = link[p];
		}
		if (p == -1) {
			link[last] = root;
		} else {
			int bad = go[p][c];
			if (len[bad] == len[p] + 1) {
				link[last] = bad;
			} else {
				int cloned = cloneVertex(bad);
				// cout << "cloning " << bad << " to " << cloned << endl;
				link[last] = cloned;
				len[cloned] = len[p] + 1;
				link[bad] = cloned;
				while (p != -1 && go[p][c] == bad) {
					go[p][c] = cloned;
					p = link[p];
				}
			}
		}
	}
} sa('a');

int n;

int cnt[MAX_NODES];
char used[MAX_NODES];

int sttree[MAX_TREE];

void maxEquals(int l, int r, int value) {
	l += MAX_N;
	r += MAX_N;
	while (l <= r) {
		if (l & 1)		sttree[l] = max(sttree[l], value);
		if (!(r & 1))	sttree[r] = max(sttree[r], value);
		l = (l + 1) / 2;
		r = (r - 1) / 2;
	}
}

int getAns(int i) {
	i += MAX_N;
	int res = 0;
	while (i) {
		res = max(res, sttree[i]);
		i /= 2;
	}
	return res;
}

vector<pair<int, int>> values[MAX_N];

int countCnt(int u) {
	// cout << "countCnt" << u << "\n";
	if (used[u])
		return cnt[u];
	used[u] = 1;
	for (int i = 0; i < 26; ++i) {
		int v = go[u][i];
		if (v == -1)
			continue;
		cnt[u] += countCnt(v);
	}
	if (u != 0) {
		// cout << "on " << u << endl;
		values[len[link[u]] + 1].push_back({len[u], cnt[u]});
		// cout << len[link[u]] + 1 << " " << len[u] << " " << cnt[u] << "\n";
		// maxEquals(len[link[u]] + 1, len[u], cnt[u]);
	}
	return cnt[u];
}

vector<pair<int, int>> answersTree[MAX_TREE];

void buildAnswers(int i = 0, int l = 0, int r = MAX_N) {
	if (l == r - 1) {
		for (auto p : values[l])
			answersTree[i].push_back(p);
		sort(all(answersTree[i]));
		return;
	}
	int mid = (l + r) / 2;
	buildAnswers(2 * i + 1, l, mid);
	buildAnswers(2 * i + 2, mid, r);
	answersTree[i].resize(answersTree[2 * i + 1].size() + answersTree[2 * i + 2].size());
	merge(all(answersTree[2 * i + 1]), all(answersTree[2 * i + 2]), answersTree[i].begin());
}

void setMaxAnswers(int i = 0, int l = 0, int r = MAX_N) {
	for (int j = 1; j < sz(answersTree[i]); ++j)
		answersTree[i][j].y = max(answersTree[i][j].y, answersTree[i][j - 1].y);
	if (l == r - 1)
		return;
	int mid = (l + r) / 2;
	setMaxAnswers(2 * i + 1, l, mid);
	setMaxAnswers(2 * i + 2, mid, r);
}

int getAnswer(int ql, int qr, int q2l, int i = 0, int l = 0, int r = MAX_N) {
	if (r <= ql || qr <= l) {
		return 0;
	}
	if (ql <= l && r <= qr) {
		// cout << l << " " << r << endl;
		auto it = upper_bound(all(answersTree[i]), make_pair(q2l + 1, -1));
		if (it == begin(answersTree[i]))
			return 0;
		return (--it)->y;
	}
	int mid = (l + r) / 2;
	return max(getAnswer(ql, qr, q2l, 2 * i + 1, l, mid), getAnswer(ql, qr, q2l, 2 * i + 2, mid, r));
}

void start(char *w) {
	n = strlen(w);
	for (int i = n; i--; )
		sa.append(w[i]);
	int p = sa.last;
	while (p != -1) {
		cnt[p] = 1;
		p = link[p];
	}
	countCnt(sa.root);
	buildAnswers();
	setMaxAnswers();
}

int round(int k, int m) {
	return getAnswer(0, k, m);
}

#ifdef DEBUG
char __w_gr[5000001];
int main () {
    int q,i,m,k;
    cin >> __w_gr;
    start(__w_gr);
    cin >> q;
    for (i=1; i<=q; i++) {
        cin >> m >> k;
        cout << round(m,k) << endl ;
        }
    return 0;
}
#endif