#include <cstdio>
#include <cassert>
#include <cmath>
#include <climits>
#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <random>

using namespace std;
using ll = long long;
using ld = long double;
#define int ll
#define all(x) x.begin(), x.end()
#define mp make_pair
#define mt make_tuple

const int N = 1e6;
int n;
int m;
set<int> g[N];

int ptr = 0;
pair<int, int> e[N];
vector<int> in[N];
int color[N];
int go[N];
int df[N];
int add[N];

void addedge(int v, int u) {
	assert(v < u);
	assert(!g[v].count(u));
	g[v].insert(u);
	g[u].insert(v);
	e[ptr++] = {v, u};
}

signed main() {
#ifdef LC
	assert(freopen("input.txt", "r", stdin));
#endif
	ios::sync_with_stdio(0);
	cin.tie(0);
	
	cin >> n >> m;
	for (int v, u, i = 0; i < m; ++i) {
		cin >> v >> u;
		--v;
		--u;
		if (v > u) {
			swap(v, u);
		}
		if (u == v + 1) {
			continue;
		}
		addedge(v, u);
	}
	if (!g[0].count(n - 1)) {
		addedge(0, n - 1);
	}
	m = ptr;

	set<pair<int, int>> st;
	//      { v,  ind}
	sort(e, e + m, [&](auto x, auto y) {
		if (x.first != y.first) {
			return x.first < y.first;
		}
		return x.second > y.second;	
	});
	/*
	for (int i = 0; i < m; ++i) {
		cout << e[i].first << " " << e[i].second << endl;
	}
	cout << "---" << endl;
	*/
	for (int i = 0; i < m; ++i) {
		if (st.size()) {
			auto it = st.lower_bound({e[i].second, INT_MIN});
			assert(it != st.end());
			int p = it->second;
			assert(e[p].first <= e[i].first && e[p].second >= e[i].second);
			in[p].push_back(i);
		}
		st.emplace(e[i].second, i);
	}
	
	for (int i = 0; i < n; ++i) {
		go[i] = i;
		df[i] = 0;
	}

	for (int ind = m - 1; ind >= 0; --ind) {
		int l = e[ind].first, r = e[ind].second;
		assert(l < r);
		int delta = 0;

		//cerr << "process " << l << " " << r << endl;
		//for (int i = l; i <= r; ++i) {
		//	cerr << i << "\t" << add[i] << " " << go[i] << " " << df[i] << endl;
		//}
		//cerr << "---" << endl;

		for (int i = l; ; ++i) {
			assert(i <= r);
			//cerr << "\t\ti = " << i << endl;
			if (i > l) {
				//cerr << "add " << endl;
				++add[i];
				++delta;
				delta %= 3;
			}
			if (i == r) {
				break;
			}
			delta += df[i];
			delta %= 3;
			i = go[i];
			if (i == r) {
				break;
			}
		}
		//cerr << "d = " << delta << endl;

		if (delta == 0) {
			assert(go[l] + 1 <= r);
			++add[go[l] + 1];
			++delta;
		}
		df[l] = delta;
		go[l] = r;
	}

	assert(add[0] == 0);
	for (int i = 1; i < n; ++i) {
		color[i] = color[i - 1] + add[i];
		color[i] %= 3;
	}

	for (int v = 0; v < n; ++v) {
		for (int u : g[v]) {
			assert(color[v] != color[u]);
		}
	}

	cout << 3 << "\n";
	for (int i = 0; i < n; ++i) {
		cout << color[i] + 1 << " ";
	}
	cout << "\n";
	return 0;
}
