#include <cstdio>
#include <cassert>
#include <cmath>
#include <climits>
#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <random>
#include <unordered_set>

using namespace std;
#define all(x) x.begin(), x.end()
#define mp make_pair
#define mt make_tuple

const int N = 1e6;
int n;
int m;
unordered_set<int> g[N];
vector<int> t[N];

int ptr = 0;
pair<int, int> e[N];
vector<int> in[N];
int color[N];
int go[N];
int df[N];
int add[N];

void time_assert(bool c) {
	while (!c) {}
}

void addedge(int v, int u) {
	assert(v != u);
	if (v > u) {
		swap(v, u);
	}
	if (g[v].count(u)) {
		return;
	}
	g[v].insert(u);
	g[u].insert(v);
	e[ptr++] = {v, u};
}

void dfs(int v, int c) {
	color[v] = c;
	for (int u : t[v]) {
		if (color[u] == -1) {
			dfs(u, c ^ 1);
		}
	}
}

void check2() {
	fill_n(color, N, -1);
	for (int i = 0; i < n; ++i) {
		if (color[i] == -1) {
			dfs(i, 0);
		}
	}
	for (int i = 0; i < n; ++i) {
		for (int j : t[i]) {
			if (color[i] == color[j]) {
				return;
			}
		}
	}
	cout << 2 << endl;
	for (int i = 0; i < n; ++i) {
		cout << color[i] + 1 << " ";
	}
	cout << endl;
	exit(0);
}

signed main() {
#ifdef LC
	assert(freopen("input.txt", "r", stdin));
#endif
	ios::sync_with_stdio(0);
	cin.tie(0);
	
	cin >> n >> m;
	for (int i = 0; i < n; ++i) {
		g[i].reserve(16);
	}
	for (int v, u, i = 0; i < m; ++i) {
		cin >> v >> u;
		--v;
		--u;
		t[v].push_back(u);
		t[u].push_back(v);
		if (v > u) {
			swap(v, u);
		}
		if (u == v + 1) {
			continue;
		}
		addedge(v, u);
	}
	check2();
	addedge(0, n - 1);
	
	m = ptr;

	set<pair<int, int>> st;
	//      { v,  ind}
	sort(e, e + m, [&](pair<int, int> x, pair<int, int> y) {
		if (x.first != y.first) {
			return x.first < y.first;
		}
		return x.second > y.second;	
	});
	/*
	for (int i = 0; i < m; ++i) {
		cout << e[i].first << " " << e[i].second << endl;
	}
	cout << "---" << endl;
	*/
	for (int i = 0; i < m; ++i) {
		if (st.size()) {
			auto it = st.lower_bound({e[i].second, INT_MIN});
			assert(it != st.end());
			int p = it->second;
			assert(e[p].first <= e[i].first && e[p].second >= e[i].second);
			in[p].push_back(i);
		}
		st.emplace(e[i].second, i);
	}
	
	for (int i = 0; i < n; ++i) {
		go[i] = i;
		df[i] = 0;
	}

	for (int ind = m - 1; ind >= 0; --ind) {
		int l = e[ind].first, r = e[ind].second;
		assert(l < r);
		int delta = 0;
/*
		cerr << "process " << l << " " << r << endl;
		for (int i = l; i <= r; ++i) {
			cerr << i << "\t" << add[i] << " " << go[i] << " " << df[i] << endl;
		}
		cerr << "---" << endl;
*/
		for (int i = l; ; ++i) {
			assert(i <= r);
			//cerr << "\t\ti = " << i << endl;
			if (i > l) {
				//cerr << "add " << endl;
				++add[i];
				++delta;
				delta %= 3;
			}
			if (i == r) {
				break;
			}
			while (go[i] != i && i != r) {
				delta += df[i];
				delta %= 3;
				i = go[i];
			}
			if (i == r) {
				break;
			}
		}
		//cerr << "d = " << delta << endl;
		int v = l;
		while (go[v] != v && v != r) {
			v = go[v];
		}
		if (delta == 0 && v < r) {
			++add[v + 1];
			++delta;
		}
		delta %= 3;
		if (delta == 0) {
			color[l] = 0;
			for (int i = l + 1; i <= r; ++i) {
				color[i] = color[i - 1] + add[i];
				color[i] %= 3;
			}
			/*
			for (int i = l; i <= r; ++i) {
				cerr << color[i] << " ";
			}
			cerr << endl;
			*/
			assert(color[r] == 0);
			int x = color[go[l]];
			if (l == go[l]) {
				x = color[l + 1];
			}
			for (int i = l; i <= go[l]; ++i) {
				if (color[i] != x) {
					color[i] = 3 - color[i] - x;
				}
			}
			/*
			for (int i = l; i <= r; ++i) {
				cerr << color[i] << " ";
			}
			cerr << endl;
			*/
			for (int i = l + 1; i < r; ++i) {
				df[i] = color[go[i]] - color[i];
			}
			df[l] = color[r] - color[l];
			df[l] %= 3;
			assert(df[l] != 0);
			for (int i = l + 1; i <= r; ++i) {
				add[i] = color[i] - color[i - 1];
			}
		} else {
			df[l] = delta;
		}
		go[l] = r;
	}

	color[0] = 0;
	for (int i = 1; i < n; ++i) {
		color[i] = color[i - 1] + add[i];
		color[i] %= 3;
		color[i] += 3;
		color[i] %= 3;
	}

	for (int v = 0; v < n; ++v) {
		for (int u : t[v]) {
			assert(color[v] != color[u]);
		}
	}

	cout << 3 << "\n";
	for (int i = 0; i < n; ++i) {
		cout << color[i] + 1 << " ";
	}
	cout << endl;

	return 0;
}
