#include <cstdio>
#include <cassert>
#include <cmath>
#include <climits>
#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <cstring>
#include <numeric>

using namespace std;
using ll = long long;
using ld = long double;
#define all(x) x.begin(), x.end()
#define mp make_pair
#define mt make_tuple

const int N = 1e6 + 100;
int n;
char s[N];
int sarr[N];
int eq[N];
int buf[N];
vector<int> bucket[N];

int inv[N];
int lcp[N];
int answer[N];
vector<int> scanline[N];

int dsu[N];
int size[N];
int cur;

int get(int x) {
	if (dsu[x] == x) {
		return x;
	}
	return dsu[x] = get(dsu[x]);
}

void umax(int &a, int b) {
	a = max(a, b);	
}

void merge(int x, int y) {
	x = get(x);
	y = get(y);
	if (x == y) {
		return;
	}
	if (size[x] > size[y]) {
		swap(x, y);
	}
	dsu[x] = y;
	size[y] += size[x];
	umax(answer[cur], size[y]);
}

int t[2 * N];

void print() {
	cerr << "sa: " << endl;
	for (int i = 0; i < n; ++i) {
		cerr << sarr[i] << " ";
	}
	cerr << endl;
	cerr << "eq: " << endl;
	for (int i = 0; i < n; ++i) {
		cerr << eq[i] << " ";
	}
	cerr << endl;
}

void start (char input[]) {
	n = (int)strlen(input);
	copy_n(input, n, s);
	reverse(s, s + n);
	s[n++] = '#';
		
	iota(sarr, sarr + n, 0);
	sort(sarr, sarr + n, [&](int i, int j) {
		return s[i] < s[j];
	});
	for (int i = 1; i < n; ++i) {
		eq[sarr[i]] = eq[sarr[i - 1]];
		if (s[sarr[i]] != s[sarr[i - 1]]) {
			++eq[sarr[i]];
		}
	}
	//print();	
	for (int l = 1; l < n; l *= 2) {
		for (int ind = 0; ind < n; ++ind) {
			int se = sarr[ind];
			int fi = (se - l + n) % n;
			bucket[eq[fi]].push_back(fi);
		}
		int ptr = 0;
		for (int i = 0; i <= n; ++i) {
			for (int j : bucket[i]) {
				sarr[ptr++] = j;
			}
			bucket[i].clear();
		}
		assert(ptr == n);
		buf[sarr[0]] = 0;
		for (int i = 1; i < n; ++i) {
			int x = sarr[i], y = sarr[i - 1];
			buf[x] = buf[y];
			if (eq[x] != eq[y] || eq[(x + l) % n] != eq[(y + l) % n]) {
				++buf[x];
			}
		}
		copy_n(buf, n, eq);
	}
	
	//print();
	//for (int i = 0; i < n; ++i) {
	//	cout << s + sarr[i] << endl;
	//}

	for (int i = 0; i < n; ++i) {
		inv[sarr[i]] = i - 1;
	}
	--n;
	for (int i = 0; i < n; ++i) {
		sarr[inv[i]] = i;
	}
	/*
	for (int i = 0; i + 1 < n; ++i) {
		int &l = lcp[i];
	   	int	x = sarr[i];
	   	int	y = sarr[i + 1];
		l = 0;
		while (s[x + l] == s[y + l]) {
			++l;
		}
	}*/
	int k = 0;
	for (int i = 0; i < n; ++i) {
		int pos = inv[i];
		if (pos == n - 1) {
			continue;
		}
		int j = sarr[pos + 1];
		k = max(0, k - 1);
		while (s[i + k] == s[j + k]) {
			++k;
		}
		lcp[pos] = k;
	}

	for (int i = 0; i < n - 1; ++i) {
		scanline[lcp[i]].push_back(i);
	}

	iota(dsu, dsu + n, 0);
	fill_n(size, n, 1);
	
	answer[n] = 1;
	for (int i = n; i >= 0; --i) {
		cur = i;
		for (int j : scanline[i]) {
			merge(j, j + 1);
		}
	}

	copy_n(answer, n + 1, t + N);
	for (int i = N - 1; i >= 0; --i) {
		t[i] = max(t[2 * i], t[2 * i + 1]);
	}
}

int round (int l, int r) {
	int res = 0;
	for (l += N, r += N; l <= r; l /= 2, r /= 2) {
		if (l % 2 == 1) {
			umax(res, t[l++]);
		}
		if (r % 2 == 0) {
			umax(res, t[r--]);
		}
	}
	return res;
}



#ifdef LC
char w_gr[5000001];
int main () {
	assert(freopen("input.txt", "r", stdin));
    int n,q,i,m,k;
	cin >> w_gr;
    start(w_gr);
    cin >> q;
	for (i=1; i<=q; i++) {
    	cin >> m >> k;
        cout << round(m,k) << endl ;
    }
    return 0;
}
#endif
