#include <cstdio>
#include <cassert>
#include <cmath>
#include <climits>
#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>

using namespace std;
using ll = long long;
using ld = long double;
#define int ll
#define all(x) x.begin(), x.end()
#define mp make_pair
#define mt make_tuple

const int N = 1e6;
int n;
int m;
vector<int> g[N];
int hist[N];
int color[N];

void greedy(int v) {
	int &c = color[v];
	c = 0;
	for (int u : g[v]) {
		++hist[color[u]];
	}
	while (hist[c]) {
		++c;
	}
	for (int u : g[v]) {
		--hist[color[u]];
	}
}

signed main() {
#ifdef LC
	assert(freopen("input.txt", "r", stdin));
#endif
	ios::sync_with_stdio(0);
	cin.tie(0);
	
	cin >> n >> m;
	for (int v, u, i = 0; i < m; ++i) {
		cin >> v >> u;
		--v;
		--u;
		g[v].push_back(u);
		g[u].push_back(v);
	}
	fill_n(color, N, -1);
	for (int i = 0; i < n; ++i) {
		greedy(i);
	}
	cout << *max_element(color, color + n) + 1 << "\n";
	for (int i = 0; i < n; ++i) {
		assert(color[i] >= 0);
		cout << color[i] + 1 << " ";
	}
	return 0;
}
