#include <cstdio>
#include <cassert>
#include <cmath>
#include <climits>
#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <random>

using namespace std;
using ll = long long;
using ld = long double;
#define int ll
#define all(x) x.begin(), x.end()
#define mp make_pair
#define mt make_tuple

const int N = 1e6;
int n;
int m;
vector<int> g[N];
int hist[N];
int color[N];

void greedy(int v) {
	int &c = color[v];
	c = 0;
	for (int u : g[v]) {
		++hist[color[u]];
	}
	while (hist[c]) {
		++c;
	}
	for (int u : g[v]) {
		--hist[color[u]];
	}
}

int anscol = 1e9;
int answer[N];

void solve(vector<int> order) {
	fill_n(color, N, -1);
	for (int v : order) {
		greedy(v);
	}
	int cur = *max_element(color, color + n) + 1;
	if (anscol > cur) {
		anscol = cur;
		copy_n(color, n, answer);
	}
}

signed main() {
#ifdef LC
	assert(freopen("input.txt", "r", stdin));
#endif
	ios::sync_with_stdio(0);
	cin.tie(0);
	
	cin >> n >> m;
	for (int v, u, i = 0; i < m; ++i) {
		cin >> v >> u;
		--v;
		--u;
		g[v].push_back(u);
		g[u].push_back(v);
	}
	vector<int> order(n);
	iota(all(order), 0);
	solve(order);
	sort(all(order), [&](int i, int j) {
		return g[i].size() < g[j].size();
	});
	solve(order);
	reverse(all(order));
	solve(order);
	mt19937 rnd;
	while (clock() < 0.3 * CLOCKS_PER_SEC) {
		shuffle(all(order), rnd);
		solve(order);
	}

	cout << anscol << "\n";
	for (int i = 0; i < n; ++i) {
		assert(answer[i] >= 0);
		cout << answer[i] + 1 << " ";
	}
	return 0;
}
