#include <bits/stdc++.h>

using namespace std;

const int N = 3e5 + 7;
vector <int> g[N];
int l[N], r[N], sz[N];
int st[N];

void prepare(int u) {
	sz[u] = 1;
	for (auto v : g[u]) {
		prepare(v);
		sz[u] += sz[v];
	}
	for (int i = 1; i < (int)g[u].size(); ++i) {
		if (sz[g[u][i]] > sz[g[u][0]]) swap(g[u][i], g[u][0]);
	}
}

vector <int> e;

void dfs(int u, int s) {
	st[u] = s;
	e.push_back(u);
	l[u] = (int)e.size() - 1;
	if (!g[u].empty()) {
		dfs(g[u][0], s);
		for (int i = 1; i < (int)g[u].size(); ++i) {
			dfs(g[u][i], g[u][i]);
		}
	}
	r[u] = (int)e.size() - 1;
}

struct fenwick {
	int n;
	vector <int> f;
	fenwick(int nn) {
		n = nn;
		f.resize(n);
	}
	void modify(int i, int val) {
		for (; i < n; i |= i + 1) f[i] += val;
	}
	int get(int r) {
		int res = 0;
		for (; r >= 0; r &= r + 1, --r) {
			res += f[r];
		}
		return res;
	}
	int sum(int l, int r) {
		return get(r) - get(l - 1);
	}
};

bool ok[N];

int main() {
	ios_base::sync_with_stdio(false); cin.tie(0);
	#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	#endif
	int n;
	cin >> n;
	for (int i = 1; i < n; ++i) {
		int p;
		cin >> p;
		--p;
		g[p].push_back(i);
	}
	prepare(0);
	dfs(0, 0);
	fenwick f(n);
	int q;
	cin >> q;
	while (q--) {
		int t;
		cin >> t;
		if (t == 1) {
			int x;
			cin >> x;
			--x;
			if (!ok[x]) {
				ok[x] = 1;
				f.modify(l[x], 1);
			}
		} else if (t == 4) {
			int x;
			cin >> x;
			--x;
			cout << f.sum(l[x], r[x]) << '\n';
		} else {
			assert(false);
		}
	}
}