#include <bits/stdc++.h>

using namespace std;

const int N = 3e5 + 7;
vector <int> g[N];
vector <int> gs[N];

int l[N], r[N], sz[N];
int st[N], en[N];

int self_del[N], del[N], self_add[N], add[N];

int cnt[N]; 
int par[N];
bool hv[N];
int nxt[N];

set <pair <int, int>> who[N];

void prepare(int u) {
	sz[u] = 1;
	for (auto v : g[u]) {
		prepare(v);
		sz[u] += sz[v];
	}
	for (int i = 1; i < (int)g[u].size(); ++i) {
		if (sz[g[u][i]] > sz[g[u][0]]) swap(g[u][i], g[u][0]);
	}
}

vector <int> e;

int dfs(int u, int p, int s) {
	par[u] = p;
	st[u] = s;
	e.push_back(u);
	l[u] = (int)e.size() - 1;
	if (!g[u].empty()) {
		nxt[u] = g[u][0];
		en[u] = dfs(g[u][0], u, s);
		for (int i = 1; i < (int)g[u].size(); ++i) {
			dfs(g[u][i], u, g[u][i]);
		}
	} else {
		en[u] = u;
		nxt[u] = -1;
	}
	r[u] = (int)e.size() - 1;
	return en[u];
}

struct fenwick {
	int n;
	vector <int> f;
	fenwick(int nn) {
		n = nn;
		f.resize(n);
	}
	fenwick() {}
	void init(int nn) {
		n = nn;
		f.resize(n);
	}
	void modify(int i, int val) {
		for (; i < n; i |= i + 1) f[i] += val;
	}
	int get(int r) {
		int res = 0;
		for (; r >= 0; r &= r + 1, --r) {
			res += f[r];
		}
		return res;
	}
	int sum(int l, int r) {
		return get(r) - get(l - 1);
	}
};

fenwick f;

int timer = 0;

bool push(int u) {
	int p = par[u];
	if (p != -1 && st[p] != st[u] && add[p] > del[p] && add[p] > max(self_del[u], del[u]) && add[p] > self_add[u]) return true;
	return false;
}

void setV(int u) {
	++timer;
	if (hv[u]) return;
	hv[u] = true;
	who[st[u]].insert({l[u], u});
	int p = par[u];
	if (push(u)) {
		--cnt[p];
		f.modify(l[p], -1);
	}
	if (p != -1) gs[p].push_back(u);
	f.modify(l[u], 1);
	self_add[u] = timer;
}

void setPush(int v) {
	++timer;
	cnt[v] = max(0, (int)g[v].size() - 1);
	f.modify(l[v], cnt[v]);
	add[v] = timer;
}

int get(int v) {
	int res = f.sum(l[v], r[v]);
	//cout << par[v] << ' ' << add[p] << ' ' << del[p] << ' ' << self_del[u] << ' ' << del[u] << ' ' << self_add[u] << endl;
	if (push(v)) ++res;
	return res;
}

void delV(int v) {
	assert(hv[v]);
	++timer;
	hv[v] = false;
	self_del[v] = timer;
	who[st[v]].erase({l[v], v});
	f.modify(l[v], -1);
}

void seDel(int v) {
	++timer;
	if (hv[v]) delV(v);
	else if (push(v)) {
		int p = par[v];
		--cnt[p];
		f.modify(l[p], -1);
		self_del[v] = timer;
	}
}

void clr(int v) {
	++timer;
	if (add[v] > del[v]) {
		f.modify(l[v], -cnt[v]);
		cnt[v] = 0;
		del[v] = timer;
	}
	for (auto u : gs[v]) {
		if (hv[u]) {
			delV(u);
		}
	}
	gs[v].clear();
	if (push(v)) {
		int p = par[v];
		--cnt[p];
		f.modify(l[p], -1);
		self_del[v] = timer;
	}
	if (hv[v]) {
		delV(v);
	}
}

bool anc(int a, int b) {
	return l[a] <= l[b] && r[b] <= r[a];
}

void clPath(int x) {
	int in = x;
	while (true) {
		int s = st[x];
		bool hvS = false;
		bool fl = false;
		vector <int> gg;
		while (!who[s].empty()) {
			auto pr = *who[s].begin();
			if (anc(pr.second, in)) {
				who[s].erase(who[s].begin());
				gg.push_back(pr.second);
			} else {
				break;
			}
		}
		reverse(gg.begin(), gg.end());
		for (int v : gg) {
			clr(v);
			setPush(v);
			if (v == x) fl = true;
			if (v == s) hvS = true;
		}
		if (!hvS && push(s)) {
			clr(s);
			setPush(s);
			if (s == x) fl = true;
		}
		if (fl && nxt[x] != -1) {
			if (!hv[nxt[x]]) setV(nxt[x]);
		}
		x = par[s];
		if (x == -1) break;
	}
	x = in;
	while (true) {
		int s = st[x];
		seDel(s);
		x = par[s];
		if (x == -1) break;
	}
}

int main() {
	ios_base::sync_with_stdio(false); cin.tie(0);
	#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	#endif
	int n;
	cin >> n;
	for (int i = 1; i < n; ++i) {
		int p;
		cin >> p;
		--p;
		g[p].push_back(i);
	}
	prepare(0);
	dfs(0, -1, 0);
	f.init(n);
	int q;
	cin >> q;
	while (q--) {
		++timer;
		int t;
		cin >> t;
		if (t == 1) {
			int x;
			cin >> x;
			--x;
			setV(x);
		} else if (t == 2) {
			int x;
			cin >> x;
			--x;
			clPath(x);
		} else if (t == 3) {
			int x;
			cin >> x;
			--x;
			clr(x);
		} else {
			int x;
			cin >> x;
			--x;
			cout << get(x) << '\n';
		}
	}
}